#ayudas.pm
# son ayudas para el programador; algunas para dar informacion al programador;
# otras para que sea mas facil programar ayudas para los usuarios

 #    Copyright (c) 2017 Diego.Saravia@gmail.com. All rights reserved.
 #    This program is free software; you can redistribute it and/or
 #    modify it under the same terms as Perl itself.


package Simusol::AyudasPP;
#use warnings;
use strict;
use warnings;
use Data::Dumper;
use version;
our $VERSION='0.01';

$Data::Dumper::Sortkeys = 1;
#our $HOME = $ENV{HOME};

our $marca_Simusol =  "producido por S I M U S O L";
use File::Path;
use File::Basename;
use Cwd; #  'abs_path';
use Getopt::Long;
use File::Spec;
use Pod::Usage;
use Path::Class;

# en ASUS NO ESTA
our $curdirori,
    #our $outdir;

    our $yaesta={};

our $progname; # sacar esto pero en propio protesta    
our %progr;
# 'simplot.pl' => 'p',
#  'simusol' => 0,
#  'simusol1.pl' => 1,
#  'simusol2.pl' => 2,
#  'simusol3.pl' => 3,
#  'simusol_sceptre' => 's'
#  'lolisol_sceptre' => 's'

our @MENSAJES;
our ($avisosgrav,$avisosnograv,$avisosnoseent);
our ($debug, $noverb, $buscar, $imprlog,$noclas);

our $presentacion;

our @extensiones = qw( sim caj d paraplot gra par gnu lsg ls3 log); #son 

# ASUS
our ($ref0,$ref1,$refs,$ref3,$reffff);
our (@opciones, $opciones);
our $todas;

#my           $SALIDAlog;
#my	     $SALIDAls3;

our $SALIDAlog;
#=*STDERR;
#open (OLDER, ">&", \*STDERR) || die "Can't dup stderr";
#close STDERR;
#open (STDERR, ">&", \*OLDER) || die "Can't repoint STDERR";
#close OLDER;
#http://stevesprogramming.blogspot.com.ar/2010/10/perl-writing-stderr-to-variable.html

our %dirsal;

BEGIN {
  use Exporter ();
  our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
  @ISA=qw(Exporter);
  @EXPORT=qw(
             &abrir_escr 
             &abrir_LOGPRIN           
             &abrir_ls3_log
             &avejec
             &avgrav 
             $avisosgrav 
             $avisosnograv 
             $avisosnoseent 
             &avnograv 
             &avnoseent 
             $buscar 
             &cerrar_paren 
             &closelog 
             &comas_invalidas
             &comifin
             $debug 
             &depurar_crudo
             &eco 
             *ESCR
             &existencia
             &explic 
             &hashrenglon 
             &impr 
             &impr_debug 
             &impr_hash
             &imprhash 
	     &imprhashlis
	     &impr_hashlis
             &imprhashrenglon
             &impr_hashrenglon
             $imprlog
             &impr_todo
             &interseccion_conjunto
             &juntar_por_paren 
             &juntar_por_signosf_y_paren
             &juntar_por_signos_y_paren
	     &mensaje 
             &mensajear
             @MENSAJES
             $noverb 
             &paraimpr3puntos 
             &parser
             &particion
	     &pausa 
             &pausadebug 
             &pausaver             
	     %progr 
	     %progr  $imprlog
             $ref0 
             $ref1 
             $ref3 
             $reffff
             $refs 
	     &relativizar
             &resolver_outdir
             &revisar_apareo
             &sacar_paren_ext              
             &simpl_directory  
             &textear_MENSAJES
             &textear_MENSAJES             
             &texto
             &transmitir
             &union_conjunto 
	    );
};
END();



#our (%reservdir,%reservdirg);

#map($reservdir{$_} = 1, values %dirsalida);
#map($dirsalida{".$_"} = $dirsalida{$_},keys %dirsalida);



# PONER TODO ESTO Y PRECEDENCIAS EN our $datosAyudasPP={}
our  $dirsalida = {
    '' => 'cdata',
    '.acs' => 'tmps',
    '.log' => 'results',
    '.caj' => 'tests',
 
    '.dat' => 'cdata',
    '.dirac' => 'tmps',
    '.eps' => 'eps',
    '.for' => 'cfunctions',
    '.f' => 'tmps',
    '.gnu' => 'results',
    # '.gra' => 'scripts',
       '.gra' => 'gra',
    '.ini' => 'tmps',
    '.ls1' => 'tmps',
    '.ls2' => 'tmps',
    '.ls3' => 'tests',
    '.lsg' => 'tests',
    '.par' => 'results',
    '.paraplot' => 'tests',
    '.png' => 'png',
    '.res' => 'results',
#   '.scripts'=>'scripts',  
    '.scripts'=>'scripts',# que no se confunda con scripts de perl??? o si, que se yo
    '.sim' => 'tmps',
    '.simul' => 'results',
    '.txt' => 'cdata',

    '.dia'=>'projects',    # es project y el nombre del proyecto
    '.d' => 'tmps',  # es proyect si no hay un dia 
    '.ds'=>'projects',     	# es proyect si no hay un dia
    '.hashplot'=>'tests',     	# es proyect si no hay un dia
    '.dumb'=>'dumb',     	# es proyect si no hay un dia 
    '.borrar'=>'tests',     # lista de archivos y directorios creados a borrar, nuevos o archivos sobreescritos, solo directorios inexistentes antes
    '.origenes'=>'tests'    # lista de origenes que uso el programa
    };




our $cprojects = 'cprojects'; 
our $cauxes = 'cauxes';
our %dirguardar = ('nada'=>'nothing',
		   'circuitogr'=>'noting',
		   'dibujo'=>'nothing',
		    'circuitogr'=>'nothing',
     'circuito'=>$cprojects,
     'compl'=>$cprojects,
     'complementario'=>$cauxes,
     'modelo'=>'cmodels',
     'elementos'=>'celements',
     'unidades'=>'celements'
    );
#map(do{$_ ne 'nothing' and $reservdirg{$_} = 1},values %dirguardar);

# --------------------------------------------------------------------------- 

sub establecer_outdir{

    my ($odi)=@_;
    
if (not defined $odi){
    $odi='';
} 

my $isab = File::Spec->file_name_is_absolute( $odi);
my @dirs = File::Spec->splitdir($odi);

#print "@dirs\n";
my @ld=();
my $c='';#=$dirs[0];
foreach (@dirs){
    if ($c or $isab){
	$c=File::Spec->catfile($c,$_);
    }else{
        $c=$_
      }	
    push (@ld,$c);
}
#print "AB $isab LLL @ld\n";
my @lll;
if (not $isab){
    @lll = reverse ('.',@ld);
   }else{
    @lll = reverse (@ld);
   }
   
#print "LLL @lll\n";
my $s='';
foreach (@lll){
    $s=$_;
    if (-d $s){
	last;
    }
}
#print "SS $s\n";

if (-W $s){
    #print "Puedo esribir";
    if($s ne $odi){
      #print "Creo $odi a partir de $s\n";
      #system("mkdir -p $odi");
      File::Path::make_path($odi,{});      
      }

    return (1,$odi)
}else{
    die "No se puede escribir en $odi, indique otro outdir";
}


    return (0,'');
}
################################################################
sub archiva{
    my ($file,$DF,$archivos,$elemento)=@_;

    #print "FILE $file - $DF - $elemento\n";
    my $NUEVO;

      my ($archivosim,$dirarchivosim,$bnsim)=Simusol::AyudasPP::resolver_dir($archivos,'simplot','.origenes','');
      Simusol::AyudasPP::creacamino($dirarchivosim,$archivos,$elemento,1);# el uno es no entra a archiva
      

      if ($DF eq 'P'){# nota no existe elemento ni archivos en este memento
	open $NUEVO, ">>simplot.origenes" or die "No puedo crear \n";
	print $NUEVO "#NUEVO PROCESA\n";
	close $NUEVO;

	return;
       }

        my ($archivo,$dirarchivo,$bn)=Simusol::AyudasPP::resolver_dir($archivos,$elemento,'.borrar','');
       Simusol::AyudasPP::creacamino($dirarchivo,$archivos,$elemento,1);# el uno es no entra a archiva    

    
  if ($DF ne 'P'){
 

    if (not exists $yaesta->{$archivo}){
	open $NUEVO, ">>simplot.origenes" or die "No puedo crear \n";
	print $NUEVO $archivo,"\n";
	close $NUEVO;
	$yaesta->{$archivo}=1;
    }




 
    open $NUEVO, ">>$archivo" or die "No puedo crear \n";
    print $NUEVO $file,":",$DF,"\n";
    close $NUEVO;
       }
}


# ---------------------------------------------------------------------------
sub resolver_dir{
  my ($archivos,$elemento,$EXT,$nombre,$seaclas,$nooutdir)=@_; 
  #($curdir,$outdir,$noclas,$baseorigen,$nombreorigen,$EXT,$suprimirbase) = @_;
  
  # los ultimos dos pasan por encima a noclas y a outdir, sirven para encontrar los archivos donde este mas alla de como se
  # quiera que salgan
  
      my $curdir=$archivos->{curdir};
      my $outdir=$archivos->{outdir};

      if ($nooutdir){            # para leer el archivo, igual que seaclas
         $outdir='';
         } 
      #      my $Aoutdir=Cwd::abs_path($outdir);
      #      my $Acurdir=Cwd::abs_path($curdir);

      #      print "AAA O $Aoutdir C $Acurdir\n";

      #  exit;
      my $arc;
      my $nombreorigen;
      my $baseorigen;
      my $CORTO; 
      my $arcext;
      if ($elemento eq 'simplot'){  # ver progname!
            $nombreorigen  ='simplot';  #SOLO
            $baseorigen   ='';  #BASE   
            $CORTO='simplot'.$EXT;
	    $arcext=$EXT;
      }else{
	    $arc=$archivos->{arg}->{$elemento}->{dirs};
	    $nombreorigen  =$arc->[0];  #SOLO
            $baseorigen   =$arc->[1];  #BASE   
            $CORTO  =$arc->[4];  #SOLO
            $arcext=$arc->[3];
            }

  

      my $suprimirbase=$archivos->{sb};
      my $noclas=$archivos->{noclas};
      if ($seaclas){$noclas=0}
  
      
  # si es seaclas, hay que sacar la clase original del argumento
  if ($seaclas){
    my $clasorigen=$dirsalida->{$arcext};
    my $fbo=dir($baseorigen)->basename;
    my $dn='';
    if ($clasorigen eq "$fbo"){
	$dn=dir($baseorigen)->parent;
	$baseorigen="$dn";
        }
    # print "$clasorigen - $baseorigen - $arcext - $fbo - $CORTO\n";
 
  }
  
  #print "PLLLL $CORTO\n";
  if ($CORTO=~/$EXT$/){
      #Se pide la extension del archivo original de los argumentos
      #convocantes, por ello, el camino de respuesta es directamente
      # ese, sea o no noclas
      # podria tambien usarse el criterio si es para leer, pero es mas confuso
      
      #exit;
      #print "EXTENSION IGUAL- LECTURA $CORTO\n";
      return  ($CORTO,$baseorigen,$nombreorigen);
  }
#  exit;
  
  #comifin('comy resolver_outdir de lib/simusol',@_);
  #print "CD $curdir   -> ";
  #printf (" %5s, %2d, %5s, %6s, %6s, %2d  -> ",$outdir,$noclas,$baseorigen,$nombreorigen,$EXT,$suprimirbase);
  my $coderr = '';
  #lo usa desmenuzar_comando
  #sobre la base que curdir NO CAMBIA, no se debe cambiar el curdir, salvo que la rutina
  # que lo haga inmediatamente lo reverse, y no es bueno para reentrancia
  
  # DEPRECADO: de linea de comandos o de directorio actual saca outdir y despues
  # le pone adelante lo que corresponda tomando el path original del archivo de entrada e insertando
  #el outdir
  # NO DEPRECADO, verifica que se pueda escribir ahi, resuelve caso path absoluto. creadir

  

#$grafo '_interact'  + (@listagrafos)  , =(@pedidos_graf, @pedidos_graf_arch) # de paraplot
#my $grafo = lc($grafoori);

# "$outdir$dsls3$basearch$PROPIOSIN   _$grafo .$els3";

#$curdir es el de inicio de ejecucion, NUNCA CAMBIA (expecionalmente por un tiempo, funcion que lo cambia lo debe retrotraer)
#$outdir es lo indicado en ociones, si es relativo se le antepone el $curdir
#$clase depende de la extension
#$variacion es cuando salen muchos archivos, depende de la funcion en particular que lo usa
#$nombreorigen es el nombre sin directorios del archivo
#$baseorigen es el directorio adelante del archivo, 
#   en CLAS con outdir no se usa para nada, salvo para encontrar y leer el archivo
#   si es relativo lo es al curdir, ver RELATIVO
#   si es absoluto ver ABSOLUTO



#CLAS con OUTDIR != CURDIR y (ABSOLUTO o RELATIVO)  
   #$outdir  $clase $nombreorigen  $variacion  $EXT
   #(manda outdir para caso outdir y absoluto), es la unica forma de madar 
   #a un lugar especifico un archivo que esta en cualquier lugar dado
   # se debe definir outdir y especificar archivo en forma absoluta
   # usar en paquete , parado ahi (con baseorigen segun paquete) 
   #o parado por encima (relativo/abs+ segun paquete)
#CLAS con OUTDIR == CURDIR y RELATIVO: 
   #$outdir $baseorigen $clase $nombreorigen  $variacion  $EXT
   #$outdir=''  
#CLAS con OUTDIR == CURDIR y ABSOLUTO:  
   #$baseorigen $clase $nombreorigen  $variacion  $EXT
   #$outdir='' 
#NOCLAS con OUTDIR != CURDIR y ABSOLUTO
   #$outdir  $nombreorigen  $variacion  $EXT
#NOCLAS con OUTDIR != CURDIR y RELATIVO
   #$outdir $baseorigen  $nombreorigen  $variacion  $EXT 
#NOCLAS (== o !=)  RELATIVO
   #$outdir  $baseorigen $nombreorigen  $variacion  $EXT
#NOCLAS con OUTDIR == CURDIR y RELATIVO 
   #$outdir $baseorigen $nombreorigen  $variacion  $EXT 

#if ABSOLUTE, salida absoluta



  
  my $CLAS=$dirsalida->{$EXT};
 
#  print "CCCC $CLAS - $EXT\n";
  #exit;
  if ($noclas){
      $CLAS='';
      }
  if ($suprimirbase){
      $baseorigen='';
      }

  my $absolutobo=0;
  my $absolutoout=0;  
  my $quedaabsoluto=0;  # solo para saber, no se usa
  #my $rootdir = File::Spec->rootdir();
  #my $is_absolute = File::Spec->file_name_is_absolute( $path );
  if (not defined $baseorigen){
      $baseorigen = '';
      }

 
  if (not defined $outdir){
      $outdir = '';
  }else{
       #####($coderr,$outdir) = simpl_directory($outdir); 
      # verificar outdir que no tenga .. u otros problemas
 #             $cpath = File::Spec->canonpath( $path ) ;

      #Note that this does *not* collapse x/../y sections into y. This is by design. If /foo on your system is a symlink to /bar/baz, then /foo/../quux is actually /bar/quux, not /quux as a naive ../-removal would give you. If you want to do this kind of processing, you probably want Cwd 's realpath() function to actually traverse the filesystem cleaning up paths like this.

      
       if(File::Spec->file_name_is_absolute( $outdir )){
         $absolutoout=1;
         $quedaabsoluto=1;
         #if( $outdir eq $curdir){ 
         #es una forma de obligar a usar caminos absolutos, se elimina este
         #tratamiento para el caso
         #	  $absolutoout=0;
         #	  $outdir='';
         #  }
         }	   
  }
 
   if (File::Spec->file_name_is_absolute( $baseorigen )){
	  $absolutobo=1;
          }
  
#       if ($CLAS and $absolutoout){
#           # se ignora base name, manda outdir
# 	   $baseorigen='';
#           }
#       if ($absolutobo and $absolutoout){
#           # se ignora base name, manda outdir
# 	   $baseorigen='';
#           }
         if ($absolutobo and $outdir){
           # se ignora base name, manda outdir
 	   $baseorigen='';
           }
  
   if  ($absolutobo and $baseorigen){
       $quedaabsoluto=1;
   }
  my $camino;

# FALTA ALGO entre ext y nombre


  if($outdir){
      $baseorigen='';
  }

#  if($CLAS){
#      $baseorigen='';
#  }
  
  if ($quedaabsoluto){      
    $camino=File::Spec->catfile('',$outdir,$baseorigen,$CLAS); #,$nombreorigen
  }elsif(not $quedaabsoluto){
    #  print "$outdir\n";
    #	  print "$baseorigen\n";
#      print "CLAS2 $CLAS\n";
      #  print "$nombreorigen.$EXT\n";


      
    $camino=File::Spec->catfile('',$outdir,$baseorigen,$CLAS); #,$nombreorigen
     # print "CAM >$camino<\n";
      $camino=~s/^\///;   # no encontre como hacerlo solo con catfile, si el primero esta vacio
      #  print "CAM >$camino<\n";
  }

#### estudiar esto esta repetido aca y en resolver_dir



#}else{
#    die "No se puede escribir en $camino\n";
  #}

 
  if ($nombre){  # generalmente es append, pero ya viene hecho
      # print "NOMBRE >$nombre<\n";
      $nombreorigen=$nombre;   
      }
  my $salida;
  if ($camino){
       $camino= file($camino);
       $camino->cleanup;
      $salida=File::Spec->catfile($camino,$nombreorigen.$EXT);
  }else{
      $salida=$nombreorigen.$EXT;

  }

  # cleanup
 # print "EXT $salida - $EXT > $camino\n ";
 return ("$salida","$camino","$nombreorigen");
  
  # si se debe usar curdir, porque hay path absolutos, se usa aca
  # si no queda todo relativo a curdir y NO SE USA
  # curdir es siempre absoluto!
  # aqui absoluto se refiere a basename

 
  $coderr and parary(250);
  #$ref->{outdir} = $outdir;
  comifin('finy resolver_outdir',$outdir);
  #return $outdir;
}#resolver_outdir';

##########################################################################################
 sub precedencia{
    my ($l,$re,$precedencia)=@_;
    # refextensiones
    foreach (@$re){
	if (not defined $precedencia->{$_}){
	    die "No esta en precedencia $_, simplot.pl 650\n";
	}
    }
    
    # exit;
      my $listah={};
    my $paralista=[];
    my $otrolista=[];
    my $ordenlista=[];


     my $prece;
    ###  ojo si se quiere ejecutar un predio si se pone como argumento lo hace
    foreach my $elel (@{$l}){
	#print "elel ", Dumper $elel;
	my ($pi,$ba,$ci,$ext,$co,$p,$d,$eo,$clas)=@$elel;
	
	$ci.='||'.$clas;  # ESTO ES PELIGROSO, nombres de archivos puede ser casi cualquier cosa, sacar || del final
	                  # directorios de clases ya son menos probar que no se elijan  con ||
        #print "ELEL  @$elel\n";    
        $prece=10;
        if (defined $precedencia->{$ext}){
           	$prece=$precedencia->{$ext};
	        }
	print "TODAS $co - $ext $prece\n";
        if ($prece == 1){                                            
	    push (@$paralista,$co);
	    #print "PARAPLOT $co - $ext $prece\n";
        }elsif ($prece == 0 or $prece ==10){       # archivos que podrian ser fuente (como los simul), pero que estan contenidos en los paraplot
	                                           # o sea simul o algo desconocido
	        push (@$otrolista,[$ci,$co,$ext]);
	        }


      #  if($prece!=10){     # los que son 1 o (diferentes de 10), tambien tienen que ir los otros
	    my $antprece=$listah->{$ci}->{'dirs'}->[-1];
	   # print "ANTE $antprece  PRECE $prece \n";
           if (not defined $antprece or $prece<$antprece ){
	    # warn "Elegido $ci $prece\n";
	     $listah->{$ci}={'dirs'=>[@$elel,$prece]};
	                                                      # se crea ordenlista, para tener un vector ordenado
	     push(@$ordenlista,$ci);                        # puede haber gra simul caj, etc entonces aparecen dos o mas aca
      # }
	   }
    }

#    print Dumper $listah;
    #exit;
    
    #foreach (@$otrolista){
    #     print "OTROLISTA @$_\n";
    #     }
    #print "PARALISTA=========\n @$paralista\n";
    #	exit;

    foreach my $otro (@$otrolista){
	my $sal='';
        my ($ci,$co,$ext)=@$otro;
        foreach my $para (@$paralista){
	    # no uso basearch por clas
	    my ($n,$d,$e)=fileparse($para,'.paraplot');	    
	    my ($rco)=relativa ($co,$d,1);
	    #print "DIR PARA $d - $para -  grep $rco $para \n";
	    if ($para ne $ci){	     
	      $sal=`grep $rco $para`;
	      #print "NNN $co en  $para --   $ci, $ext - $listah->{$ci}->{dirs}->[-1]\n";
	      if ($sal){
		 #   and $listah->{$ci}->{dirs}->[-1]==10
	         warn "Elimino $ci - $ext dado que $para tiene $co adentro\n";
                 delete $listah->{$ci};
         	 #push(@$borrarlista,$ext);
                 last;  # mejor no circular por los eliminados
                 }
              }
            }
    }

    
#    print "listah ", Dumper $listah;

  #  exit;


    ### se podria ? YA QUE ESTAMOS AVISAMOS DE MALOS PARAPLOT
    # no es muy obvio, pueden no estar detectados algunos, hacer de otra forma en el momento de graficarlos
	 
    return ($ordenlista,$listah);
  }
##########################################################################################
sub eliminaarchivos{
    my ($l,$re,$precedencia)=@_;
   # print Dumper $l;
 
  
   my    ($ordenlista,$listah)=precedencia($l,$re,$precedencia);

    
     # borra todo otro contenido en algun paraplot, no hace falta poner 
    #la extension de otro, pq a esta altura solo hay un archivo con ese nombre

 #  print Dumper $listah;
    
 #     print "KKKKKKKKKKKKKKKKKKKKKKKKKKKKK";
 
#    exit;
    
  #  print "KKKKKKKKKKKKKKKKKKKKKKKKKKKKK";
    # eliminar RERUN
    # para los rerun, si bien, cuando hay paraplot que los contienen ya fueron eliminados antes
    foreach my $ll (keys %$listah){
	my $llsac=$ll;
	$llsac=~s/\|\|([^\|]*)//;
	my $cclas=$1;
	#print "KEYS listah $ll  - $llsac\n";
	if ($llsac=~s/_\d+$// and exists $listah->{$llsac.'||'.$cclas} ){
	    warn "Elimino $ll dado que es otra corrida de $llsac||$cclas\n";
            delete $listah->{$ll.'||'.$cclas};
            }
        }

    #exit;
    my $udol={};
    my $defordenlista=[];
    #print "ordenlista ", Dumper $ordenlista;
    foreach my $ol (@$ordenlista){
	if (defined $listah->{$ol} and not exists $udol->{$ol}){
	    push(@$defordenlista,$ol);
	    $udol->{$ol}=1;
           }
        }
    #print "pl ",  Dumper $paralista;
    #print "ol ",  Dumper $otrolista;
    #print "dol ",  Dumper $defordenlista;
    #print "listah ",  Dumper $listah;
    
    return ($listah,$defordenlista);
}


# ---------------------------------------------------------------------------
sub inicio{
    my ($commlineinfo,$append,$presenta,$archivos)=@_;

    $progname=$commlineinfo->{progname};    
   
    $todas=$commlineinfo->{opciones}->{todas};
    $debug = $commlineinfo->{opciones}->{d};
    $noverb = $commlineinfo->{opciones}->{noverb};
    $curdirori=$archivos->{curdir}; 
   
   
    ($avisosgrav,$avisosnograv,$avisosnoseent)=(0,0,0);    
    my $datestring = localtime();
    #@months = qw( Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec );
    #@days = qw(Sun Mon Tue Wed Thu Fri Sat Sun);
    #($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime();
    #print "$mday $months[$mon] $days[$wday]\n";


   
    $presentacion="*x24 S i m u s o l - $datestring - $presenta";
    
  
 
    #print "PPPP  $progr{$progname}\n";
    #exit;
    
    
    #  print STDERR "                                  Voy a abrir ls3_log\n";
    #$LSS1=abrir_LSS1($arch,$progname,0,$presentacion);

    #      my ($elog,$els3,$PROPIOSIN,$camino) = @_; 
    #  ($SALIDAls3, $SALIDAlog)=abrir_ls3_log($elog,$els3,$archivos,$elemento,$progname);

    ####abrir_ls3_log();

    # nombre del archivo en el que se graban los mensajes, nombre que 
    #identifica a quien llama, 0 sin append 1 con append
   
    #print "Prese $Simusol::Ayudas::presentacion\n";
    #return  ($SALIDAls3, $SALIDAlog);
}

# ---------------------------------------------------------------------------
#sub setsali{#   my ($ls3,$log)=@_;
#  $SALIDAls3=$ls3;
#  $SALIDAlog=$log;   
#}
######################################
sub clas{
    my ($ext,$noclas,$PROPIOSIN)=@_;
    my $CLAS='';
    if (not defined $noclas or not  $noclas){
	$CLAS=$dirsalida->{$ext};		
        if (not defined $CLAS){
		  #warn "Se pide una extension no conocida: $lext con clas\n";
		  # es lo mas normal del mundo que existan archivos de otros proyectos en un directorio
		  $CLAS='DESCO';  # solo para que no proteste en caso de imprimir
        }elsif($CLAS eq 'project'){  # caso ds  d dia
                  $CLAS=file($CLAS,$PROPIOSIN);   # los .d, .ds, .dia en clas projects deben estar en projects/pepe/pepe.ds
		  # si estan en temp o cosas asi, son intermedios y no nos importan aca, buscar
		  # las fuentes 
		  $CLAS="$CLAS";
	          }

	 }

    return ($CLAS);
}

#######################################
       sub baseclas{
		   my ($basearch,$CLAS)=@_;
	        
                  #print "============================\nCLAS $CLAS\n";
		  if ($basearch){
                    my $dir=dir($basearch);
		    my @ldirc=$dir->components;
		    my $sldirc= scalar @ldirc;
		    my $last=$ldirc[-1];
		 
		    #print "LAST LDIRC $last\n";
		    if ($last eq $CLAS){		      
		      #print "SLLLLL $sldirc\n";
		      if ($sldirc == 1 ){
			  $basearch='';
		      }else{
			  $basearch=dir(@ldirc[0..$sldirc-2]);
			  $basearch="$basearch";
			  if ($basearch eq '.'){
			      $basearch='';
			     }
		          }
		      
		      #print "BA $basearch\n";	  
		    }else{
		      #print "CLAS CERO\n";
		      $CLAS='';
		      }
		  }else{
                     $CLAS='';
                      }  
		
		return ($basearch,$CLAS);
}


######################################
 sub prepfile{  
     my ($lista,$EXT,$refextensiones,$otros,$dirsalida,$PROPIOSIN,$refopt_hash,$basearch,$CORTO)=@_;
    #print "RN $CORTO - $EXT - $PROPIOSIN\n";
    my $si=0;
    my $esotra=1;  #si es otra extension (tipo .simul u otras), va 1 al final del array, 
    #para poder buscar adentro de los paraplot, si esta no la lista
     # ext puede ser vacia pero en ese caso no es especial, puedes servir como pseudo simul

   #  print "REXT @$refextensiones\n";
    foreach my $EXTO (@$refextensiones){	  
	  if ($EXT eq $EXTO){  # no es necesario el if $EXT ya que no hay vacio en refextensions
	      $si=1;
	      $esotra=0;
	      #print "SI $EXT\n";
	    }
         }
      if ($otros){   # OTROS es permitir otras extensiones, esta en 1
  	   $si=1;
           }

     my $ECORTO;
      my @lexte=('',@$refextensiones);
      # probamos primero si hay vacio
      # ojo puede haber simul en el mismo que paraplot (tests) o en (results)
    
	    # pero aca no buscamos archivos fuera de su lugar
    if ($EXT){   # si el archivo tiene extension usa SOLO ESA
	@lexte=($EXT);
	$CORTO=~s/$EXT$//;   ########## HORRIBLE
    }else{

    }
		


	    ### revisar esto hasta el proximo ### meter en subrutina
     foreach my $lext (@lexte){
	       $ECORTO=$CORTO.$lext;
	       # print "LEXT   $CORTO    $lext\n";
               my ($CLAS)=clas($lext,$refopt_hash->{noclas});	
               if ($CLAS){
		 ($basearch,$CLAS)=baseclas($basearch,$CLAS,$PROPIOSIN); # PROPIOSIN caso project
	         }
		   
# CORTO ES EL NOMBRE REAL DONDE ESTA EL ORIGEN; DEBE EXISTIR COMO ARCHIVO, include obviamente la clase origen, sea que tengamos clas o no clas

# CORTOSIN 
# lleve o no una clase  si cambia la extension cambia la clase
	      # sin embargo TIENE SENTIDO y va sin clase
              # VEAMOS ESTO
	      # 1) DIRARCH / NOMBRE
	      # 2) DIRARCH / CLAS / NOMBRE
	      # DIRARCH / NOMBRE (1) es la KEY de los ORIGENES, aunque luego se forme como 2) , 
              #salvo noclas, no se puede usar directamente para leer o escribir nada

#DIRARCH es el $indir  por defecto, si no se lo cambia en una opcion	 
   
      #SOLO      #BASE     #BASE+SOLO #EXT  #BASE+SOLO+EXT #NOMBRE+EXT      
      #[$PROPIOSIN,$basearch,$CORTOM,   $EXTO,$CORTO,        $PROPIO,    $DATE,0];
      #   my $PROPIOSIN  =$arc->[0];  #SOLO   
      #   my $CORTOSIN   =$arc->[2];  #BASE+SOLO  solo se usa de key para hash 
                                      #cada extension resultara en BASE+CLAS+SOLO, con CLAS DISTINTA
      #   my $BASEARCH   =$arc->[1];  #BASE   
      #   my $EXT        =$arc->[3];       
      #   my $CORTO      =$arc->[4];  #BASE+CLAS+SOLO+EXT  solo se usa como fuente del archivo ORIGEN
      #   my $PROPIO     =$arc->[5];  #SOLO+EXT
      #   my $CLAS       =$arc->[7];  #CLAS
      #   my $ESTIPOSIMUL=$arc->[8];
  
      #   my $PROPIOASIN= Simusol::AyudasPP::simpl_archivo($PROPIOSIN);  
      #   A es ABSOLUTO  es sin /../  buscar modulo perl que lo haga
      #
      
	      # la pregunta a definir es cuando se pone en linea de comandos  DIRARCH/NOMBRE.EXT y rige CLAS
	      # si no rige CLAS, CLAS es parte de DIRARCH y no hay problema
	      # esto resulta en DIRARCH/NOMBRE.EXT o en DIRARCH/CLAS/NOMBRE.EXT ????
	      # a los efectos de que siempre se puede decir en linea de comandos el nombre exacto de algo
	      # supongamos que existen los dos archivos DIRARCH/NOMBRE.EXT y DIRARCH/CLAS/NOMBRE.EXT
	      # ambos tienen el mismo HASH, cual se elimina?
	      # PRECEDE LA REGLA DE QUE SI SE ESCRIBE en linea de comandos un archivo que existe 
              # SE USA ESTRICTAMENTE ESE
              # QUE PASA SI EN LA LINEA DE COMANDOS SE PONEN AMBOS?????
	      # HAY QUE AGREGAR ALGO AL KEY DEL HASH   se agrega la clase |$CLAS 
	      # si hay clas es porque rige clas.



	     

		
	      # parea leer se pone clas (en realidad la direccion tal cual fue encontrado), para escribir no pq cambia
	      # es necesario esta file porque si el primer argumento de file es vacio lo toma como absoluto
		
		my $CORTOSIN=$PROPIOSIN;;
		if ($basearch){    		
		    $CORTOSIN =file($basearch,$PROPIOSIN);
		    }
	
          #print "SI $si - $otros - $esotra  EXT>$lext<  CLAS $CLAS BASEARCH $basearch CORTO $CORTO INDICE: $CORTOSIN \n";
          #if ($CORTO){ print "ES STRING\n"}
          #if (not -d "$CORTO"){ print "NO ES DIR\n"}
	  #if (-e "$CORTO"){print "E CORTO $CORTO\n"}
	 #if ($si){ print "SI\n";}

               #print "ECORTO $ECORTO - $basearch - $CORTOSIN (2)\n";
               if ($ECORTO and not -d $ECORTO  and -e $ECORTO and $si){
                    #print "EXISTE ECORTO $ECORTO \n";
		    my $DATE = scalar localtime ((stat $ECORTO)[9]);
		    # CORTO ES DONDE ESTA PARA LEER, el resto es para consstruir otros
		    # en comillas pq file crea objeto, las comillas lo stringnifican
		    #despues  $esotra, dos uno no se porque
		    #
		    #,1,1,$CLAS]);
		    push (@{$lista},[$PROPIOSIN,$basearch,"$CORTOSIN",$lext,$ECORTO, $PROPIOSIN.$lext,$DATE,$esotra,$CLAS]);
		    #red($arg,$refd->{lista},$PROPIOSIN,$basearch,$EXT,$refextensiones,$otros);
		    # ya no usa mas red
	            }
	     
                     #print Dumper $lista;
 
	    }
        
                # si no tiene extension la busca
	    #  red($arg,$lista,$PROPIOSIN,$basearch,$EXT,$refextensiones,$otros);
	  }

# ---------------------------------------------------------------------------
### la subrutina necesita;
### use File::Basename;
### use Cwd;
### use Getopt::Long;
################
sub isEmpty {
 opendir(DIR,shift) or die $!;
 my @files = grep { !m/\A\.{1,2}\Z/} readdir(DIR);
 closedir(DIR);
 @files ? 0 : 1;
}
#######################################
sub cleanfunc{
     my ($archivos)=@_;
     my $fls;
     my $ols;

     # uisar unlink;!!!!
     # comentar los print borrar
          my ($archivo,$dirarchivo,$bn)=Simusol::AyudasPP::resolver_dir($archivos,'simplot','.origenes','');
	
	  my $ok=  open (my $ENTRADA,  $archivo) ;
          if (not $ok) {                                        # REVISAR
              warn "No existe el archivo $archivo";
          }else{
              #Simusol::AyudasPP::parar3(12,"No existe el archivo $archpar dir:$DIRC");
              @$ols = <$ENTRADA>;
              close $ENTRADA;
	          

              foreach my $borrar (@$ols){
		  ###print "MMMMMMMMMMM $borrar\n";
		  chomp $borrar;
		  if (not $borrar=~/^#/ and -e $borrar){ # un archivo puese estar repetido simplot.borrar p ej
		                                         # y ya fue eliminado
	         my $ok=  open(  my $ENTRADA,  $borrar) ;
                 if (not $ok) {                                        # REVISAR
                    warn "No existe el archivo $borrar";
                 }else{
                    #Simusol::AyudasPP::parar3(12,"No existe el archivo $archpar dir:$DIRC");
                    @$fls = <$ENTRADA>;
                    close $ENTRADA;
		    print "BORRAborrar $borrar\n";  
 	            system("rm $borrar");
	            }
	          }
	      
                 foreach (@$fls){
	           chomp $_;
                   if (not $_=~/^#/){
	           my ($file,$f)=split(/:/,$_);	     
	             if ($f eq 'F'){
		       if (-e $file){                # estimo que es por append en algunos lugares que guarda varias veces el archivo
		          # poner hash en archiva y poner rm -NOPROTESTA, o usar funcion de perl unli
                          print "BORRA: $file : F\n";
 	                  system("rm $file");
		          }
	                }
		     }
	           }
	           # ANOTAR DIRECTORIOS DE BORRADOS y si estan vacios BORRAR
                   # luego de borrar todos los file si se puede se borran dir, estos solo se anotan si efectivamente se crearon , es decir si estaban no vana .borrar
                   foreach (@$fls){
	               chomp $_;	   
                       if (not $_=~/^#/){ 
	                 my ($file,$f)=split(/:/,$_);
     	                 if ($f eq 'D'){
                            # system("rmdir $file");   # esto esta mal rm -rf ****
	                    # poner para borrar solo si efectivamente lo crea no si ya estaba
	                    # y si no hay nada mas ahi
	                    # estudiar muy bien esto, sacar primero todos los archivos F de borrar si esta vacio entoinces eliminar   		  
 		            if (-e $file and -d $file  and isEmpty($file)){
	                       print "BORRADIR: $file : D\n";
		               system("rmdir $file");
		               }
                            }
                         }
	              }
	      }
	      print "BORRA ORIGENES $archivo\n";
 	      system("rm $archivo");
	  }
      }

      

# ---------------------------------------------------------------------------
sub desmenuzar_comando{# devuelve toda la informacion en hashes $refopt_hash y $ref
  #print STDERR ".....  comy desmenuzar_commando(@_)\n";
    
  my ($otros) = @_; # es permitir otras extensiones esta en 1

 # my $precedencia={  '.simul'=>0,   # cambiar 0 por 1,
 #                    '.paraplot'=>1,                     # tiene que ser paraplot porque en elimina archivo los identifica asi
 #                    '.ds'=>2,
 #                    '.caj'=>3,
 #                    '.hashplot'=>3,#
#	             '.gra'=>4		            ############ poner ejecutar_graf en simplot.pl
#  };


  my $precedencia={  '.hashplot'=>0,    # estos son los producidos por simusol1
                     '.paraplot'=>1,    # estos a veces lo producen (1 es siempre paraplot
                     '.gra'=>2,         # producidos a veces por simplot
                     '.ds'=>3,          # producidos por siru
	             '.caj'=>4,         # por simusol1
                     '.simul'=>5	# por muchos
  };

#  cualquiera es 10

  my $refextensiones = [keys %$precedencia];

  my $archivos={};
  
  #qw( d help version noclas noverb nokill graf=s );
  my $refopciones = ['help','d','version','noverb','noclas',
		      'todas=s','graf=s','kill','nokill','path=s','i',
                       'impr','buscar','notrad','comp','outdir=s','scp','ncp','ncgf',
                       'backup','path','patronno','patronsi','elementos','modelos',
                       'comocopia','talcual','cadena','sb','nofiles','clean','cleangeneraldep','cleangeneral'
                       ];

         

  #sb es para no tener en cuenta el basearg de un argumento
  #scp es para solo crear paraplot (simusol1)  ojo si esta activada ncp no sirve para nada, y termina sin hacer nada  
  #ncgf no crea graphic files
  #ncp no crea paraplot, si bien lo calcula para su grafico
  # path es para elegir_archivo
  # impr genera archivos png con los dia
  # buscar es junto para path, usa find
  # notrad es para simusol, no llama a simusol1
  # comp es para comparar original con backup de todos los archivos producidos en una corrida con la anterior
  # pueden ser muchos con numero los producidos, compara el ultimo con el anterior, los dos ultimos
  # d pone el $debug=1
  # noverb es un nivel de debug menor al normal
  # noclas pone los archivos en el directorio corriente 
  # toda cambia las variables de salida, las pone a todas que empiecen con las letras que se indiquen, se pueden poner varios toda
  # graf que tipo de graficos se necesita, con 
     #0 no llama a simusol3,  
     #1 hace graficos interactivos, 
     #3 el normal
     #4 no hace graficos pero hace los png
     #5 o chicos hace graficos para dos columnas, con letras mas grandes


#sgp es solo para graficar (simusol3), se saca, si se quiere eso, poner .paraplot en linea de comando, ya no tien4e sentido esta opcion
  
  my $refopt_hash={};
  
  $refopt_hash->{d}=0;
  $refopt_hash->{sb}=0;
  # hacer para todos asi no queda indefindo y causa lio
  
  #  my $ref={};
  #my $dirsalida={};
  # pretendo obligatorios y 'buenos'  los 5 argumentos de esta subrutina; pero 
  #   no recuerdo como se indica esto.
  # $refopciones: referencia a array con todas las opciones que interesan y 
  #   calificadas para GetOpt 
  # $refextensiones: referencia a array de extensiones para argumentos que inter.
  #NO $default_ext: extension para completar nombre de argumento; scalar sin '\'s

  # los argumentos pueden venir sin su extension; se refiere  parte final del
  #   nombre completo ( sin '\'s
  
  my($progname,$progpath) = fileparse($0);
  my $progdate = scalar localtime((stat "$progpath$progname")[9]);
  my $curdirori = getcwd; 
  $curdirori .= '/';

  ############### OJO SACAR LA BARRA FINAL  
  # @{$ref}{'progname','progpath','progdate','curdirori'} = ($progname,$progpath,$progdate,$curdirori);

  GetOptions($refopt_hash,@$refopciones)  or pod2usage(2);

  if (defined $refopt_hash->{help}){      
      main::help($progname);
      exit 0;
      }

  if (defined $refopt_hash->{version}){
      main::version($progname) ;
      exit 0;
  }

  if (defined $refopt_hash->{clean}){
	  #print "No instrumentado clean";
	  #cat simplot.borrar| sed s/:.*$//| sed s/^[^\.]*\.//|sort -u
          #gnu #gra  #log  #ls1    #ls3
          #rm: no se puede borrar 'test30/tests/tanque.ls3': No existe el archivo o el directorio
          #BORRA: test30/results/tanque.log:F
          #rm: no se puede borrar 'test30/results/tanque.log': No existe el archivo o el directorio

      cleanfunc({});
 
          exit 0;
          }

    if (defined $refopt_hash->{cleangeneraldep}){
      	print "No instrumentado cleandep";
	# lo que viene pero recursivo!!!
#

         my @ext=('.gnu','.gra','.log','.ls1','.ls3');
	 #sacar log , cambiar de nombre
	  
	 foreach(@ext){	      
	      print "BORRA RECURSIVAMENTE con extensión: $_\n";
              system("find . -name \"*$_\" -type f -delete");	      
	      }

	 foreach('.eps','.png','.dumb'){	      
	      print "BORRA RECURSIVAMENTE con _graf?? y extensión: $_\n";
              system("find . -name \"*_graf*$_\" -type f -delete");	      
	      }


      exit 0;
      }

      if (defined $refopt_hash->{cleangeneral}){
	  # borra todos los archivos del tipo que solo son producidos por el simplot

#	  .gra
#	      .gnu#
#	      .ls3
#	      #log???
#	      .ls1
#.paraplot
	  my @ext=('.gnu','.gra','.log','.ls1','.ls3','.eps','.png','.dumb');
	  #sacar log , cambiar de nombre
	  
	  foreach(@ext){
	      my $dd=$dirsalida->{$_};
	      my $file;
	      if (defined $refopt_hash->{noclas}){
                  $file="*".$_;
	      }else{
		  $file=file($dd,"*".$_);
	      }
	      #print "MMM $_, $dirsalida->{$_} , $file\n";
	      print "BORRA: $file\n";
              system("rm $file");	      
	      }
	  
      exit 0;
      }


  

  
  #if ( not defined $opt_hash{graf}){
  #      $opt_hash{graf}="3"
  #};  
  defined $refopt_hash->{graf} and $refopt_hash->{graf} =~ /^chic/i 
    and $refopt_hash->{graf} = 5;
  if (not $refopt_hash->{graf}) {
      $refopt_hash->{graf} = 3;
  } elsif ($refopt_hash->{graf} =~ /\D/) {
      die "Opción para -graf $refopt_hash->{graf} irreconocible\n";
  };

  if (defined $refopt_hash->{i} and $refopt_hash->{i}) {   # es mandatoria, o sea, sea cual sera graf si es -i entonces graf es 1
      $refopt_hash->{graf}=1;
      }

  if ($refopt_hash->{graf} eq '0' or $refopt_hash->{graf} == 0){
	  warn "No pidio graficar nada o pidio no graficar, igual puedo hacer paraplots";
          }
  # --------------------------------------------------------------------------
  # --------------------------------------------------------------------------
  #warn ".....  com3 interpretar_opciones_3($ref1)" if $refopt_hash->{d};


  ################ SACAR
  #$outdir=Simusol::AyudasPP::resolver_outdir($curdirori,$refopt_hash->{outdir});
  my $ok;
  my $outdir=$refopt_hash->{outdir};
  if (not $outdir){$outdir='';}
  ($ok,$outdir)=establecer_outdir($outdir);
  #print "OUTDIR $outdir\n";
  
  # en realidad no sale, si hay error muere en la rutina, cambiar que solo muiera en pgrama principal

#  resolver_outdir($ref1,$opt_hash{outdir}); ######## RESOLVER
 
#  $debug = $refopt_hash->{d}; #$debug está definida con our en Ayudas.pm


  #sale tambien en ref, pero como se lo llama aca no.

  #outdir es global y se setea en inicio tambien
  #calcular_dirsal();
  # esto parece reemplazar disal
#  if ($refopt_hash->{noclas}) {
#      foreach my $key (keys %$dirsalida) {
#          substr($dirsalida->{$key},0,1) ne 'c' and $dirsalida->{$key} = '';
#          };
#      };

  $noclas = $refopt_hash->{noclas};
  
  #my $ref3 = {'curdirori' => $curdirori};
  #($coderr,$mensaje) = Simusol::AuxiliaresPP::atender_argumentos($ref3);
  #$coderr and Simusol::PlotGNU::parar3($coderr,$mensaje);
  #impr_todo(__LINE__.' sims',$ref3);
 

  my $commlineinfo;
  # para que funcione bien progr{} se saca .pl si lo tiene en este caso
  # habitualmente se ejecuta sin pl, pero a veces ....
  # tests corregido, en scripts estan los dos con y sin pl, lo hace el make
  $progname=~s/\.pl$//;
  $commlineinfo->{progname}=$progname;
  $commlineinfo->{progpath}=$progpath;
  $commlineinfo->{progdate}=$progdate;
  $commlineinfo->{cantarg}=0;
  $commlineinfo->{opciones}=$refopt_hash;
      


 if (defined $refopt_hash->{kill}){
   return ($commlineinfo,{});      
   }
  if (defined $refopt_hash->{nofiles}){
   return ($commlineinfo,{});      
   #return 0;
   }
  
  # @{$ref->{argumentos}} = @ARGV;
  my $argumentos;
  @{$argumentos}=@ARGV;
  my $cantarg=scalar  @ARGV;
#  @{$ref->{opciones}} = keys %$refopt_hash;


  # OJO si se introduce un directorio vacio en los argumentos, buscar archivos ahi adentro, asi como se hace sin argumentos sobre el corriente

  #Y en todos los directorios abajo que contengan directorios del tipo clas, buscar antes los archivos del tipo clas

  #my $listadirs=['.'];
  my $listadirs=[]; 
  # si se introducen dirs se busca ahi aunque hayan mas archivos en argumentos
 # my $sibusca=0;


  #CURDIR  desde donde se lo llama
  # Si no los especifica INDIR OUTDIR WORKDIR son CURDIR
  # si no especifica WORKDIR es OUTDIR

  # sino hay EXT especificada elige la mejor

############################### que pasa si tanque es un archivo tanque.dia 
#######################y ademas un directorio tanque????? poner barra al fin para dir?
  # REVISAR
  
  # pueden llegar:
  # DIR
  #             busca todas las extensiones conocidas abajo de dir
  # DIRARCH/CLASE/ARCHIVO.EXT    clase puede no estar, ext puede no estar
  #        Hay directorio, busca en noclas: DIR y luego DIR/CLASS el archivo
  #                        busca en clas:  DIR/CLAS y luego DIR el archivo

# SI HAY CLASE BUSCA EN CLASE
  
  # ARCHIVO.EXT                  ext puede no estar
  #        No hay directorio, busca en noclas: INDIR y luego INDIR/CLASS el archivo
  #                              busca en clas:  INDIR/CLAS y luego INDIR el archivo
  
  #INDIR   desde donde hace base para leer
  #OUTDIR  desde donde hace base para escribir
  #WORDIR  Donde escribe temporarios

############# OJO ELIMINAR FUENTES DE DIFERENTES CLAS con extensiones diferentes, obviamente .....

  
#  my $refd = {}; 
#  $ref->{dirarray} = $refd;
#$refd->{lista}=[];
 
  my $lista=[];
  foreach my $arg (@ARGV) {
            my ($PROPIOSIN,$basearch,$EXT) = fileparse($arg,@$refextensiones,'\.[^\.]*');
	    $basearch=~s/^\.\///;
            #warn "ARCHIVOX $basearch $PROPIOSIN $EXT \n";
            if (-d $arg)    {
	       #print "$arg es un directorio\n";
	       my ($ok,$file)=buscafiles($arg,$refextensiones, $refopt_hash,$progname);
	       push (@$listadirs,[$file,$arg]);
	       #$sibusca=1;
	    }else{
		#print "ARG $arg\n";
		prepfile($lista,$EXT,$refextensiones,$otros,$dirsalida,$PROPIOSIN,$refopt_hash,$basearch,$arg);	  
	        }	    
            }

 
     #   if (scalar @{$refd->{lista}} <1 or $sibusca){  # NO ES SI NO ENCUENTRA, ES SI NO HAY ARGUMENTOS
  
  if (not scalar @ARGV){
       #print "$curdirori, $progname ", Dumper $refextensiones, $refopt_hash;
       my ($ok,$file)=buscafiles($curdirori,$refextensiones, $refopt_hash,$progname);
       #print "file ",  Dumper $file;
       #exit;
       # revisar, no siempre existe los de file
       push (@$listadirs,[$file,'']);
  }


 

  #exit;
  #print Dumper $lista;
  
  foreach my $mm (@$listadirs) {
   
           my $pdir=$mm->[1];
           my $lf=$mm->[0];
	   foreach my $args (@$lf){	       
               print "KKKKKKKKKK @$args - $pdir \n";
	       my ($PROPIOSIN ,$basearch,$EXT,$FF)=@$args;
	       $basearch=~s/^\.\///;
	        print "PS $PROPIOSIN , PDOR $pdir, BA $basearch, EXT $EXT, CORTO $FF\n";
	        if ($pdir){
		    $basearch=file($pdir,$basearch);
		    $FF=file($pdir,$FF);
		}
	        print "CORTO $FF (1)\n";
        	prepfile($lista,$EXT,$refextensiones,$otros,$dirsalida,$PROPIOSIN,$refopt_hash,"$basearch","$FF");	      
	        }
           }

  ###exit;
  
#print Dumper $lista;

 # exit;
  
 # print "XXXX\n";
 
  
  if (scalar @{$lista} < 1 ){
      warn "No hay archivos para procesar\n";  # si es debug sacar el \n
      # no salgo porque hay otras cosas para hacer como kill
      }

  #print STDERR Dumper $ref;
  #print STDERR ".....  finy desmenuzar_commando()\n";


  if (not defined $refopt_hash->{noclas}){
    $refopt_hash->{noclas}=0;
    }


  my ($la,$argu)=Simusol::AyudasPP::eliminaarchivos($lista,$refextensiones,$precedencia);

#print Dumper $lista;
  
  #print Dumper $la;
  #print "ARGU @$argu\n";
  #exit;
  
  $archivos->{arg}=$la;
  $archivos->{noclas}=$refopt_hash->{noclas};
  $archivos->{outdir}=$outdir;
  $archivos->{curdir}=$curdirori;
$archivos->{argumentos}=$argu;  #lista ordenada
$archivos->{sb}=$refopt_hash->{sb};
$archivos->{extensiones}=$refextensiones;    # estas son las extensiones, solo para pasar su valor, 
#pero no debiera estar aca, es dato producido directamente de dato estatico
 #$archivos->{dirclas}=$dirsalida;   # son datos estaticos del programa no van aca


  #print Dumper $archivos;
  #print Dumper $la;
  #  print Dumper $argu;
  


 

      
  return ($commlineinfo,$archivos);
}#desmenuzar_comando  

#	    my $PROPIO=$PROPIOSIN . $EXT;
#            my $CORTO;#
#	    if ($pdir){
#		$basearch=file($pdir,$basearch);
#	        }
#	    if ($basearch){
#		 $CORTO =  file($basearch , $PROPIOSIN . $EXT);
#	    }else{
#	         $CORTO=$PROPIO;
#	         }
#   if (-e $CORTO){  # ojo vimos que aparecian de siru archivos como los paraplot en files que no estaban
 #      	       #printf ("ARCHIVO:  %20s  - %12s  | %10s |%10s\n",$PROPIOSIN,$EXT,$pdir,$CORTO);
#	       my $DATE  = scalar localtime ((stat "$CORTO")[9]);
#	       
 #            # CORTO ES DONDE ESTA PARA LEER, el resto es para consstruir otros                      
  #	     push @{$lista}, [$PROPIOSIN,$basearch,$basearch.$PROPIOSIN,$EXT,"$CORTO",$PROPIO,$DATE,0,1,1];
#	     # 0 es otro ver si va 0 o uno
#	     }
######################################################################

sub red{
    my ($arg,$lista,$PROPIOSIN,$basearch,$EXT,$refextensiones,$otros)=@_;

   # print "MMMM $arg $EXT\n";
    # si existe  arg, lo usa y ya, inclusive si su extension es cualquiera o nula por archivos tipo
    # datos con cualquier extension
    my $PROPIO='';
    my $DATE='';
    my $CORTO='';
  
    # MAL
    if ($arg and -e $arg and 1){
    	my $esotra=0;

	
	$DATE = scalar localtime ((stat $arg)[9]);
	$PROPIO=$PROPIOSIN . $EXT;
        my $CORTOSIN =  file($basearch, $PROPIOSIN);  # ES LO MISMO QUE ARG si es que arg esta

	#print "MMMMMMMMMM $basearch - $PROPIOSIN - $CORTOSIN\n ";
	$CORTO=$CORTOSIN.$EXT;
        push @{$lista}, [$PROPIOSIN,$basearch,"$CORTOSIN",$EXT,$CORTO,$PROPIO,$DATE,$esotra];
	 #SOLO      #BASE     #BASE+SOLO #EXT  #BASE+SOLO+EXT #NOMBRE+EXT      
         #[$PROPIOSIN,$basearch,$CORTOSIN,   $EXTO,$CORTO,        $PROPIO,    $DATE,0];
	return;
    }
    #  si no es archivo y si no tiene extension pruebo con todas las extensiones por default

    # USAR JOINDIR!
    
    
    if (not $EXT){
	  foreach my $EXTO (@$refextensiones){
           # $CORTO =  
	    my $CORTOSIN =  file($basearch, $PROPIOSIN);  # ES LO MISMO QUE ARG si es que arg esta
	    $CORTO=$CORTOSIN.$EXTO;
            if (-e $CORTO) {            
               $PROPIO=$PROPIOSIN . $EXTO;
               $DATE = scalar localtime ((stat $CORTO)[9]);
#                            propiosin basearch  cortosin            ext   corto  propio  date
	       push @{$lista}, [$PROPIOSIN,$basearch,"$CORTOSIN",$EXTO,$CORTO,$PROPIO,$DATE,0];
	       }           	  
	  }
	 
    }else{
	warn "No encontro el archivo $arg\n";
    }

    #      
}

###################################################################

use File::Find;
use Cwd qw(cwd);
# for example let location be tmp



my @fil=();
our $location=cwd();
our $refexten;
################################################################################################
sub find_txt {
    my $F = $File::Find::name;
    # my $FF=$F;
    my $FF =  File::Spec->abs2rel($_, $location);
    
    #print "File $FF\n";
    my ($n,$d,$e)=fileparse($FF,@$refexten);
    #foreach my $EXT (@$refexten){   ################### GLOBAL
    #print "MMM $EXT\n";
    if ($e) {
	 #   $FF=~s/^\.\///;
         #   #print "$FF\n";
         push(@fil,[$n,$d,$e,$FF]);
	 # solo encuentra la correcta
         }
}

######################################################################

sub buscafiles{
    my ($dir, $refext, $refopt_hash,$progname)=@_;
    

    my @files;
    my $ok=0;
    my $nea;
    my $ee;
    #   if (not scalar  @files){
    $refexten=$refext;
    if ($dir){
	$location=$dir;
    }

    #cwd will return the symbolic link (the logical path to where we are) 
    #getcwd will resolve the symbolic link and return the real directory (the hard link) of where we are. 
    find({ wanted => \&find_txt, no_chdir=>1}, $location);
    #print "FIL @fil\n";
    foreach (@fil){
           my ($n,$d,$e,$FF)=@$_; #se podria no usar y separar con la exp regular y el filefind
           #print "NEA $_->[0],$_->[1] - $d - $n - $e\n";
           push (@files ,[$n,$d,$e,$FF]);
           }
    
   # print "MMMMMMMMMMMMMMMMMMMMMMMMM  \n";
    
    #foreach my $ee (@$EXT){	
    #   my $eee=$ee;
    #   $eee=~s/^\.//; 
    #   ($ok,$nea) = Simusol::AuxiliaresPP::elegir_archivos($eee, $refopt_hash,$progname);
    #   #print "BUSCA $ee @$nea\n";    
    #   foreach (@$nea){
    #       my ($n,$d,$e)=fileparse($_,$ee);
    #       print "NEA $_ - $n - $ee\n";
    #       push (@files ,[$n,$d,$e]);
    #       }
    #   }    
return (1,[@files]);

}   

# -------------------------------------------------------------------------
sub relativizar{
    

    # deprecado
   
 
  comifin('comy relativizar',@_);
  #se espera nombre completo para $pwd, con su barra final;
  my ($archivo,$pwdreal) = @_;
  $archivo = "$pwdreal$archivo" if $archivo !~ /^\//;
  my $POSABSOLUTO = simpl_archivo($archivo);
  impr_debug(__LINE__.' Ayud $archivo,$POSABSOLUTO',[$archivo,$POSABSOLUTO]); 
  $pwdreal =~ /^\/.+\/$/ or die "ERROR de programa ".__LINE__." Ayud\n";
  my ($BASEARCH,$PROPIO1,$PROPIO,$CORTO,$PROPIOSIN, $CORTOSIN,$BASEARCHCORTO,
      $ABSOLUTO,$ABSOLUTOSIN,$puntoext);
  if ($POSABSOLUTO =~ /^(.*)(\.\w+)/) {
      $puntoext = $2;
      $ABSOLUTOSIN = $1;
  } else {
      $puntoext = '';
      $ABSOLUTOSIN = $POSABSOLUTO;
  };    
  if ($ABSOLUTOSIN =~ /(.*\/)([^\/]*)$/) {
       $BASEARCH = $1;
       $PROPIOSIN = $2;
  };# no se da el else al ser $ABSOLUTO nombre absoluto
  my $largopwd = length ($pwdreal); my $largoBASEARCH = length $BASEARCH;
  if ($largoBASEARCH >= $largopwd) {
      my $comi = substr($BASEARCH,0,$largopwd);
      if ($comi eq $pwdreal) {
          $BASEARCHCORTO = substr($BASEARCH,$largopwd);
          $CORTOSIN = substr($ABSOLUTOSIN,$largopwd);
      } else {    
          $BASEARCHCORTO = $BASEARCH;
          $CORTOSIN = $ABSOLUTOSIN;
      };
  } else {
      $BASEARCHCORTO = $BASEARCH;
      $CORTOSIN = $ABSOLUTOSIN;
  };
  comifin('finy relativizar,$BASEARCH,$BASEARCHCORTO, $PROPIOSIN, $CORTOSIN,
           $ABSOLUTOSIN,$puntoext',
	  $BASEARCH,$BASEARCHCORTO,$PROPIOSIN, $CORTOSIN,$ABSOLUTOSIN,$puntoext);
  return $BASEARCH,$BASEARCHCORTO,$PROPIOSIN,$CORTOSIN,$ABSOLUTOSIN,$puntoext;
}#relativizar


# ---------------------------------------------------------------------------
sub comfin{ #uso comfin('com xxxxxx', @_)   o comfin('fin xxxxxx', @_)
  # o comfin('fin xxxxxx', @_,$lisque,$ref,'impr')
  # o comfin('fin xxxxxx',,$lisque,$ref,'impr')
  # 'impr' para que llame a impr_datos con $lisque y $ref
  return ''  unless $debug;
  my @viene = @_;
  my $primera = shift @viene; my $cosa = ''; @viene and $cosa = $viene[0];
  my @refarchers =  @Simusol::Globales::refarchers;
  my @refgrafers =  @Simusol::Globales::refgrafers;
  my @reflayers =  @Simusol::Globales::refgrafers;
  if ($cosa) {
      if ($cosa =~ /^HASH/) {
          my @caliscosa;
          if ($cosa->{ARCHIVOCAPA}) {
              push @caliscosa, 'reflay';
	      warn "parece reflay\n";
          };
          if ($cosa->{numfile} and $cosa->{capas}) {
              push @caliscosa, 'refarch';
              warn "parece refarch\n";
          };
          if ($cosa->{hashclasegr}) {
              push @caliscosa, 'refgraf';
              warn "parece refgraf\n"
          };
          if ($cosa->{numobj} and $cosa->{numcapa}) {
              push @caliscosa,'refcuadro';
	      warn "parece refcuadro\n";
          };
          @caliscosa >1 and do {
          warn ' @caliscosa ',__LINE__,' Ayud ' ,"@caliscosa\n";
          };
      };
  };
  my @simplif;
  foreach(@viene) {
#    impr_debug(__LINE__.' Ayud @viene',Dumper \@viene); 
     my $nuevo;
      my $texto = $_;
      if (not defined $texto) {
          $nuevo = 'no definido';
      } elsif ($texto =~   /^(ARRAY|HASH|SCALAR)\(/) {
          if ($texto =~ /^ARRAY\(/) { 
              my @lisundef = @$_; @lisundef = grep(do{not defined $_},@lisundef);
              if(@$_>8) {
                 $nuevo = 'ARRAY (' . scalar (@$_) . ')'    
              } elsif (@lisundef) {
                 $nuevo = 'ARRAY (' . scalar (@$_) . ' con undef)'
	      } else {
                 $nuevo = "[@$_]";
              }
          } elsif ($texto =~ /^HASH\(/) {
              $nuevo = 'HASH (' . scalar (keys (%$_ )) . ')'; 
 	      if (defined $_->{CORTOSIN}) {
	          $nuevo .= " - (($_->{CORTOSIN})): ";
              } elsif ($_->{numfile}) {
 	          my @refarchers = @Simusol::Globales::refarchers;
                  if (defined $refarchers[$_->{numfile}] and
                      defined $refarchers[$_->{numfile}]->{CORTOSIN}) { 
                      $nuevo .= 
                      " - ((capa de $refarchers[$_->{numfile}]->{CORTOSIN})): ";
                  };
              };
          } elsif ($texto =~ /^SCALAR\(/) {
	      $nuevo = 'SCALAR (' . length($$_) . ')';
          };
      } else {
          ($nuevo = $texto) =~ s/^\s*//;
          if ($nuevo eq '') {
              $nuevo = 'blanco';
          } elsif (length $nuevo < 16) {
          } elsif($nuevo =~ /^\//) {
              my $largo = length $nuevo; my $comi = $largo - 15;
              $nuevo = '...'. substr($nuevo,$comi); 
          } elsif (length $nuevo > 24) {
              $nuevo = substr($nuevo,0,24) .'...';
          };
          if ($texto =~ /,/) {
              $nuevo .= 'con comas';
          };
      };
      push @simplif, $nuevo;
  };
  my ($donde,$comfin);
  if ($_[0] =~ /^\s*(\w+)\s+(\S\w*)/){
     ($donde,$comfin) = ($1,$2);
    if (@_ >3 and defined $_[-1] and defined $_[-2] 
         and $_[-1] eq 'impr' and  $_[-2] =~ /HASH\(/ ) {
            impr_datos(
            "para $comfin pide comfin",['DATOS','PARAMETROS','INICIALES']
		  ,$_[-2]);
     };
  };
  eco(" $_[0](" . join(',',@simplif). ')'); #para comfin
  return '';
}#comfin

# ---------------------------------------------------------------------------
sub mensajear{

    #escribe lista de mensajes en la salida, mensaje es un solo mensaje, este es una lista
    
#  comifin('com mensajear',@_);
  if (@_ != 1) {
      die "mensajear no tiene 1 argumento
          @_"
  };
  my $agre = ' _ _ _ _ '; 
  if ($debug) {
     warn "$agre$_[0]\n";
  } else {
      print "$agre$_[0]\n";
  };
  no warnings;
  if (tell($SALIDAlog)) {
     print $SALIDAlog "$_[0]\n"
  };
}#mensajear
# ---------------------------------------------------------------------------
sub mensaje{
  if (@_ != 1) {
      die "mensaje no tiene 1 argumento
          @_"
  };
  if ($debug) {
      warn "$_[0]\n";
  } else {    
      print     "$_[0]\n";
  };    
  print $SALIDAlog "$_[0]\n";
}

##########################################################################################

sub imprhash{
  my ($identy, @hash)=@_; my ($impr, $largo);
  my $cuantos = scalar @hash; 
  if (($cuantos % 2) ) {#numero impar de valores
     $impr = pop(@hash);
     $largo = $impr;    
  } else {    
     $impr = 0;
     $largo = length($identy) + 1; # en imprhash 
  }; 
  my %hash = @hash;    
  my $texto ='';     
  foreach my $uno (sort keys %hash){
     $texto .= sprintf "%1s",  (' ' x $largo) . "$uno => $hash{$uno}\n"; 
  };
  if ($impr) {
     return $texto;
  } else {
     print "$identy --- hash: ",scalar keys %hash," ---\n";
     print "$texto\n";   
  }; 
}
#---------------------------------------------------------------------------

sub impr{
  #imprime elementos de una lista dada por sí
  my ($identy,@lista) = @_;my $largo = length($identy) + 1; # en impr
  if (@lista) {
   print "$identy --- array: ",scalar @lista," ---\n";
   foreach (@lista){
      print ' ' x $largo; 
      if (defined){ print $_,"\n"
      } else {print " undef\n"
      }
   }
  } else {print $identy,"\n";
  }
}
#---------------------------------------------------------------------------
sub imprhashrenglon{  ########### OJO hay hash_renglon
   #imprime un hash dado por sí, todo en un renglón y sin identificación
   my ($mensaje, %hash)=@_;
   print "$mensaje ";
   if (@_) {
      map((print "$_=>$hash{$_};   "),sort keys %hash)  
   } else {
      print '(vacio)'
   };   
   print "\n"  
}

# ---------------------------------------------------------------------------
sub parary{
    # para salir
  my ($codigo,$mensaje) = @_;
  warn "$mensaje\n" if $mensaje;
 # print STDERR ' ' x 30,"Salgo de $progname con $codigo\n";
 # print ' ' x 30,"Salgo de $progname con $codigo\n";
  exit $codigo;
}#parary


# --------------------------------------------------------------------------- ASUS
     
#----------------------------------------------------------------------------
sub abrir_ls3{ # llama presentar_simusol en AUXILIARES_PP
  my ($archivos,$elemento,$progname) = @_; 
    # ls3 va a ser los mensajes de todo el simusol
    # lss1 es por ahora para todo el simusol con noclas, en el futuro DEPRECADo
    
  comifin('comy abrir_ls3_log',@_);
  # la apertura vale para el programa (y subrutinas) que la hizo, no 
  # para otros programas, 
  #    pero no se interrumpe por error; solo hay aviso

 # my $elog='.log'; 
  my $els3='.ls3';

  # cuando es simplot
  my ($archls3,$camino1,$bn);
     if ($elemento eq 'simplot'){  # ver progname!
           ($archls3,$camino1,$bn)=Simusol::AyudasPP::resolver_dir($archivos,'simplot','.ls3','');
           creacamino($camino1,$archivos,$elemento,1);# el uno es no entra a archiva
      }else{      

           ($archls3,$camino1,$bn)=resolver_dir($archivos,$elemento,$els3,'');
           creacamino($camino1,$archivos,$elemento,0);        
      }

  
  my $modo = '1';
  $progr{$progname} eq '1' and $modo = 0;
  
  

  #print "SSSS $archls3\n";
  #my $archls3=File::Spec->catfile($camino,$PROPIOSIN.$els3);
  #my $archlog=File::Spec->catfile($camino,$PROPIOSIN.$elog);
  #exit;

  impr_debug(__LINE__.' Ayud',[$archls3]);
  

  #print "CAMINO  $archls3 | $archlog\n";
  Simusol::AyudasPP::archiva($archls3,'F',$archivos,$elemento);
  # Simusol::AyudasPP::archiva($archlog,'F',$archivos,$elemento);
  # my $SALIDAlog;

  #if (tell($SALIDAlog)) {
    #  close $SALIDAlog;
  #}
      
  if ($modo) {
    
          open($SALIDAlog, ">>",$archls3) or  die " $progname no pudo  escribir >> $archls3";
          ###   open($SALIDAlog, ">>",$archlog) or  die " $progname no pudo  escribir >> $archlog";
	  print $SALIDAlog "Se abre nuevamente: $archls3\n";
       }else{   
          open($SALIDAlog, ">",$archls3) or  die " $progname no pudo  escribir > $archls3";
          #    open($SALIDAlog, ">",$archlog) or  die " $progname no pudo  escribir > $archlog";
          };
       

  comifin('finA abrir_ls3_log');
  return;
  #exit;
}#abrir_ls3_log
####################################################


sub creacamino{
    my ($camino,$archivos,$elemento,$noentra)=@_;
    if($camino and not -e $camino){
      #if (-W $camino){ verificar superior
      #print "Creo $camino\n";
      #system("mkdir -p $odi");
      if (not $noentra){Simusol::AyudasPP::archiva($camino,'D',$archivos,$elemento);}
      my @created=File::Path::make_path($camino,{});
      #print cwd()," - @created -\n";
      #print "RRR >$camino< \n";
    }
   
}
# ---------------------------------------------------------------------------
sub avejec{; # AVISO DE ERROR EJECUCION
  propio("ERROR DE EJECUCION", $_[0]);
}#avejec
# ---------------------------------------------------------------------------
sub avgrav{$avisosgrav++;
	   propio("ERROR GRAVE", $_[0]);
}#avgrav
# ---------------------------------------------------------------------------
sub avnograv{$avisosnograv++;
  propio("ERROR NO GRAVE?", $_[0]);
}#avnograv
# ---------------------------------------------------------------------------
sub avnoseent{$avisosnoseent++;
  # uso avisosnoseent(xxx1):
  #    xxx1: mensaje del aviso;
  #    se cuentan.      
  propio("ERROR NO SE ENTIENDE", "$_[0]\n                 se ignora");
}#avnoseent
# ---------------------------------------------------------------------------
sub cerrar_paren{
  # recibe un string y lo devuelve partido en dos (la concat. de los dos es
  # el de entrada;
  # si no comienza con parentesis el primero es vacio
  # si comienza con parentesis el primero termina al cerrarse el parentesis
  #    o al acabar... en cuyo caso se le agrega un # al final y 
  # devuelve un tercero 'error' 
  # el segundo queda con el resto, que puede ser vacio.
  # asi que si el primero no es vacio y no termino con parentesis 
  # es porque  no pudo cerrarlo  
  my $dato = $_[0]; 
  if ($dato !~ s/^\s*\(//) { return ('',$dato) };    
  my @liscar  = split '', $dato;  
  my $abre = 1; my $out1 = '(';
  while (@liscar) {
      $_ = shift @liscar;
      $out1 .= $_;
      if ($_ eq '(') {$abre++
      } elsif ($_ eq ')') {
          $abre--;
          $abre == 0 and last;
      };
  };
  my $out2 = join '',@liscar;
  $abre > 0 and $out1 .= '#' and return ($out1,$out2,'error');
  return ($out1,$out2);
}#cerrar_paren
# ---------------------------------------------------------------------------
sub comas_invalidas{
    # saca comas repetidas o al vicio
  #detecta subexpresiones listas que no son argumentos de funcion
  #simplifica las que no molestan ....
  my $expre = 'lista'.$_[0]; #para que no moleste una lista pura
  (my $coderr,my @lista) = juntar_por_paren(',',split /\s*\,\s*/, $expre);
  @lista > 1  and return 1;
  while ($expre ne '' and $expre =~ s/(\w+)\s*\([^\(\)]+\)/$1/) {
  }; #elimino todas las posibles llamadas a funciones
  if ($expre =~ /\([^\(\)]+\,[^\(\)]+\)/) {return 1};
  return ''
}#comas_invalidas   
# ---------------------------------------------------------------------------
# es como el comfin de GlobalesSimusol.pm pero sin lo del 'impr'
sub comifin{ #uso comifin('com xxxxxx', @_)   o comifin('fin xxxxxx', @_)
  # o comifin('fin xxxxxx', @_,$lisque,$ref,'impr')
  # o comifin('fin xxxxxx',,$lisque,$ref,'impr')
  # 'impr' para que llame a impr_datos con $lisque y $ref
  return ''  unless $debug;
  my @viene = @_;
  my $primera = shift @viene; my $cosa = ''; @viene and $cosa = $viene[0];
  if ($cosa) {
      if ($cosa =~ /^HASH/) {
          my @caliscosa;
          if ($cosa->{NUMARCHIVOCAPA}) {
              push @caliscosa, 'reflay';
	      warn "parece reflay\n";
          };
          if ($cosa->{numfile} and $cosa->{cuantas_capas}) {
              push @caliscosa, 'refarch';
              warn "parece refarch\n";
          };
          if ($cosa->{hashclasegr}) {
              push @caliscosa, 'refgraf';
              warn "parece refgraf\n"
          };
          if ($cosa->{numobj} and $cosa->{numcapa}) {
              push @caliscosa,'refcuadro';
	      warn "parece refcuadro\n";
          };
          @caliscosa >1 and do {
          warn ' @caliscosa ',__LINE__,' Ayud ' ,"@caliscosa\n";
          };
      };
  };
  my @simplif;
  foreach(@viene) {
     my $nuevo;
      my $texto = $_;
      if (not defined $texto) {
          $nuevo = 'no definido';
      } elsif ($texto =~   /^(ARRAY|HASH|SCALAR)\(/) {
          if ($texto =~ /^ARRAY\(\w*\)$/) { 
              my @lisundef = @$_; @lisundef = grep(do{not defined $_},@lisundef);
              if(@$_>8) {
                 $nuevo = 'ARRAY (' . scalar (@$_) . ')';   
              } elsif (@lisundef) {
                 $nuevo = 'ARRAY (' . scalar (@$_) . ' con undef)'
	      } else {
                 $nuevo = "[@$_]";
              }
          } elsif ($texto =~ /^HASH\(\w*\)$/) {
              $nuevo = 'HASH (' . scalar (keys (%$_ )) . ')'; 
 	      if (defined $_->{CORTOSIN}) {
	          $nuevo .= " - (($_->{CORTOSIN})): ";
#              } elsif ($_->{numfile}) {
# 	          my @refarchers = @Simusol::GlobalesSimusol::refarchers;
#                  if (defined $refarchers[$_->{numfile}] and
#                      defined $refarchers[$_->{numfile}]->{CORTOSIN}) { 
#                      $nuevo .= 
#                      " - ((capa de $refarchers[$_->{numfile}]->{CORTOSIN})): ";
#                  };
              };
          } elsif ($texto =~ /^SCALAR\(\w*\)$/) {
	      $nuevo = 'SCALAR (' . length($$_) . ')';
          };
      } else {
          ($nuevo = $texto) =~ s/^\s*//;
          if ($nuevo eq '') {
              $nuevo = 'blanco';
          } elsif (length $nuevo < 16) {
          } elsif($nuevo =~ /^\//) {
              my $largo = length $nuevo; my $comi = $largo - 15;
              $nuevo = '...'. substr($nuevo,$comi); 
          } elsif (length $nuevo > 24) {
              $nuevo = substr($nuevo,0,24) .'...';
          };
          if ($texto =~ /,/) {
              $nuevo .= 'con comas';
          };
      };
      push @simplif, $nuevo;
  };
  my ($donde,$comifin);
  if ($_[0] =~ /^\s*(\w+)\s+(\S\w*)/){
     ($donde,$comifin) = ($1,$2);
    if (@_ >3 and defined $_[-1] and defined $_[-2] 
         and $_[-1] eq 'impr' and  $_[-2] =~ /HASH\(/ ) {
            impr_datos("para $comifin pide comifin",['DATOS','PARAMETROS','INICIALES']
		  ,$_[-2]);
     };
  };
  eco(" $_[0](" . join(',',@simplif). ')'); #para comifin
  return '';
}#comifin
# ---------------------------------------------------------------------------
sub depurar_crudo{
   # depura los cuadros del dia
    
  # depura a $crudo que  supone es un texto formado de varios renglones;
  # eliminando comentarios (desde un #)
  # y limpia espacios al comienzo y al final
  # devuelve lista de renglones depurados
  my $crudo =$_[0];
  #print  __LINE__ . " Ayud crudo $crudo\n";
  my @listain = split "\n", $crudo; my @listaout =();
  foreach (@listain) {
      #tr/\t/ /; #sustituye  tabuladores por espacios; ya estan dentro de \s
      s/\#.*//g; #quita comentarios
      next if /^\s*$/;
      s/^\s+//;
      s/\s+$//;
      push @listaout, $_;
  };
  return @listaout;
}#depurar_crudo
# ---------------------------------------------------------------------------
sub eco{
   # parecido al explic pero va a dos lados STDERR STDOUT 
  return if $noverb and not defined $_[0];
  #para indicar que esta haciendo simusol; para depurar
  print        "..... $_[0]\n"; 
  warn "..... $_[0]\n"; 
  #si se usa > o 2> quedan separados
}#eco
# ---------------------------------------------------------------------------
sub existencia{
  # DEPRECADO  tiene gnus
    
  comifin('comy existencia',@_);# si el $puntoext es .dia se controla que sea diagrama
  my ($ref,$puntoext,@dirdato) = @_; my ($coderr,$mensaje) = ('','');
  my $dir = $ref->{curdirori}; my @dirdatosin; 
  foreach my $arch (@dirdato) {
      (my $archsin = $arch) =~ s/\.[^\/\.]*$//;
      $archsin !~ /^\// and $archsin = "$dir$archsin";
      push @dirdatosin, $archsin;
  };
  @dirdatosin = union_conjunto(@dirdatosin); my (@archivos,@archivossin);
  foreach my $archsin (@dirdatosin) {    
      if (-e $archsin and not -d $archsin and not -e "$archsin$puntoext") {
          push @archivos,$archsin;
          push @archivossin,$archsin;
      };         
      if (-e "$archsin$puntoext" and not -d "$archsin$puntoext" and
            not -e $archsin) { 
          push @archivos,"$archsin$puntoext";
          push @archivossin,$archsin;
      };
      if (-e "$archsin$puntoext" and -e $archsin) {
          $coderr = 250; $mensaje = " Existen archivos
             $archsin$puntoext  y  $archsin
                Asi no puede trabajar Simusol"; 
      };
  };#foreach
  if (not $coderr) {
      impr_debug(__LINE__.' Ayud',\@archivos);
      if (@archivos == 0) {
          $coderr = 250; $mensaje = "No han quedado archivos para procesar";
      };
  };
  if (not $coderr) {      
      if ($puntoext eq '.dia') { 
          for (my $i = 0;  $i < @archivos; $i ++) {
              my $arch = $archivos[$i];
	      next if not system "grep dia:diagram $arch >/tmp/null";
	      system "zcat $arch > gnus/llll 2>/tmp/null";
              next if not system "grep dia:diagram  gnus/llll >/tmp/null";
	      $archivos[$i] = undef; $archivossin[$i] = undef;
          };
      };	    
      @{$ref->{absoluto}} = grep ($_,@archivos);
      @{$ref->{absolutosin}} = grep ($_,@archivossin);	  
      impr_debug(__LINE__.' Ayud $ref->{absoluto}',$ref->{absoluto});
  };    
  comifin('finy existencia,$coderr,$mensaje',$coderr,$mensaje);
  return $coderr,$mensaje;    
}#existencia;    
# ---------------------------------------------------------------------------
sub explic{
    # imprime mensaje para explicar va STDOUT
  return if $noverb;   
  if (@_ != 1) {
      die "explic no tiene 1 argumento
          @_"
      };
    # para que sirva de ayuda al usuario; no va al archivo lss1
    print        "........ $_[0]\n";
}#explic
#----------------------------------------------------------------------------
sub hashrenglon{
  #para un hash dado por si, forma un renglon ...
  my ($mensaje, %hash)=@_;
  my $texto = "$mensaje ";
  if (@_) {
     map(do{$texto .= "$_=>$hash{$_}; "},sort keys %hash);  
  } else {
      $texto .= '(vacio)';
  };   
  return "$texto\n";  
}#hashrenglon
# ---------------------------------------------------------------------------



sub impr_todo{
  comifin('comy impr_todo',@_);
  return unless $debug;  
  my ($mensaje,$ref)= @_;
  print STDERR " Empieza impr_todo $mensaje (ref$progr{$progname})\n";
  if ($ref->{dirarray}) {
      warn " dirarray: ",scalar @{$ref->{dirarray}};
      if (@{$ref->{dirarray}} == 1) {
	  warn " archivo: $ref->{dirarray}->[0]\n";
      }else{
          warn " archivos\n";
      };
  };	  
  foreach my $palabra (qw(juntos curdirori outdir APARTIR 
    ARCHGUARDARCONGNUS ABSOLUTO ABSOLUTOSIN BASEARCHCORTO CLASEARCH CORTO CORTOSIN
    DATECORTO DIRG NUMARCH PROPIO PROPIOSIN GUARDARCORTOSIN ls3 PUNTOEXT)) {
      warn " $palabra $ref->{$palabra}\n"
        if defined $ref->{$palabra};
  };
  foreach my $palabra (qw(absoluto absolutosin basearch basearchcorto
    corto cortosin guardarcortosin propio propiosin clasearch datecorto puntoext
    codigo_1 codigo_s codigo_3)) {
#     print STDERR " $palabra ",paraimpr3puntos(60,@{$ref->{$palabra}}),"\n"
#	 if $ref->{$palabra};
     warn " $palabra: @{$ref->{$palabra}}\n"
	 if $ref->{$palabra};
   };    
  warn " Termina impr_todo $mensaje\n";
  comifin('finy impr_todo');
  return;
}#impr_todo
# ---------------------------------------------------------------------------
sub impr_hash{
  my ($identy, @hash)=@_; my ($impr, $largo);
  my $cuantos = scalar @hash; 
  if (($cuantos % 2) ) {#numero impar de valores
     $impr = pop(@hash);
     $largo = $impr;    
  } else {    
     $impr = 0;
     $largo = length($identy) + 1; # en impr_hash 
  }; 
  my %hash = @hash;    
  my $texto ='';     
  foreach my $uno (sort keys %hash){
     $texto .= sprintf "%1s",  (' ' x $largo) . "$uno => $hash{$uno}\n"; 
  };
  if ($impr) {
     return $texto;
  } else {
     print "$identy --- hash: ",scalar keys %hash," ---\n";
     print "$texto\n";   
  }; 
}#impr_hash
#---------------------------------------------------------------------------
sub impr_{
    # DEPRECADO
    
  #imprime elementos de una lista dada por si
  my ($identy,@lista) = @_;my $largo = length($identy) + 1; # en impr_
  if (@lista) {
   print "$identy --- array: ",scalar @lista," ---\n";
   foreach (@lista){
      print ' ' x $largo; 
      if (defined){ print $_,"\n"
      } else {print " undef\n"
      }
   }
  } else {print $identy,"\n";
  }
}#impr_
# ---------------------------------------------------------------------------
sub impr_debug{
  return unless $debug;
  if (@_ != 2) {
      die "impr_debug no tiene dos argumentos
          @_"
      };
  my ($mensaje,$cosa) = @_;
  my $texto = 'impr_debug ';
  $texto .= "$mensaje " if defined $mensaje;
  if (not defined $cosa) {
      $texto .=" no definido\n";    
  } elsif ($cosa =~ /^ARRAY\(/) {
      my $cosa1; @$cosa1 = @$cosa; 
      map(do{not defined $_ and $_ ='no definido' or
             $_ !~ /\S/ and $_ = 'blancos'},@$cosa1);
      $texto .= 'array ('.join (",", @$cosa1).")\n";	       
  } elsif ($cosa =~ /^HASH\(/) {
      my @lista; 
      foreach my $key (keys %$cosa){
          my $algo = $cosa->{$key}; defined $algo or $algo = 'undef';
          push @lista, "$key=>$algo";
      }; 
      $texto .= 'hash (' . join (',',@lista) .")\n";
  } elsif ($cosa =~ /^SCALAR\(/) { 
      $texto .=  "( escalar )$$cosa\n";
  } else { 
      $texto .= "$cosa\n";
  }; 
  print STDERR $texto;
}#impr_debug    
#---------------------------------------------------------------------------
sub impr_hashrenglon{
   #imprime un hash dado por si, todo en un renglon y sin identificacion
   my ($mensaje, %hash)=@_;
   print "$mensaje ";
   if (@_) {
      map((print "$_=>$hash{$_};   "),sort keys %hash)  
   } else {
      print '(vacio)'
   };   
   print "\n"  
}#impr_hashrenglon

# ---------------------------------------------------------------------------
sub interseccion_conjunto{
  # Dadas dos referencias a listas devuelve otra  con los elementos comunes
  # es mas eficiente si en la primera no hay elementos repetidos
  my ($lista1,$lista2) = @_;
  my %hash;
  foreach my $ele (@$lista1) {
      map(do{$_ eq $ele and $hash{$_}= 1},@$lista2);
  };  
  return keys %hash
}#interseccion_conjunto
# ---------------------------------------------------------------------------
sub juntar_por_paren{
    # buscar parentesis de cierre en listas de expresiones
  my ($pega,@listain) = @_; 
  my @listaout = ();
  my ($abre, $cierra, $ant, $coderr) = (0, 0, '', '');
  foreach(@listain) {
      $ant .=  "$_$pega" ;
      $abre = ($ant =~ tr/\(//); $cierra = ($ant =~ tr/\)//);
      if ($abre < $cierra) {
          avgrav ("Expresion con parentesis ')' no apareados:\n  $_");
          return 68;    
      } elsif ( $abre == $cierra) {
          $ant =~ s/$pega$//;push(@listaout,$ant); 
          $ant = ''; $abre = 0; $cierra = 0;;
      } 
  }; #@listain
  $ant =~ s/$pega$// if $ant ne '';
  if ($abre > $cierra) {
      avgrav ("Expresion con parentesis '(' no apareado:\n  $ant");
      return 69;
  };
  return $coderr,@listaout;    
}#juntar_por_paren
# ---------------------------------------------------------------------------
sub juntar_por_signos_y_paren{
    # para analizar cuadros, y ver cortes de renglones

  my ($pega,@listain) = @_; my @listaout = (); my $ant = '';
  my $juntado = join ("\n",@listain);
  #para juntar renglones : no 'pueden' comenzar con +-*/=\)
  #no  'pueden' terminar con \(ni con =; 
  #un renglon con = no inicial no se junta con el anterior, aunque quede
  #con parentesis u operaciones pendientes
  # los parentesis se tratan algebraicamente
  $juntado =~      s/([\,\+\-\*\/\=\(])\s*\n/$1 /g; # signos finales
  $juntado =~ s/\n\s*([\,\+\-\*\/\=\)])/ $1/g; # signos iniciales
  @listain = split ("\n",$juntado);
  my ($abre, $cierra) = (0,0);
  foreach(@listain){
      if ($ant eq '') {
          $ant = $_;
      } elsif (/^\s*\S.+=/) {
          do{push(@listaout,$ant); $ant = $_};#puede salir con parentesis mal
      } else {
          $ant .= $pega . $_;#le saque la ,
      };
      $abre = ($ant =~ tr/\(//); $cierra = ($ant =~ tr/\)//);
      #print 'Ayud ' . __LINE__ . " abre $abre cierra $cierra ant $ant \n";
      do {push(@listaout,$ant); $ant = ''} 
          if ($abre == $cierra );
  }; #@listain
  push(@listaout,$ant) if $ant ne  '';
  return (@listaout)    
}#juntar_por_signos_y_paren
# ---------------------------------------------------------------------------
sub juntar_por_signosf_y_paren{
    # para analizar cuadros, y ver cortes de renglones
    
  my (@listain) = @_; my @listaout = (); my $ant = '';
  my $juntado = join ("\n",@listain);
  # no  'pueden' terminar con ,;
  # y se intentan parentesis apareados 
  # con parentesis u operaciones pendientes
  # los parentesis se tratan algebraicamente
  $juntado =~      s/([\,\+\-\*\/\=])\s*\n/$1/g; # , finales
  @listain = split ("\n",$juntado);
  my ($abre, $cierra) = (0,0);
  foreach(@listain){
      next unless $_; 
      $ant .= $_; 
      $abre = ($ant =~ tr/\(//); $cierra = ($ant =~ tr/\)//);
      #print 'Ayud ' . __LINE__ . " abre $abre cierra $cierra ant $ant \n";
      do {push(@listaout,$ant); $ant = ''} 
          if ($abre <= $cierra );#puede haber errores que se detectaran despues
  }; #@listain
  push(@listaout,$ant) if $ant ne  '';
  return (@listaout)    
}#juntar_por_signosf_y_paren 
# ---------------------------------------------------------------------------

#----------------------------------------------------------------------------
sub paraimpr3puntos{
    # lista larga imprime el comienzo, y agrega ...
  my ($largo,@lista) = @_;my $dato = join(' ',@lista);
  length($dato) < $largo or  $largo < 5  # en paraimpr3puntos
    or $dato = substr($dato,0,$largo - 4) . '...';
  return $dato;
}#paraimpr3puntos
# ---------------------------------------------------------------------------
sub parser{
 # analiza paraplot   
  # se usa @resultados = parser($expresion);
    my ($expresion) = @_;


my ($sepi,$sepc,$sepd)=  (' +','=','\s*[,:]\s*');

    
  my (@lisi,@lisd);my ($lisi,$lisd);
  if ($expresion =~ /([^$sepc]+)\s*$sepc\s*(.*)/) {
      $lisi = $1; $lisd = $2; $lisd =~ s/\s*$//;
      @lisi = split(/$sepi/,$lisi);
      @lisd = split(/$sepd/,$lisd);
      (@lisi == 2   and @lisd) or return 'error';  
      $lisd[-1] =~ s/\s*$//;
      (my $coderr,@lisd)  = juntar_por_paren(',',@lisd);
  } else {return 'error'};
  return  (\@lisi,$sepc,\@lisd,$lisd);
}#parser 
# ---------------------------------------------------------------------------
sub particion{   # NO SE SABE 
  my ($refhash, $que) = @_;
  my @keys = keys %$refhash; 
  # se suponen ordenados con un mismo criterio los elementos en cada clase 
  # expresada con un string que es join con ' ' de los elementos
  # (si no interpreta clases distintas)
  my @clases = union_conjunto(values %$refhash);
  my $cuantos;
  for (my $i = 0; $i < @clases; $i ++) {
      my @lista = split /\s+/, $clases[$i];
      $cuantos += @lista;
  };
  #print '$refhash ', Dumper $refhash;
  $cuantos == @keys or
  do {explic("     ". join ('  ;  ', @clases) . "
      no es particion de \n          @keys;
      Numero total de elementos, ". scalar @keys . ",
      y numero de apariciones en las clases, $cuantos, 
      son distintos");
      return 1;
  };
  foreach my $key (@keys) {
      my $stringclase = " $refhash->{$key} ";
      $stringclase =~ /$key/ or
      do {explic("     ". join ('  ;  ', @clases) ."
          no es particion de \n          @keys;
          falla pertenencia");  
	  return 2;
      };
  };
  return ''; 
}#particion 
# ---------------------------------------------------------------------------
sub pausa{

    # PAUSA
    
    my ($msg) =(@_,'');
    explic("$msg    Pulse ENTER   ( o CTRL-C para terminar con todo):\n");
    my $dummy = <STDIN>;
    explic('');
    return
}#pausa
# ---------------------------------------------------------------------------
sub pausadebug{
    return if not $debug; 
    pausa(@_);
}#pausadebug
# ---------------------------------------------------------------------------
sub pausaver{
    # muestra y pausa
    
   my ($mensaje,$tarea)=@_;
   mensajear($mensaje);
   mensajear(
       "              Continue $tarea
                        con   ENTER-RETURN;
               Interrumpa con CTRL-C");
   my $resp = <STDIN>;
   mensajear('') if $debug; 
}#pausaver    
# ---------------------------------------------------------------------------
sub propio{
    #usada por avnograv error no grave  avgrav avnoseent  no se entiende
    #que: es avgrav no avnograv o no se entiende
  my ($que,$mensaje) = @_;
  print $SALIDAlog "$que: $mensaje\n";

  #print "PN $progname ", Dumper \%progr;
  #exit;
  if ($debug) {
      warn "($progr{$progname}) $que: $mensaje\n";
  } else {    
      print  "($progr{$progname}) $que: $mensaje\n";
  };
}#propio

# ---------------------------------------------------------------------------
sub resolver_outdirMAL{#
  my ($curdir,$outdir) = @_;
    
  comifin('comy resolver_outdir de lib/simusol',@_);
  my $coderr = '';
  #lo usa desmenuzar_comando
  #sobre la base que curdir NO CAMBIA, no se debe cambiar el curdir, salvo que la rutina
  # que lo haga inmediatamente lo reverse, y no es bueno para reentrancia
  
  # DEPRECADO: de linea de comandos o de directorio actual saca outdir y despues
  # le pone adelante lo que corresponda tomando el path original del archivo de entrada e insertando
  #el outdir
  # NO DEPRECADO, verifica que se pueda escribir ahi, resuelve caso path absoluto. creadir
   
  #if (not defined $outdir){
  #    $outdir = $curdir;      
  #}else{
  #    #####($coderr,$outdir) = simpl_directory($outdir);
  #    # verificar outdir que no tenga .. u otros problemas
  #   if( $outdir !~ /^\//){ 
  #      $outdir =join($curdir,$outdir);
  #      }
  #   }
  # caso contrario queda como viene, un directorio absoluto;

  impr_debug(__LINE__.' Ayud $outdir',$outdir);  
  if (not -d ) {

         warn " $outdir no es un directorio; no sirve para recibir archivos, lo creo";
         # verificar que la parte que pre-existe es un directorio escribible y adecuado para no hacer lio
         File::Path::make_path ($outdir,{});

	 #puedo escribir en curdir?
	 #es outdir absoluto? 

	 # existe y puedo escribir ahi
	 # puedo crearlo?
 
       
  } else{
      # verificar que es un directorio escribible y adecuado para no hacer lio

   if (-d $outdir) {
     #if (not $coderr) {
      my $owner =  `stat -c %U $outdir`; 
      chomp $owner;
      my $usted =  `whoami`;
      chomp $usted;
      impr_debug(__LINE__.' Auxi $owner,$usted',[$owner,$usted]);
      $owner eq $usted or die "    El directorio $outdir no sirve para outdir;
        pertenece a $owner y usted es $usted\n"; 
      my $attr = `stat -c %A $outdir`;
      $attr =~ /r.x$/ or die "    El directorio $outdir no sirve para outdir;
        no tiene los permisos necesarios. 
          Proponga uno adecuado con la opcion -outdir\n";
      
  };

  
  
  #}else{
  #    die "No se pudo crear outdir=$outdir\n";
  #}
  
  #$coderr and parary(250);
  #$ref->{outdir} = $outdir;
  comifin('finy resolver_outdir',$outdir);
  return $outdir;
}#resolver_outdir';
}

# ---------------------------------------------------------------------------
sub revisar_apareo{# revisa desde la izaquierda apareo de parentesis
    
  #devuelve $coderr -1 cuando no hay apareo; y
  # los conteos de apertura de los tres tipos de parentesis y
  # $uno la porcion de la izquierda quizas terminada 
  # en el parentesis culpable y $dos la porcion de la derecha no revisada
  my $expre = $_[0]; my ($coderr,$mensaje) = ('','');
  my ($car,$abrec,$abrer,$abrel,$uno,$dos) = ('',0,0,0,'',$expre); 
#  print STDERR __LINE__," $coderr,$abrec,$abrer,$abrel,$uno,$dos\n";
  while  ($dos =~ /[\(\)\[\]\{\}]/) {
      $dos =~ s/^(.)//; $car = $1; $uno .= $car;
 #     print STDERR __LINE__," $coderr,$abrec,$abrer,$abrel,$uno,$dos\n";
      next unless $car  =~ /[\(\)\[\]\{\}]/;
      $car eq '(' and $abrec++ or $car eq ')' and $abrec -- or
        $car eq '[' and $abrer ++ or $car eq ']' and $abrer -- or
        $car eq '{' and $abrel ++ or $car eq  '}' and $abrel --;
 #     print STDERR __LINE__," $coderr,$abrec,$abrer,$abrel,$uno,$dos\n";
      if ($abrec < 0 or $abrer < 0 or $abrel < 0) {
	  $coderr = -1; $mensaje = " No apareo detectado en \"$uno\"";
#          $mensaje .=  "\"$dos\"" if $dos;last;
      };
  };
  if ($abrec > 0 or $abrer > 0 or $abrel > 0) {
      $coderr = -1; $mensaje = " Hay parentesis sin cerrar en \"$expre\"";
  };     
#  print STDERR '(finy revisar_apareo $coderr,$mensaje,$uno,$dos,$abrec,$abrer,$abrel',
#	  " $coderr,$mensaje,$uno,$dos,$abrec,$abrer,$abrel\n";
  return $coderr,$mensaje,$uno,$dos,$abrec,$abrer,$abrel;
}#revisar_apareo
# ---------------------------------------------------------------------------
sub sacar_paren_ext{
  #recibe un string y devuelve un string  sin parentesis externos + resto (-1, por error)
  # o una terna  numero,string, string: el numero la cantidad de pares 
  # de parentesis exteriores sacados; lo de adentro; y el resto
  my ($dato,$resto,$error) = ($_[0],'',''); 
  my  $dat;
  if ($dato =~ /^\(/) { 
      ($dat,$resto,$error) = cerrar_paren($dato);
      defined $error and return -1; #no se cerro
      $dato = $dat;
  } else {
      return (0,$dato,'');
  };
  my $cuantos = 0;
  my $restin = ''; 
  while  ($restin eq '' and $dat ne '') {
      $dato = $dat;
      #impr_debug( __LINE__.' Ayud', "$_[0]     dato $dato ");
      $dato =~ s/^\((.*)\)$/$1/;
      ($dat,$restin,$error) = cerrar_paren($dato);
      defined $error and return -1; #no se cerro
      $cuantos ++;
  };
  return ($cuantos, $dato,$resto);
}#sacar_paren_ext
# ---------------------------------------------------------------------------
sub simpl_archivo{ #elimina'..' intercalados en nombre de archivo
    #se supone que no hay errores de sintaxis ni espacios 
    # al princ.ni al final
    # y que no termina en /, pues no es un directorio, pero si empieza con /

    # NO SE USA
    
    my $arch = $_[0]; $arch =~ s/^\///;
    my @lista = split /\//, $arch;
    @lista = grep (do{$_ ne '.'}, @lista);
    my $hay =1;
    while ($hay){
        $hay ='';
        for(my $i = 0; $i <@lista-1; $i ++) {
            if ($lista[$i+1] eq '..'  and $lista[$i] ne '..') {
 	        delete $lista[$i]; delete $lista[$i+1]; 
                if (defined $lista[$i+2] and $lista[$i+2] eq '..') {
                    $hay= 1;
                }
                $i ++;
	    } ;
        };
        @lista = grep(defined $_,@lista);    
    };  #ya no hay '..' intercalados
    my @listadospuntos = grep($_ eq '..',@lista);
    return '/'. join '/',@lista;
}#simpl_archivo
# ---------------------------------------------------------------------------
sub simpl_directory{ #elimina '..' o '.' intercalados en nombre del directorio

    # NO SE USA
    
  comifin('comy simpl_directory',@_); 
  my $direin = $_[0]; my ($coderr,$direout) = ('',$direin);
  my $curdir = `pwd`;
  chomp $curdir;
  if (-d $direin) {
      chdir $direin;
      $direout = `pwd`; 
      chomp $direout;
      $direout =~ s/([^\/])$/$1\//;
  } else {
      $coderr = 1;
  };
  chdir $curdir;# si $curdir no fue chompeado, resultaria inutil  
  comifin('finy simpl_directory',$coderr,$direout);
  return $coderr,$direout; 
}#simpl_directory 
# ---------------------------------------------------------------------------
sub textear_MENSAJES{
  my $texto = '   '. join("   \n",@MENSAJES);
  @MENSAJES = ();
  return $texto;
}#textear_MENSAJES
# ---------------------------------------------------------------------------
sub texto{
  # texto que debe ser traducido a otro idioma (ademas de los mensaje etc
  return $_[0];
}#texto
# ---------------------------------------------------------------------------
sub transmitir{
    # pone en nombres info de $ref NO SE DE ACUERDA 
    my ($ref,$numarch) = @_;
  my @palas = qw (BASEARCH PROPIO CORTO PROPIOSIN CORTOSIN BASEARCHCORTO ABSOLUTO
   ABSOLUTOSIN DATECORTO PUNTOEXT);
  my @nombres;
  map(do{push @nombres, $ref->{lc($_)}->[$numarch]},@palas);
  return @nombres;
}#transmitir  
# ---------------------------------------------------------------------------
sub union_conjunto{
    my @lista = @_;
  # Dada un lista devuelve la "misma" sin elementos repetidos (respeta orden)
  my %hash; 
   
  foreach (@lista) {
      next unless defined $_;
      if ($hash{$_}) {
          $_ = undef;
      } else {
          $hash{$_} = 1
     }; 
  };
  @lista = grep (defined $_,@lista);
  return @lista;
}#union_conjunto


# foreach my $na (@ARGV){
#   if (-e $na){ 
#       my ($n,$d,$e)=fileparse($na,@$EXT);
#	push (@files ,[$n,$d,$e]);
#     }else{
#       foreach my $ex (@$EXT){     
#            if (-e $na.$ex){
#		my ($n,$d,$e)=fileparse($na.$ex,$ex);
#   	        push (@files ,[$n,$d,$e]);
#                }		       
#             }
#       }
#     }


# ---------------------------------------------------------------------------


#             &error_progr
# ESTA EN GLOBALES
#sub error_progr{
#   my ($archivo,$linea,@array) = @_;
#   print STDERR " ===== ERROR de programación detectado en: 
#       archivo $archivo      linea  $linea\n";
#   print STDERR Dumper \@array;
#   exit 200;
#}#error_progr
# ---------------------------------------------------------------------------

#Subroutine hashrenglon redefined at /usr/local/share/perl/5.22.1/Simusol/AyudasPP.pm line 1415.
#Subroutine propio redefined at /usr/local/share/perl/5.22.1/Simusol/AyudasPP.pm line 1789.




#if ($files[0]->[0]){
#    $Simusol::PlotGNU::archivosinext=$files[0]->[0];
#    #    $arch=$files[0]->[0];
#    print "PRIMERO  $files[0]->[0]\n";
#    #print Dumper \@files;
#    return (1,[@files]);
#} else{
#    print "No encontro archivo que pueda usar\n";
#    print "usar paraplot.pl ARCHIVO (sin extension, busca .ds .caj o finalmente un .paraplot ya realizado )\n";
#    return (-1,[]);
#}

#}

#if ($arch){
#    $Simusol::PlotGNU::archivosinext=$arch;
#}elsif(@ARGV == 1 and -e "$ARGV[0].paraplot") {
#    $Simusol::PlotGNU::archivosinext = $ARGV[0];
#} else {
#    my $ok;
#   ($ok,$Simusol::PlotGNU::archivosinext) = elegir_archivos('paraplot');
#   $Simusol::PlotGNU::archivosinext =~ s/\.paraplot//;   # hey es una lista!!! pueden venir varios, procesar
#    # antes salia si no encontraba, pero tener en cuenta que puede no haber paraplot y venir la info por $paraplot
# 
#   #hacer bien!
#};

my $LSS1;
my %reffi;
my $CORTOA;
my $CAJAS;
my %clasearchivos;

# -----------------------------------------------------------------------------
#sub parar3MAL{
# NO USO MAS
#  if ($_[1]) {
#      avgrav($_[1]);
#  };
 # foreach my $keysindia (keys %{$LSS1}) {
#      my $texto = join("\n",@{$LSS1->{$keysindia}}) . "\n";
#      open $SALIDAls3, ">>$keysindia.ls3";
#      print $SALIDAls3 $texto;
 # };
#  mensaje ("código s3: $_[0]") if $ENV{USER} eq 'loli'; close LSS1;
#  exit $_[0];
#}#parar3
#------------------------------------------------------------------------------



# ---------------------------------------------------------------------------
sub concretar_ABSOLUTO{
  comfin('comA concretar_ABSOLUTO',@_);
  my ($ABSOLUTOSIN,$BASEARCHCORTO,$PROPIOSIN,$puntoext,$curdirori,$outdir) = @_;
  my ($coderr,$mensaje,$outdirfinal) = ('','',$outdir); my ($ABSOLUTO,$PROPIO);
  my $realpuntoext = $puntoext;my %existe;
  my $archdia;
  my @posibles =($ABSOLUTOSIN.'.dia',$ABSOLUTOSIN,$ABSOLUTOSIN.$puntoext);
  @posibles = union_conjunto(@posibles);
  impr_debug(__LINE__.' Auxi @posibles',\@posibles);
  @posibles = grep(do{-e $_ and not (-d $_)} ,@posibles);
  impr_debug(__LINE__.' Auxi @posibles',\@posibles);
  if (@posibles >1) {
      $coderr = 200; $mensaje = " Existen mas de uno posibles: @posibles
       Asi no trabaja Simusol";
  } elsif (@posibles == 0 ) {
      $coderr = 200; $mensaje = " No existe ninguno de estos archivos:
          $posibles[0]
          $posibles[1]";
  } else {
      $archdia = $posibles[0]; 
      $archdia =~ /(\.\w+)$/ and $realpuntoext = $1; 
  };
  if (not $coderr) {        
      if ($progr{$progname} =~ /[01]/) {
          $ABSOLUTO = "$ABSOLUTOSIN$realpuntoext";$PROPIO = "$PROPIOSIN$realpuntoext"
      } else {
          my $EXT = 'd';
          $progr{$progname} eq '3' and $EXT = 'paraplot';


          ($coderr,$mensaje,$ABSOLUTO,$PROPIO,$outdirfinal) = interpretar_outdir(
            $ABSOLUTOSIN,$BASEARCHCORTO,$PROPIOSIN,$EXT,$curdirori,$outdir);



      };
  };
  comfin('finA concretar_ABSOLUTO $coderr,$mensaje,$ABSOLUTO,ABSOLUTOSIN,$PROPIO,
    $outdirfinal',
    $coderr,$mensaje,$ABSOLUTO,$ABSOLUTOSIN,$PROPIO,$outdirfinal,$realpuntoext);
  return $coderr,$mensaje,$ABSOLUTO,$ABSOLUTOSIN,$PROPIO,$outdirfinal,$realpuntoext;
}#concretar_ABSOLUTO
# ---------------------------------------------------------------------------
#sub controlar_reserv_dirsNO{
#  DEPRECADO cada directorio se crea al usarlo
#  comfin('comA controlar_reserv_dirs',@_);
#  my ($ref,$crear) = @_;# $estedir con / fin
#  my ($coderr,$mensaje) = ('','');
#  impr_debug(__LINE__.' Auxi %dirsalida',Dumper \%dirsalida);
#  my @reserv_dirs = (union_conjunto((values %dirsalida)),'cprojects','cauxes');
#  impr_debug(__LINE__.' Auxi @reserv_dirs',[@reserv_dirs]);
#  my $outdir = $ref->{outdir};
#  foreach my $reservdir (@reserv_dirs) { 
#      if ($outdir =~ /\/$reservdir\//) {
#           $mensaje =  "   $outdir\n,       pasando por  $reservdir,
#  no es buen lugar para recibir resultados; use adecuadamente la opcion outdir";
#          $coderr = 254; last;
#      };
#  };
#  $coderr and return ($coderr,$mensaje);    
#  foreach my $estedir (@{$ref->{basearchcorto}}) {
#      impr_debug(__LINE__.' Auxi $estedir',$estedir);
#      foreach my $reservdir (@reserv_dirs) { 
#          if ($estedir =~ /\/$reservdir\//) {
#              push @MENSAJES, "   $estedir\n,       pasando por  $reservdir,
#  no es buen lugar para recibir resultados; use adecuadamente la opcion outdir";
#          $coderr = 254; last;
#          };
#      };
#  };    
#  if (not $coderr and $crear) {
#      ($coderr,$mensaje) = crear_subdirectorios($outdir,@reserv_dirs);
#  };
#  comfin('finA controlar_reserv_dirs',$coderr,$mensaje,$outdir);
#  return $coderr,$mensaje;
#}#controlar_reserv_dirs
# ---------------------------------------------------------------------------
# usar mkpath
#sub crear_subdirectorios{
#  comfin('comA crear_subdirectorios',@_);
#  my ($desde, @subdirs) = @_;
#  my $coderr = '';
#  if (-e $desde and not -e $desde) {
#      push @MENSAJES, 
#        " Hay un archivo no directorio $desde que se ha pedido como directorio";
#  } elsif (not -d $desde) {
#      mkdir $desde;
#      if (not -d $desde) {
#	 push @MENSAJES," No existe y no se pudo crear el directorio $desde\n";
#         $coderr = 253;
#     };
#  };
#  if (not $coderr) {
#      foreach my $subdir (@subdirs) {
#          if (not -d "$desde/$subdir") {
#              mkdir "$desde/$subdir";
#              if (not -d "$desde/$subdir") {
#                  push @MENSAJES
#                    , " No existe y no se pudo crear el directorio $desde/$subdir\n";
#              };
#          };
#      };
#  };
#  my $mensaje = textear_MENSAJES();    
#  comfin('finA crear_subdirectorios',$coderr,$mensaje);
#  return $coderr,$mensaje;
#}#crear_subdirectorios;
# ---------------------------------------------------------------------------
#sub interpretar_outdir{#ya debe estar definido outdir; $arch se  interpreta como
# referido a $curdirori y para indicar el archivo-diagrama
# se preocupa por existencia solo de lo que le interesa segun el $EXT : d o paraplot
#  comifin('comA interpretar_outdir',@_);
#  my ($ABSOLUTOSIN,$BASEARCHCORTO,$PROPIOSIN,$EXT,$curdirori,$outdir) = @_;
#  my ($coderr,$mensaje) = ('',''); my $outdirfinal = $outdir;my($ABSOLUTO,$PROPIO);
#  if ($BASEARCHCORTO !~ /^\//) {    
#      $outdirfinal =  "$outdir$BASEARCHCORTO";
#      impr_debug(__LINE__.' Auxi $outdirfinal',$outdirfinal);
#  }; 
#  my $archext = "$outdirfinal$dirsal{$EXT}$PROPIOSIN.$EXT";
#  impr_debug(__LINE__.' Auxi $outdirfinal,$archext',[$outdirfinal,$archext]);
#  if (not -e $archext) {#
#
# ve que este el .d!!!!
#      $coderr = 252; $mensaje = " No existe un archivo $archext";
#
##
#
# } else {
#      $ABSOLUTO = "$outdirfinal$PROPIOSIN.$EXT";
#      $PROPIO = "PROPIOSIN.$EXT";
#  };
#  comifin('finA interpretar_outdir  $coderr,$mensaje,$ABSOLUTO,$PROPIO,$outdirfinal',
#    $coderr,$mensaje,$ABSOLUTO,$PROPIO,$outdirfinal); 
#  return $coderr,$mensaje,$ABSOLUTO,$PROPIO,$outdirfinal;
#}#interpretar_outdir

# ---------------------------------------------------------------------------
sub aprontar{
  comfin('comA aprontar',@_);
  my ($ref,$PROPIOSIN) = @_;
  #print "$ref->{outdir}\n";
  my $outdirfinal =  "$ref->{outdir}$ref->{BASEARCHCORTO}";
  chdir $outdirfinal if $outdirfinal ne ''; 
  impr_debug(__LINE__.' Auxi $progr{$progname}',$progr{$progname});
  impr_debug(__LINE__.' Auxi',\%dirsal);
  impr_todo(__LINE__.' Auxi',$ref);  
  if ($progr{$progname} eq '1') {
      my $NUMARCH = $ref->{NUMARCH}; 
      not defined $NUMARCH and error_progr(__FILE__,__LINE__,' $NUMARCH no definido');
      my $cortosin = $ref->{cortosin}->[$NUMARCH];
      my $guardarcortosin = $ref->{guardarcortosin}->[$NUMARCH];
      not $guardarcortosin and $guardarcortosin = $ref->{cortosin}->[$NUMARCH];
      @extensiones = qw(ls3 log caj d par paraplot);
      foreach my $EXT (@extensiones) {
          my $next = $ref->{$EXT}; not defined $next and $next = $EXT;
          my $arch = "$guardarcortosin$next";
	  # print "ARCHB >$arch< - >$EXT< >$next< >$guardarcortosin<\n";
          system "rm $dirsal{$EXT}$arch 2>/tmp/null";
      };
      chdir $ref->{curdirori};
  } elsif ($progr{$progname} =~/[3s]/) {
      if ($progr{$progname} eq 's') {
          @extensiones = qw (sim res f simul);
      } else {
          @extensiones = qw (gra);
      };
      my $arch = $PROPIOSIN;      
      my $guardarcortosin = $ref->{GUARDARCORTOSIN};
      not $guardarcortosin and $guardarcortosin = $PROPIOSIN;
      foreach my $EXT (@extensiones) {
          my $next = $ref->{$EXT}; not defined $next and $next = $EXT;
          my $arch = "$guardarcortosin$next";
	  #print "ARCHA >$arch< >$EXT< >$next< >$guardarcortosin<>$dirsal{$EXT}<\n";
	  #print Dumper \%dirsal;
          system "rm $dirsal{$EXT}$arch 2>/tmp/null";
      };              
  };
  comfin('finA aprontar');
}#aprontar;

# ---------------------------------------------------------------------------
sub presentar_simusol{
# ojo tiene gnus

  comfin('comA presentar_simusol',@_);
  
 my ($ref,$NUMARCH,$dirsal) = @_;

  
#  impr_todo(__LINE__.' Auxi comienzo de presentar_simusol',$ref);
  my $prog = $progr{$progname}; my $pre = '';
  $prog eq 's' and $pre = $dirsal{d} or $prog eq '3' and $pre = $dirsal{paraplot}; 
  my $PROPIOSIN = $ref->{PROPIOSIN};   
  my $PROPIO = $ref->{PROPIO};
  my $BASEARCHCORTO = $ref->{BASEARCHCORTO};
  my $CORTOSIN = $ref->{CORTOSIN};
  my $CORTO = $ref->{CORTO};
  my $DATECORTO = $ref->{DATECORTO};
  if ($progr{$progname} eq '1') {
  my $CLASEARCH = $ref->{CLASEARCH};
  my $dirg = $dirguardar{$CLASEARCH};
  $ref->{DIRG} = $ref->{dirg}->{$NUMARCH} = $dirg;
  $ref->{GUARDARCORTOSIN} = $ref->{guardarcortosin}->[$NUMARCH];
  $ref->{GUARDARPROPIOSIN} = $ref->{guardarpropiosin}->[$NUMARCH];
  my $apartir = " a partir de archivo de fecha $DATECORTO";
  my $copiado = " copiado en $dirg/$PROPIO";
  $ref->{APARTIR} = $apartir; $ref->{COPIADO} = $copiado;
  my $archguardarcongnus = $ref->{CORTOSIN};
  if ($todas) {
      my $archguardar = $ref->{GUADARCORTOSIN}."_$todas";
      $archguardar=~ s/\s+/_/g;
      $archguardarcongnus =~ s/([^\/]+)$/gnus\/$1/;
  };
  $ref->{ARCHGUARDARCONGNUS} = $archguardarcongnus;
};
#  impr_todo(__LINE__.' Auxi',$ref);
  my (%nombre,%presen);
  my (%extreal);

  
  $extreal{log} = 'log'; 
  $extreal{ls3} = $ref->{ls3};
#  impr_todo(__LINE__.' Auxi',$ref);
  my ($modo,$arch);
  my %cosas = ('ls3'=>'Mensajes de',
	       'log'=>'Archivos producidos por');
  for my $EXT ('ls3','log') {
      if ($progr{$progname} eq '1') {
          $modo = '0';
      } else {
	  $modo = '1';
      };
      impr_debug(__LINE__.' Auxi $CORTO',$CORTO);
      $nombre{$EXT} = "$PROPIOSIN.$extreal{$EXT}";
      $presen{$EXT} = "=-=-$cosas{$EXT} $progname, $PROPIO, $DATECORTO";
      $presen{$EXT} .= "       con opcion -todas $todas\n"
          if $todas;
  };
#  print STDERR "                                  Voy a abrir ls3_log\n";
  
#my   ( $SALIDAls3, $SALIDAlog)=abrir_ls3_log($ref,\%dirsal);
 


 print STDERR "                                   Ya abri ls3_log\n";
  if ($progr{$progname} ne '1') {
      my $date = localtime();
      if ($progr{$progname} eq '1') {
          print $SALIDAlog
            "Archivo $dirsal{ls3}$PROPIOSIN.$ref->{ls3}  $marca_Simusol  $date\n";
 #         print $SALIDAlog 
  #          "Archivo $dirsal{log}$PROPIOSIN.log  $marca_Simusol  $date\n";
      };
      print $SALIDAlog "$presen{ls3}\n";
#      print $SALIDAlog "$presen{log}\n";
  };
  comfin('finA presentar_simusol');
  return  ;
}#presentar_simusol;













#NO USO en simplot ################################################################################
sub abrir_escr{
    my ($EXT,$archivos,$elemento,$marca,$progname,$apartir)=@_;
    #,$apartir

#  PONER $ESCR
    
# se usa para abrir archivos desde la base del diagrama 
# y que seran interpretados desde $outdir    

# abre .d .paraplot .par (parametros que no influyen en el .d)
    # NO LO USO
    
  comifin('com1 abrir_escr',@_);     
  
  my $coderr = '';

 my ($archsal,$camino1,$x2)=resolver_dir($archivos,$elemento,$EXT,'');
    creacamino($camino1,$archivos,$elemento,0);
    
 # my $archsal=File::Spec->catfile($camino,$PROPIOSIN.$EXT);
 
  impr_todo(__LINE__.' Ayud',$archsal);

  Simusol::AyudasPP::archiva($archsal,'F',$archivos,$elemento); 
  open ESCR, ">$archsal" or do{
      explic (" No pude abrir $archsal");
      $coderr = 66;
  };
  if (not $coderr) {
      print ESCR  "# Archivo $archsal; $marca ($progname)\n";
      print ESCR "$apartir\n";
#      print ESCR "#         con opcion -todas $todas\n" if $todas;
  };    
  comifin('fin1 abrir_escr $coderr',$coderr);
  return $coderr;     
}#abrir_escr


######################### DEPRECADOS

#----------------------------------------------------------------------------
#sub abrir_LSS1MAL{
    # DEPRECADO
    # reempalzado por abrir_ls3_log
# }#abrir_lss1

#####################
####### pre_parar1
####### porparar1
####### parars1
# --------------------------------------------------------------------------
sub parar1MAL{
    comfin('comfin parar1',@_);
    # $mensaje se usa para errores detectados por simusol1.pl,
    # que aun no se comunicaron;
    # otros se han comunicado por avgrav,... or porparar 
    # el codigo sera 0 (sin error para el principal) 
    # o el numero del exit
    # $archivo, si se da, es el nombre corto
    # $archivo o $mensaje $refcircuito deben estar presentes 
    #impr_debug(__LINE__.' Glob reffi ', \%reffi);
    my ($codigo,$refcircuito,$mensaje,$archivo)
           = (@_,'','');#a veces se usa sin el tercer y cuarto argumentos  
    if ($refcircuito eq '0' and not $archivo) {
        print "$mensaje\n";
        mensajear(" codigo s1: $_[0]"); 
        exit $codigo;
    } elsif ($archivo) { 
        $refcircuito = $reffi{$archivo}; 
    }; 
    my ($CORTO, ,$CORTOSIN, $PROPIO, $PROPIOSIN, $DATECORTO,$CLASE)
	= @$ref1{'CORTO', 'CORTOSIN', 'PROPIO', 'PROPIOSIN','DATECORTO'
                      , 'CLASEARCH'};
    $archivo = $CORTO; 
#    impr_datos(__LINE__.' Glob',['PARBORR'],$refcircuito);
    if ($codigo > 4 and $mensaje) {
        if ($avisosgrav) {explic($mensaje)} else {avgrav($mensaje)};
    };
    my $SI = 'SI';
    if ($codigo < 5) {$SI = 'NO';};
    explic("... $progname $SI detecto errores graves en: $archivo ($CLASE)\n");
    $reffi{$CORTO}->{errores} = 1 if $codigo > 2;
    if ($refcircuito ne '0' and $CLASE ne 'elementos') {
        my $BASE = $ref1->{BASEARCH};
        foreach my $arch (sort keys %clasearchivos) {
            impr_debug(__LINE__.' Glob $arch',$arch);
	    next if $arch eq $CORTO;
            my $CLASE = $clasearchivos{$arch}; 
            my $archm = $arch;
            if ($arch !~ /^\//) {
                $archm =$ref1->{curdirori} . $arch;
            };
            my ($basearch,$propio,$corto,$PROPIOSIN,$cortosindia) 
                = relativizar($archm,$BASE);
            next if $corto eq $CORTOA;
            my $consin = " sin";
	    if ($reffi{$arch}->{errores}) {
                $consin = " con";   
            };       
            mensajear(" $corto: ($CLASE)$consin errores");
        };#foreach $arch
    };
    if ($codigo) {
          explic('       no hay circuito para simular');
    } else {    
          explic(" $archivo: se puede intentar simularlo");  
    }; 
    
    foreach my $keysindia (keys %{$LSS1}) {
        $keysindia =~ /\s/ and error_progr(__FILE__,__LINE__.' $keysindia con espacio');
        my $refc = $reffi{$keysindia};
        my $cod = $refc->{errorparar};
        next if defined $cod and $cod eq 0; 
        # significa que no corresponde archivo .lss1 
        #impr_debug(__LINE__.' Glob $CORTOA,$keysindia,$cod'
        #      ,[$CORTOA, $keysindia,$cod]); 
        my $texto = join("\n",@{$LSS1->{$keysindia}}) . "\n";
#        open LSS1, ">>$keysindia.lss1";
        print SALIDAlog $texto;
    };
    mensajear(" codigo s1: $_[0]");
     #close SALIDAls3;
    exit $codigo; 
};#parar1 



# --------------------------------------------------------------------------
sub parar1V{
    # NO SE USA
    comfin('comfin parar1',@_);
    # $mensaje se usa para errores detectados por simusol1.pl,
    # que aun no se comunicaron;
    # otros se han comunicado por avgrav,... or porparar 
    # el codigo sera 0 (sin error para el principal) 
    # o el numero del exit
    # $archivo, si se da, es el nombre corto
    # $archivo o $mensaje $refcircuito deben estar presentes 
    #impr_debug(__LINE__.' Glob reffi ', \%reffi);
    my ($codigo,$refcircuito,$mensaje,$archivo,$archivos,$elemento)
           = (@_,'','');#a veces se usa sin el tercer y cuarto argumentos  
    if ($refcircuito eq '0' and not $archivo) {
        print "$mensaje\n";
        print $SALIDAlog "codigo s1: $_[0]\n"; 
        exit $codigo;
    } elsif ($archivo) { 
        $refcircuito = $reffi{$archivo}; 
    }; 
    my ($CORTO, ,$CORTOSINDIA, $PROPIO, $PROPIOSINDIA);
   #	= @$refcircuito{'CORTO', , 'CORTOSINDIA', 'PROPIO', 'PROPIOSINDIA'
   #                   , 'clasearch'};
   # $archivo = $CORTO; 

    my $CLASE=$refcircuito->{'clasearch'};
    
    my @parborr = sort keys %{$refcircuito->{PARBORR}};
    if (@parborr) {
	impr_datos(__LINE__.' Glob',['PARBORR'],$refcircuito);
	Simusol::AyudasPP::archiva("$CORTOSINDIA.par",'F',$archivos,$elemento); 
        open my $PARAM, ">$CORTOSINDIA.par";
        print $PARAM  '#'.'-' x 10 
	    ." Parámetros o elementos sin influencia en los calculos\n";
        print $PARAM  "#    de Sceptre, o ya sustituidos en $PROPIOSINDIA.d\n";
        foreach (sort @parborr) {
           print $PARAM "$_ = $refcircuito->{PARBORR}->{$_}\n";
        };
        close $PARAM;
        my $cuantos = scalar @parborr;
        mensaje( 
        "Hay $cuantos parámetros sin influencia en los cáculos de Sceptre o 
         ya sustituidos; verlos en $PROPIOSINDIA.par");
        explic (" ($CORTOSINDIA.par) ") if $PROPIO ne $CORTO;
    };
    if ($codigo > 4 and $mensaje) {
        if ($avisosgrav) {explic($mensaje)} else {avgrav($mensaje)};
    };
    my $SI = 'SI';
    if ($codigo <5) {$SI = 'NO';};
    explic("... $progname $SI detectó errores graves en: $archivo ($CLASE)\n");
    $reffi{$CORTO}->{errores} = 1 if $codigo > 2;
    if ($refcircuito ne '0' and $CLASE ne 'elementos') {
        my $BASE = $refcircuito->{BASEARCH};
        foreach my $arch (keys %clasearchivos) {
            my $CLASE = $clasearchivos{$arch}; 
            my $archm = $arch;
            if ($arch !~ /^\//) {
                $archm =$GlobalesSimusol::pwdori . $arch;
            };
            my ($basearch,$propio,$corto,$PROPIOSIN,$cortosindia) 
                = relativizar($archm,$BASE);
            next if $corto eq $CORTOA;
            my $consin = " sin";
	    if ($reffi{$arch}->{errores}) {
                $consin = " con";   
            };       
            mensaje(" $corto: ($CLASE)$consin errores");
        };#foreach $arch
    };
    if ($codigo) {
          explic('       no hay circuito para simular');
    } else {    
          explic(" $archivo: se puede intentar simularlo");  
    }; 


    Simusol::AyudasPP::archiva("$CORTOSINDIA.caj",'F',$archivos,$elemento); 
    open my $CAJ, ">$CORTOSINDIA.caj";
    print $CAJ 
        "#    Archivo $PROPIOSINDIA.caj   preparado por simplot.pl\n";
    if (defined $CAJAS->{$CORTO}) {
         print $CAJ "$CAJAS->{$CORTO}\n";   
    } else {
         print $CAJ "Nada para poner aquí\n";   
    }
    close $CAJ;
    foreach my $keysindia (keys %{$LSS1}) {
        $keysindia =~ /\s/ and error_progr(0,__LINE__.' Glob');
        my $refc = $reffi{$keysindia};
        my $cod = $refc->{errorparar};
        next if defined $cod and $cod eq 0; 
        # significa que no corresponde archivo .lss1 
        #impr_debug(__LINE__.' Glob $CORTOA,$keysindia,$cod'
        #      ,[$CORTOA, $keysindia,$cod]); 
        my $texto = join("\n",@{$LSS1->{$keysindia}}) . "\n";
  #     open LSS1, ">>$keysindia.lss1";
        print  $SALIDAlog $texto;
    };
    mensaje ("codigo s1: $_[0]"); 

    # close $SALIDAls3;

    exit $codigo; 
}; #parar1 

##############################################


my $outdir;

if (1==2){
  impr_debug(__LINE__.' Ayud $outdir',$outdir);  
  if (not -d $outdir) {
         
         warn " $outdir no es un directorio; no sirve para recibir archivos, lo creo";
         # verificar que la parte que pre-existe es un directorio escribible y adecuado para no hacer lio
         File::Path::make_path ($outdir,{});
  } else{
       # verificar que es un directorio escribible y adecuado para no hacer lio
  };
  
  if (-d $outdir) {
     #if (not $coderr) {
      my $owner =  `stat -c %U $outdir`; 
      chomp $owner;
      my $usted =  `whoami`;
      chomp $usted;
      impr_debug(__LINE__.' Auxi $owner,$usted',[$owner,$usted]);
      $owner eq $usted or die "    El directorio $outdir no sirve para outdir;
        pertenece a $owner y usted es $usted\n"; 
      my $attr = `stat -c %A $outdir`;
      $attr =~ /r.x$/ or die "    El directorio $outdir no sirve para outdir;
        no tiene los permisos necesarios. 
          Proponga uno adecuado con la opcion -outdir\n";
  }else{
      die "No se pudo crear outdir=$outdir\n";
  }
}  


#######################
# que paso con relatiba absoluta????
sub relativa{
    my ($archi,$rela,$noabs)=@_;
 # archivo en pwd con relacion a rela

    my $a=file($archi);


    # y si quiero relativo del absoluto???
    if ($a->is_absolute and not defined $noabs) {
         # NOTA si es absoluto y fuera del camino, copiarlo a su lugar estandar
         # y usar la copia, salvo que se diga que no como opcion

        #print "archiABS: $archi  rela:  $rela  ret: $archi\n"; 
        return $archi; 
         }
 
    my $file = file($archi);
    my $filedir = $file->parent;
    my $rel = $filedir->relative($rela);
    my $archibase= $file->basename;    
    my $archif= file($rel,$archibase);
    $archif->cleanup;
    my $RRR="$archif";
    $RRR=~s/^\.\///;
#	  $archif->resolve;

    # lo vemos en realidad?
    #print "archiREL: $archi  rela:  $rela  ret: $archif\n"; 
    return $RRR;
    }


# -----------------------------------------------------------------------------


1;
