#ayudas.pm
# son ayudas para el programador; algunas para dar informacion al programador;
# otras para que sea mas facil programar ayudas para los usuarios
package Simusol::AyudasPP;
#use warnings;
use strict;
use warnings;
use Data::Dumper;
$Data::Dumper::Sortkeys = 1;
#our $HOME = $ENV{HOME};



our $marca_Simusol =  "producido por S I M U S O L";

  use File::Path;
use File::Basename;
use Cwd;
use Getopt::Long;
use File::Spec;

# en ASUS NO ESTA
our $curdirori,
our $outdir; 

our (%progr,$progname);
our @MENSAJES;
our ($avisosgrav,$avisosnograv,$avisosnoseent);
our ($debug, $noverb, $buscar, $imprlog,$noclas);

our $presentacion;

our @extensiones = qw( sim caj d paraplot gra par gnu lsg ls3 log); #son 

# ASUS
our ($ref0,$ref1,$refs,$ref3,$reffff);
our (@opciones, $opciones);

our $todas;

my           $SALIDAlog;
my	     $SALIDAls3; 
#my           $LSS1;

#open $SALIDAls3,">zzzz";

our %dirsal;

BEGIN {
  use Exporter ();
  our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
  @ISA=qw(Exporter);
  @EXPORT=qw(
             &abrir_escr 
             &abrir_LOGPRIN           
             &abrir_ls3_log
             &avejec
             &avgrav 
             $avisosgrav 
             $avisosnograv 
             $avisosnoseent 
             &avnograv 
             &avnoseent 
             $buscar 
             &cerrar_paren 
             &closelog 
             &comas_invalidas
             &comifin
             $debug 
             &depurar_crudo
             &eco 
             *ESCR
             &existencia
             &explic 
             &hashrenglon 
             &impr 
             &impr_debug 
             &impr_hash
             &imprhash 
	     &imprhashlis
	     &impr_hashlis
             &imprhashrenglon
             &impr_hashrenglon
             $imprlog
           &impr_todo
             &interseccion_conjunto
             &juntar_por_paren 
             &juntar_por_signosf_y_paren
             &juntar_por_signos_y_paren
	     &mensaje 
             &mensajear
             @MENSAJES
             $noverb 
             &paraimpr3puntos 
             &parser
             &particion
	     &pausa 
             &pausadebug 
             &pausaver 
             $progname 
	     %progr 
	     %progr $progname $imprlog
             $ref0 
             $ref1 
             $ref3 
             $reffff
             $refs 
	     &relativizar
             &resolver_outdir
             &revisar_apareo
             &sacar_paren_ext 
             
             &simpl_directory  
             &textear_MENSAJES
             &textear_MENSAJES             
             &texto
             &transmitir
             &union_conjunto 
	    );
};
END();



our %dirsalida = (
    '' => 'cdata',
    'acs' => 'tmps',
#    'cache' => 'results',
    'log' => 'results',
    'caj' => 'tests',
    'd' => 'tmps',
    'dat' => 'cdata',
    'dirac' => 'tmps',
    'eps' => 'results',
    'for' => 'cfunctions',
    'f' => 'tmps',
    'gnu' => 'results',
    'gra' => 'scripts',
    'ini' => 'tmps',
    'ls1' => 'tmps',
    'ls2' => 'tmps',
    'ls3' => 'tests',
    'lsg' => 'tests',
    'par' => 'results',
    'paraplot' => 'tests',
    'png' => 'results',
    'res' => 'results',
    'scripts'=>'scripts',
    'sim' => 'tmps',
    'simul' => 'results',
    'txt' => 'cdata'
    );


our (%reservdir,%reservdirg);

map($reservdir{$_} = 1, values %dirsalida);
map($dirsalida{".$_"} = $dirsalida{$_},keys %dirsalida);


our $cprojects = 'cprojects'; 
our $cauxes = 'cauxes';
our %dirguardar = ('nada'=>'nothing',
		   'circuitogr'=>'noting',
		   'dibujo'=>'nothing',
		    'circuitogr'=>'nothing',
     'circuito'=>$cprojects,
     'compl'=>$cprojects,
     'complementario'=>$cauxes,
     'modelo'=>'cmodels',
     'elementos'=>'celements',
     'unidades'=>'celements'
    );
map(do{$_ ne 'nothing' and $reservdirg{$_} = 1},values %dirguardar);


# "$outdir$dsls3$basearch$propiosin.$els3";

# ---------------------------------------------------------------------------
sub inicio{
    my ($arch,$progn,$append,$presenta,$cd,$dg,$nv,$td,$od,$els3,$ref,$dirsal)=@_;

    $todas=$td;
    $outdir=$od;
    ($avisosgrav,$avisosnograv,$avisosnoseent)=(0,0,0);    
    my $datestring = localtime();
    #@months = qw( Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec );
    #@days = qw(Sun Mon Tue Wed Thu Fri Sat Sun);
    #($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime();
    #print "$mday $months[$mon] $days[$wday]\n";

    $curdirori=$cd;

    $debug = $dg; 
    $noverb = $nv;
    
    $presentacion="*x24 S i m u s o l - $datestring - $presenta";
#  print STDERR "                                  Voy a abrir ls3_log\n";
    #$LSS1=abrir_LSS1($arch,$progname,0,$presentacion);

    ($SALIDAls3, $SALIDAlog)=abrir_ls3_log($dirsal->{log},$dirsal->{ls3},'.log',$els3,
                             $ref->{PROPIOSIN},$ref->{BASEARCHCORTO},$ref->{outdir});
 

    ####abrir_ls3_log();

    # nombre del archivo en el que se graban los mensajes, nombre que 
    #identifica a quien llama, 0 sin append 1 con append
    $progname=$progn;
    $progr{$progname}=$progn;
    #print "Prese $Simusol::Ayudas::presentacion\n";
    return  ($SALIDAls3, $SALIDAlog);
}

# ---------------------------------------------------------------------------
#sub setsali{
#   my ($ls3,$log)=@_;
#  $SALIDAls3=$ls3;
#  $SALIDAlog=$log;   
#}


# ---------------------------------------------------------------------------
### la subrutina necesita;
### use File::Basename;
### use Cwd;
### use Getopt::Long;
# ---------------------------------------------------------------------------
sub desmenuzar_comando{# devuelve toda la informacion en hashes $refopt_hash y $ref
  #print STDERR ".....  comy desmenuzar_commando(@_)\n";
    
  my ($refopciones,$refextensiones,$otros) = @_;

  my $refopt_hash={};
  $refopt_hash->{d}=0;
# hacer para todos asi no queda indefindo y causa lio
  
  my $ref={};
  my $dirsalida={};
  # pretendo obligatorios y 'buenos'  los 5 argumentos de esta subrutina; pero 
  #   no recuerdo como se indica esto.
  # $refopciones: referencia a array con todas las opciones que interesan y 
  #   calificadas para GetOpt 
  # $refextensiones: referencia a array de extensiones para argumentos que inter.
  #NO $default_ext: extension para completar nombre de argumento; scalar sin '\'s

  # los argumentos pueden venir sin su extension; se refiere  parte final del
  #   nombre completo ( sin '\'s
  
  my($progname,$progpath) = fileparse($0);
  my $progdate = scalar localtime((stat "$progpath$progname")[9]);
  my $curdirori = getcwd; 
  $curdirori .= '/';
  @{$ref}{'progname','progpath','progdate','curdirori'} = ($progname,$progpath,$progdate,$curdirori);
  my $refd = {}; 
  $ref->{dirarray} = $refd;
  GetOptions($refopt_hash,@$refopciones)  or pod2usage(2);
 
  help() if defined $refopt_hash->{help};
  version() if defined $refopt_hash->{version};


  #if ( not defined $opt_hash{graf}){
  #      $opt_hash{graf}="3"
  #};  
  ########################################################################## ?

  defined $refopt_hash->{graf} and $refopt_hash->{graf} =~ /^chic/i 
    and $refopt_hash->{graf} = 5;
  if (not $refopt_hash->{graf}) {
      $refopt_hash->{graf} = 3;
  } elsif ($refopt_hash->{graf} =~ /\D/) {
      die "Opción para -graf $refopt_hash->{graf} irreconocible\n";
  };

  Simusol::PlotGNU::parar3(200,' Pidio no graficar') if $refopt_hash->{graf} eq '0';
  Simusol::PlotGNU::parar3(200,'No pidió nada') if $refopt_hash->{graf} == 0;
  
  # --------------------------------------------------------------------------
  # --------------------------------------------------------------------------
  warn ".....  com3 interpretar_opciones_3($ref1)" if $refopt_hash->{d};



  $outdir=Simusol::AyudasPP::resolver_outdir($curdirori,$refopt_hash->{outdir});


#  resolver_outdir($ref1,$opt_hash{outdir}); ######## RESOLVER
 





  

  $debug = $refopt_hash->{d}; #$debug está definida con our en Ayudas.pm


  #sale tambien en ref, pero como se lo llama aca no.

  #outdir es global y se setea en inicio tambien
  #calcular_dirsal();
  # esto parece reemplazar disal
  if ($refopt_hash->{noclas}) {
      foreach my $key (keys %$dirsalida) {
          substr($dirsalida->{$key},0,1) ne 'c' and $dirsalida->{$key} = '';
          };
      };

  $noclas = $refopt_hash->{noclas};
  
  #my $ref3 = {'curdirori' => $curdirori};
  #($coderr,$mensaje) = Simusol::AuxiliaresPP::atender_argumentos($ref3);
  #$coderr and Simusol::PlotGNU::parar3($coderr,$mensaje);
  #impr_todo(__LINE__.' sims',$ref3);
  @{$ref->{argumentos}} = @ARGV;
  my $cantarg=scalar  @ARGV;
  @{$ref->{opciones}} = keys %$refopt_hash;

  $refd->{lista}=[];
  foreach my $arg (@ARGV) {
            my ($propiosin,$basearch,$ext) = fileparse($arg,@$refextensiones,'\.[^\.]*');
            warn "ARCHIVOX $basearch $propiosin $ext \n";
            red($arg,$refd->{lista},$propiosin,$basearch,$ext,$refextensiones,$otros);  
            };
  if (scalar @{$refd->{lista}} <1 ){
     my ($ok,$file)=buscafiles($refextensiones, $refopt_hash,$progname);
     #print Dumper $file;
     foreach my $args (@$file) {
           my ($propiosin ,$basearch,$ext)=@$args;
           print "ARCHIVO Y $propiosin \n";
	   my $PROPIO=$propiosin . $ext;
           my $CORTO =  $basearch . $propiosin . $ext;
           my $DATE  = scalar localtime ((stat $CORTO)[9]);                                              
	   push @{$refd->{lista}}, [$propiosin,$basearch,$basearch.$propiosin,$ext,$CORTO,
                                    $PROPIO,$DATE,0];
                                    # 0 es otro ver si va 0 o uno  
           }
     }

  if (scalar @{$refd->{lista}} <1 ){
      warn "No hay archivos para procesar\n";  # si es debug sacar el \n
      # no salgo porque hay otras cosas para hacer como kill
      }

  #print STDERR Dumper $ref;
  #print STDERR ".....  finy desmenuzar_commando()\n";   
  return ($ref,$refopt_hash,$debug,$outdir,$dirsalida,$curdirori,$cantarg);
}#desmenuzar_comando  


######################################################################

sub red{
    my ($arg,$lista,$propiosin,$basearch,$ext,$refextensiones,$otros)=@_;

    # si existe  arg, lo usa y ya, inclusive si su extension es cualquiera o nula por archivos tipo
    # datos con cualquier extension
    my $PROPIO='';
    my $DATE='';
    my $CORTO='';
    my $si=0;
    my $esotra=1;  #si es otra extension (tipo .simul u otras), va 1 al final del array, 
    #para poder buscar adentro de los paraplot, si esta no la lista
    #
    foreach my $exto (@$refextensiones){
	  if ($ext eq $exto){
	      $si=1;
	      $esotra=0;
	    }
          }
    if ($otros){
	$si=1;
        }
    if ($arg and -e $arg and $si){
	$DATE = scalar localtime ((stat $arg)[9]);
	$PROPIO=$propiosin . $ext;
        my $CORTOSIN =  join($basearch, $propiosin);  # ES LO MISMO QUE ARG si es que arg esta
	$CORTO=$CORTOSIN.$ext;
        push @{$lista}, [$propiosin,$basearch,$CORTOSIN,$ext,$CORTO,$PROPIO,$DATE,$esotra];
	 #SOLO      #BASE     #BASE+SOLO #EXT  #BASE+SOLO+EXT #NOMBRE+EXT      
         #[$propiosin,$basearch,$CORTOSIN,   $exto,$CORTO,        $PROPIO,    $DATE,0];
	return;
    }

    #  si no es archivo y si no tiene extension pruebo con todas las extensiones por default

    # USAR JOINDIR!
    
    
    if (not $ext){
	  foreach my $exto (@$refextensiones){
          $CORTO =  
	  my $CORTOSIN =  join($basearch, $propiosin);  # ES LO MISMO QUE ARG si es que arg esta
	  $CORTO=$CORTOSIN.$exto;
          if (-e $CORTO) {            
            $PROPIO=$propiosin . $exto;
            $DATE = scalar localtime ((stat $CORTO)[9]);
#                            propiosin basearch  cortosin            ext   corto  propio  date
	    push @{$lista}, [$propiosin,$basearch,$CORTOSIN,$exto,$CORTO,$PROPIO,$DATE,0];
	    }
	  }           
    }else{
	warn "No encontro el archivo $arg\n";
    }

    #      
}

###################################################################

use File::Find;
use Cwd qw(cwd);
# for example let location be tmp



my @fil=();
sub find_txt {
    my $F = $File::Find::name;
    foreach my $ext (@$main::refextensiones){   ################### GLOBAL
	if ($F =~ /$ext$/ ) {
	    $F=~s/^\.\///;
            #print "$F\n";
	    push(@fil,[$F,$ext]);
    }}
}


sub buscafiles{
    my ($ext, $refopt_hash,$progname)=@_;
    my @files;
    my $ok=0;
    my $nea;
    my $ee;
    #   if (not scalar  @files){

    my $location=cwd();
    #cwd will return the symbolic link (the logical path to where we are) 
    #getcwd will resolve the symbolic link and return the real directory (the hard link) of where we are. 
    find({ wanted => \&find_txt, no_chdir=>1}, $location);
    print "FIL@fil\n";
    foreach (@fil){
           my ($n,$d,$e)=fileparse($_->[0],$_->[1]); #se podria no usar y separar con la exp regular y el filefind
           print "NEA $_ - $d - $n - $ee\n";
           push (@files ,[$n,$d,$e]);
           }
    

    
    #foreach my $ee (@$ext){	
    #   my $eee=$ee;
    #   $eee=~s/^\.//; 
    #   ($ok,$nea) = Simusol::AuxiliaresPP::elegir_archivos($eee, $refopt_hash,$progname);
    #   #print "BUSCA $ee @$nea\n";    
    #   foreach (@$nea){
    #       my ($n,$d,$e)=fileparse($_,$ee);
    #       print "NEA $_ - $n - $ee\n";
    #       push (@files ,[$n,$d,$e]);
    #       }
    #   }    
return (1,[@files]);

}   

# -------------------------------------------------------------------------
sub relativizar{
    

    # deprecado
   
 
  comifin('comy relativizar',@_);
  #se espera nombre completo para $pwd, con su barra final;
  my ($archivo,$pwdreal) = @_;
  $archivo = "$pwdreal$archivo" if $archivo !~ /^\//;
  my $POSABSOLUTO = simpl_archivo($archivo);
  impr_debug(__LINE__.' Ayud $archivo,$POSABSOLUTO',[$archivo,$POSABSOLUTO]); 
  $pwdreal =~ /^\/.+\/$/ or die "ERROR de programa ".__LINE__." Ayud\n";
  my ($BASEARCH,$PROPIO1,$PROPIO,$CORTO,$PROPIOSIN, $CORTOSIN,$BASEARCHCORTO,
      $ABSOLUTO,$ABSOLUTOSIN,$puntoext);
  if ($POSABSOLUTO =~ /^(.*)(\.\w+)/) {
      $puntoext = $2;
      $ABSOLUTOSIN = $1;
  } else {
      $puntoext = '';
      $ABSOLUTOSIN = $POSABSOLUTO;
  };    
  if ($ABSOLUTOSIN =~ /(.*\/)([^\/]*)$/) {
       $BASEARCH = $1;
       $PROPIOSIN = $2;
  };# no se da el else al ser $ABSOLUTO nombre absoluto
  my $largopwd = length ($pwdreal); my $largoBASEARCH = length $BASEARCH;
  if ($largoBASEARCH >= $largopwd) {
      my $comi = substr($BASEARCH,0,$largopwd);
      if ($comi eq $pwdreal) {
          $BASEARCHCORTO = substr($BASEARCH,$largopwd);
          $CORTOSIN = substr($ABSOLUTOSIN,$largopwd);
      } else {    
          $BASEARCHCORTO = $BASEARCH;
          $CORTOSIN = $ABSOLUTOSIN;
      };
  } else {
      $BASEARCHCORTO = $BASEARCH;
      $CORTOSIN = $ABSOLUTOSIN;
  };
  comifin('finy relativizar,$BASEARCH,$BASEARCHCORTO, $PROPIOSIN, $CORTOSIN,
           $ABSOLUTOSIN,$puntoext',
	  $BASEARCH,$BASEARCHCORTO,$PROPIOSIN, $CORTOSIN,$ABSOLUTOSIN,$puntoext);
  return $BASEARCH,$BASEARCHCORTO,$PROPIOSIN,$CORTOSIN,$ABSOLUTOSIN,$puntoext;
}#relativizar


# ---------------------------------------------------------------------------
sub comfin{ #uso comfin('com xxxxxx', @_)   o comfin('fin xxxxxx', @_)
  # o comfin('fin xxxxxx', @_,$lisque,$ref,'impr')
  # o comfin('fin xxxxxx',,$lisque,$ref,'impr')
  # 'impr' para que llame a impr_datos con $lisque y $ref
  return ''  unless $debug;
  my @viene = @_;
  my $primera = shift @viene; my $cosa = ''; @viene and $cosa = $viene[0];
  my @refarchers =  @Simusol::Globales::refarchers;
  my @refgrafers =  @Simusol::Globales::refgrafers;
  my @reflayers =  @Simusol::Globales::refgrafers;
  if ($cosa) {
      if ($cosa =~ /^HASH/) {
          my @caliscosa;
          if ($cosa->{ARCHIVOCAPA}) {
              push @caliscosa, 'reflay';
	      print STDERR "parece reflay\n";
          };
          if ($cosa->{numfile} and $cosa->{capas}) {
              push @caliscosa, 'refarch';
              print STDERR "parece refarch\n";
          };
          if ($cosa->{hashclasegr}) {
              push @caliscosa, 'refgraf';
              print STDERR "parece refgraf\n"
          };
          if ($cosa->{numobj} and $cosa->{numcapa}) {
              push @caliscosa,'refcuadro';
	      print STDERR "parece refcuadro\n";
          };
          @caliscosa >1 and do {
            print STDERR ' @caliscosa ',__LINE__,' Ayud ' ,"@caliscosa\n";
          };
      };
  };
  my @simplif;
  foreach(@viene) {
#    impr_debug(__LINE__.' Ayud @viene',Dumper \@viene); 
     my $nuevo;
      my $texto = $_;
      if (not defined $texto) {
          $nuevo = 'no definido';
      } elsif ($texto =~   /^(ARRAY|HASH|SCALAR)\(/) {
          if ($texto =~ /^ARRAY\(/) { 
              my @lisundef = @$_; @lisundef = grep(do{not defined $_},@lisundef);
              if(@$_>8) {
                 $nuevo = 'ARRAY (' . scalar (@$_) . ')'    
              } elsif (@lisundef) {
                 $nuevo = 'ARRAY (' . scalar (@$_) . ' con undef)'
	      } else {
                 $nuevo = "[@$_]";
              }
          } elsif ($texto =~ /^HASH\(/) {
              $nuevo = 'HASH (' . scalar (keys (%$_ )) . ')'; 
 	      if (defined $_->{CORTOSIN}) {
	          $nuevo .= " - (($_->{CORTOSIN})): ";
              } elsif ($_->{numfile}) {
 	          my @refarchers = @Simusol::Globales::refarchers;
                  if (defined $refarchers[$_->{numfile}] and
                      defined $refarchers[$_->{numfile}]->{CORTOSIN}) { 
                      $nuevo .= 
                      " - ((capa de $refarchers[$_->{numfile}]->{CORTOSIN})): ";
                  };
              };
          } elsif ($texto =~ /^SCALAR\(/) {
	      $nuevo = 'SCALAR (' . length($$_) . ')';
          };
      } else {
          ($nuevo = $texto) =~ s/^\s*//;
          if ($nuevo eq '') {
              $nuevo = 'blanco';
          } elsif (length $nuevo < 16) {
          } elsif($nuevo =~ /^\//) {
              my $largo = length $nuevo; my $comi = $largo - 15;
              $nuevo = '...'. substr($nuevo,$comi); 
          } elsif (length $nuevo > 24) {
              $nuevo = substr($nuevo,0,24) .'...';
          };
          if ($texto =~ /,/) {
              $nuevo .= 'con comas';
          };
      };
      push @simplif, $nuevo;
  };
  my ($donde,$comfin);
  if ($_[0] =~ /^\s*(\w+)\s+(\S\w*)/){
     ($donde,$comfin) = ($1,$2);
    if (@_ >3 and defined $_[-1] and defined $_[-2] 
         and $_[-1] eq 'impr' and  $_[-2] =~ /HASH\(/ ) {
            impr_datos(
            "para $comfin pide comfin",['DATOS','PARAMETROS','INICIALES']
		  ,$_[-2]);
     };
  };
  eco(" $_[0](" . join(',',@simplif). ')'); #para comfin
  return '';
}#comfin

# ---------------------------------------------------------------------------
sub mensajear{

    #escribe lista de mensajes en la salida, mensaje es un solo mensaje, este es una lista
    
#  comifin('com mensajear',@_);
  if (@_ != 1) {
      die "mensajear no tiene 1 argumento
          @_"
  };
  my $agre = ' _ _ _ _ '; 
  if ($debug) {
     print STDERR "$agre$_[0]\n";
  } else {
      print "$agre$_[0]\n";
  };
  no warnings;
  if (tell($SALIDAls3)) {
     print $SALIDAls3 "$_[0]\n"
  };
}#mensajear
# ---------------------------------------------------------------------------
sub mensaje{
  if (@_ != 1) {
      die "mensaje no tiene 1 argumento
          @_"
  };
  if ($debug) {
      print STDERR  "$_[0]\n";
  } else {    
      print     "$_[0]\n";
  };    
  print $SALIDAls3 "$_[0]\n";
}

##########################################################################################

sub imprhash{
  my ($identy, @hash)=@_; my ($impr, $largo);
  my $cuantos = scalar @hash; 
  if (($cuantos % 2) ) {#numero impar de valores
     $impr = pop(@hash);
     $largo = $impr;    
  } else {    
     $impr = 0;
     $largo = length($identy) + 1; # en imprhash 
  }; 
  my %hash = @hash;    
  my $texto ='';     
  foreach my $uno (sort keys %hash){
     $texto .= sprintf "%1s",  (' ' x $largo) . "$uno => $hash{$uno}\n"; 
  };
  if ($impr) {
     return $texto;
  } else {
     print "$identy --- hash: ",scalar keys %hash," ---\n";
     print "$texto\n";   
  }; 
}
#---------------------------------------------------------------------------

sub impr{
  #imprime elementos de una lista dada por sí
  my ($identy,@lista) = @_;my $largo = length($identy) + 1; # en impr
  if (@lista) {
   print "$identy --- array: ",scalar @lista," ---\n";
   foreach (@lista){
      print ' ' x $largo; 
      if (defined){ print $_,"\n"
      } else {print " undef\n"
      }
   }
  } else {print $identy,"\n";
  }
}
#---------------------------------------------------------------------------
sub imprhashrenglon{  ########### OJO hay hash_renglon
   #imprime un hash dado por sí, todo en un renglón y sin identificación
   my ($mensaje, %hash)=@_;
   print "$mensaje ";
   if (@_) {
      map((print "$_=>$hash{$_};   "),sort keys %hash)  
   } else {
      print '(vacio)'
   };   
   print "\n"  
}

# ---------------------------------------------------------------------------
sub parary{
    # para salir
  my ($codigo,$mensaje) = @_;
  print STDERR "$mensaje\n" if $mensaje;
 # print STDERR ' ' x 30,"Salgo de $progname con $codigo\n";
 # print ' ' x 30,"Salgo de $progname con $codigo\n";
  exit $codigo;
}#parary


# --------------------------------------------------------------------------- ASUS
sub abrir_escr{
# se usa para abrir archivos desde la base del diagrama 
# y que seran interpretados desde $outdir    

# abre .d .paraplot .par (parametros que no influyen en el .d)
    # NO LO USO
    
  comifin('com1 abrir_escr',@_);     
  my ($ref,$ext,$refdirsal,$refdirguardar,$marca) = @_; my $coderr = '';
  impr_debug(__LINE__.' Ayud $refdirsal',Dumper $refdirsal);
  impr_debug(__LINE__.' Ayud $refdirguardar',Dumper $refdirguardar);
  impr_todo(__LINE__.' Ayud',$ref);
  my ($ls3,$NUMARCH) = ($ref->{ls3},$ref->{NUMARCH});;
  my ($corto,$cortosin,$propiosin,$basearchcorto) = 
     ($ref->{CORTO},$ref->{CORTOSIN},$ref->{PROPIOSIN}, $ref->{BASEARCHCORTO});
  my $clasearch = $ref->{CLASEARCH};
  my $archsal = "$basearchcorto$refdirsal->{$ext}$propiosin.$ext";
  my $dirg = $refdirguardar->{$clasearch};
  my $apartir = "#   $ref1->{APARTIR}";
  open ESCR, ">$archsal" or do{
      explic (" No pude abrir $archsal");$coderr = 66;
  };
  if (not $coderr) {
      print ESCR  "# Archivo $archsal; $marca ($progname)\n";
      print ESCR "$apartir\n";
      print ESCR "#         con opcion -todas $todas\n" if $todas;
  };    
  comifin('fin1 abrir_escr $coderr',$coderr);
  return $coderr;     
}#abrir_escr     
#----------------------------------------------------------------------------
sub abrir_ls3_log{ # llama presentar_simusol en AUXILIARES_PP

    # ls3 va a ser los mensajes de todo el simusol
    # lss1 es por ahora para todo el simusol con noclas, en el futuro DEPRECADo
    
  comifin('comy abrir_ls3_log',@_);
  # la apertura vale para el programa (y subrutinas) que la hizo, no 
  # para otros programas, 
  #    pero no se interrumpe por error; solo hay aviso

  my ($dslog,$dsls3,$elog,$els3,$propiosin,$basearchcorto,$outdir) = @_; 
  impr_debug(__LINE__.' Ayud',[$propiosin,$els3]);
  my $modo = '1';
  $progr{$progname} eq '1' and $modo = 0;
  
  my $archls3 = "$outdir$dsls3$propiosin.$els3";
  my $archlog = "$outdir$dslog$propiosin.$elog";
  print " >$outdir<>$basearchcorto< >$dsls3< >$propiosin<  >$els3<\n";
  print " >$outdir<>$basearchcorto< >$dslog< >$propiosin<  >$elog<\n";
  if ($modo) {
     open($SALIDAls3, ">>",$archls3) or  die " $progname no pudo  escribir >> $archls3";
     open($SALIDAlog, ">>",$archlog) or  die " $progname no pudo  escribir >> $archlog";
  }else{   
     open($SALIDAls3, ">",$archls3) or  die " $progname no pudo  escribir > $archls3";
     open($SALIDAlog, ">",$archlog) or  die " $progname no pudo  escribir > $archlog";
     };
  comifin('finA abrir_ls3_log');
  return ( $SALIDAls3, $SALIDAlog);
  exit;
}#abrir_ls3_log
#----------------------------------------------------------------------------
sub abrir_LSS1MAL{

    # DEPRECADO
    
  my ($nombrelss1,$progname,$modo) = @_;
  #impr_debug(__LINE__.' Ayud abrir_LSS1',[$nombrelss1,$progname,$modo]);
  # la apertura vale para el programa (y subrutinas) que la hizo, no 
  # para otros programas, 
  #    pero no se interrumpe por error; solo hay aviso
  # si el tercer argumento es true, abre para append
  my $LSS1;
  if ($modo) {
      open $LSS1, ">>$nombrelss1.lss1"; #ya otro escribio antes 
  } else {
      open $LSS1,">$nombrelss1.lss1"  
        or die 
         " Parece que Ud. no tiene permisos para crear archivo $nombrelss1.lss1
        en ese directorio;  asi no puede trabajar simusol\n";
      print $LSS1 "$presentacion";
  };
  return $LSS1;
}#abrir_lss1

# ---------------------------------------------------------------------------
sub avejec{; # AVISO DE ERROR EJECUCION
  propio("ERROR DE EJECUCION", $_[0]);
}#avejec
# ---------------------------------------------------------------------------
sub avgrav{$avisosgrav++;
	   propio("ERROR GRAVE", $_[0]);
}#avgrav
# ---------------------------------------------------------------------------
sub avnograv{$avisosnograv++;
  propio("ERROR NO GRAVE?", $_[0]);
}#avnograv
# ---------------------------------------------------------------------------
sub avnoseent{$avisosnoseent++;
  # uso avisosnoseent(xxx1):
  #    xxx1: mensaje del aviso;
  #    se cuentan.      
  propio("ERROR NO SE ENTIENDE", "$_[0]\n                 se ignora");
}#avnoseent
# ---------------------------------------------------------------------------
sub cerrar_paren{
  # recibe un string y lo devuelve partido en dos (la concat. de los dos es
  # el de entrada;
  # si no comienza con parentesis el primero es vacio
  # si comienza con parentesis el primero termina al cerrarse el parentesis
  #    o al acabar... en cuyo caso se le agrega un # al final y 
  # devuelve un tercero 'error' 
  # el segundo queda con el resto, que puede ser vacio.
  # asi que si el primero no es vacio y no termino con parentesis 
  # es porque  no pudo cerrarlo  
  my $dato = $_[0]; 
  if ($dato !~ s/^\s*\(//) { return ('',$dato) };    
  my @liscar  = split '', $dato;  
  my $abre = 1; my $out1 = '(';
  while (@liscar) {
      $_ = shift @liscar;
      $out1 .= $_;
      if ($_ eq '(') {$abre++
      } elsif ($_ eq ')') {
          $abre--;
          $abre == 0 and last;
      };
  };
  my $out2 = join '',@liscar;
  $abre > 0 and $out1 .= '#' and return ($out1,$out2,'error');
  return ($out1,$out2);
}#cerrar_paren
# ---------------------------------------------------------------------------
sub comas_invalidas{
    # saca comas repetidas o al vicio
  #detecta subexpresiones listas que no son argumentos de funcion
  #simplifica las que no molestan ....
  my $expre = 'lista'.$_[0]; #para que no moleste una lista pura
  (my $coderr,my @lista) = juntar_por_paren(',',split /\s*\,\s*/, $expre);
  @lista > 1  and return 1;
  while ($expre ne '' and $expre =~ s/(\w+)\s*\([^\(\)]+\)/$1/) {
  }; #elimino todas las posibles llamadas a funciones
  if ($expre =~ /\([^\(\)]+\,[^\(\)]+\)/) {return 1};
  return ''
}#comas_invalidas   
# ---------------------------------------------------------------------------
# es como el comfin de GlobalesSimusol.pm pero sin lo del 'impr'
sub comifin{ #uso comifin('com xxxxxx', @_)   o comifin('fin xxxxxx', @_)
  # o comifin('fin xxxxxx', @_,$lisque,$ref,'impr')
  # o comifin('fin xxxxxx',,$lisque,$ref,'impr')
  # 'impr' para que llame a impr_datos con $lisque y $ref
  return ''  unless $debug;
  my @viene = @_;
  my $primera = shift @viene; my $cosa = ''; @viene and $cosa = $viene[0];
  if ($cosa) {
      if ($cosa =~ /^HASH/) {
          my @caliscosa;
          if ($cosa->{NUMARCHIVOCAPA}) {
              push @caliscosa, 'reflay';
	      print STDERR "parece reflay\n";
          };
          if ($cosa->{numfile} and $cosa->{cuantas_capas}) {
              push @caliscosa, 'refarch';
              print STDERR "parece refarch\n";
          };
          if ($cosa->{hashclasegr}) {
              push @caliscosa, 'refgraf';
              print STDERR "parece refgraf\n"
          };
          if ($cosa->{numobj} and $cosa->{numcapa}) {
              push @caliscosa,'refcuadro';
	      print STDERR "parece refcuadro\n";
          };
          @caliscosa >1 and do {
            print STDERR ' @caliscosa ',__LINE__,' Ayud ' ,"@caliscosa\n";
          };
      };
  };
  my @simplif;
  foreach(@viene) {
     my $nuevo;
      my $texto = $_;
      if (not defined $texto) {
          $nuevo = 'no definido';
      } elsif ($texto =~   /^(ARRAY|HASH|SCALAR)\(/) {
          if ($texto =~ /^ARRAY\(\w*\)$/) { 
              my @lisundef = @$_; @lisundef = grep(do{not defined $_},@lisundef);
              if(@$_>8) {
                 $nuevo = 'ARRAY (' . scalar (@$_) . ')';   
              } elsif (@lisundef) {
                 $nuevo = 'ARRAY (' . scalar (@$_) . ' con undef)'
	      } else {
                 $nuevo = "[@$_]";
              }
          } elsif ($texto =~ /^HASH\(\w*\)$/) {
              $nuevo = 'HASH (' . scalar (keys (%$_ )) . ')'; 
 	      if (defined $_->{CORTOSIN}) {
	          $nuevo .= " - (($_->{CORTOSIN})): ";
#              } elsif ($_->{numfile}) {
# 	          my @refarchers = @Simusol::GlobalesSimusol::refarchers;
#                  if (defined $refarchers[$_->{numfile}] and
#                      defined $refarchers[$_->{numfile}]->{CORTOSIN}) { 
#                      $nuevo .= 
#                      " - ((capa de $refarchers[$_->{numfile}]->{CORTOSIN})): ";
#                  };
              };
          } elsif ($texto =~ /^SCALAR\(\w*\)$/) {
	      $nuevo = 'SCALAR (' . length($$_) . ')';
          };
      } else {
          ($nuevo = $texto) =~ s/^\s*//;
          if ($nuevo eq '') {
              $nuevo = 'blanco';
          } elsif (length $nuevo < 16) {
          } elsif($nuevo =~ /^\//) {
              my $largo = length $nuevo; my $comi = $largo - 15;
              $nuevo = '...'. substr($nuevo,$comi); 
          } elsif (length $nuevo > 24) {
              $nuevo = substr($nuevo,0,24) .'...';
          };
          if ($texto =~ /,/) {
              $nuevo .= 'con comas';
          };
      };
      push @simplif, $nuevo;
  };
  my ($donde,$comifin);
  if ($_[0] =~ /^\s*(\w+)\s+(\S\w*)/){
     ($donde,$comifin) = ($1,$2);
    if (@_ >3 and defined $_[-1] and defined $_[-2] 
         and $_[-1] eq 'impr' and  $_[-2] =~ /HASH\(/ ) {
            impr_datos("para $comifin pide comifin",['DATOS','PARAMETROS','INICIALES']
		  ,$_[-2]);
     };
  };
  eco(" $_[0](" . join(',',@simplif). ')'); #para comifin
  return '';
}#comifin
# ---------------------------------------------------------------------------
sub depurar_crudo{
   # depura los cuadros del dia
    
  # depura a $crudo que  supone es un texto formado de varios renglones;
  # eliminando comentarios (desde un #)
  # y limpia espacios al comienzo y al final
  # devuelve lista de renglones depurados
  my $crudo =$_[0];
  #print  __LINE__ . " Ayud crudo $crudo\n";
  my @listain = split "\n", $crudo; my @listaout =();
  foreach (@listain) {
      #tr/\t/ /; #sustituye  tabuladores por espacios; ya estan dentro de \s
      s/\#.*//g; #quita comentarios
      next if /^\s*$/;
      s/^\s+//;
      s/\s+$//;
      push @listaout, $_;
  };
  return @listaout;
}#depurar_crudo
# ---------------------------------------------------------------------------
sub eco{
   # parecido al explic pero va a dos lados STDERR STDOUT 
  return if $noverb and not defined $_[0];
  #para indicar que esta haciendo simusol; para depurar
  print        "..... $_[0]\n"; 
  print STDERR "..... $_[0]\n"; 
  #si se usa > o 2> quedan separados
}#eco
# ---------------------------------------------------------------------------
sub existencia{
  # DEPRECADO
    
  comifin('comy existencia',@_);# si el $puntoext es .dia se controla que sea diagrama
  my ($ref,$puntoext,@dirdato) = @_; my ($coderr,$mensaje) = ('','');
  my $dir = $ref->{curdirori}; my @dirdatosin; 
  foreach my $arch (@dirdato) {
      (my $archsin = $arch) =~ s/\.[^\/\.]*$//;
      $archsin !~ /^\// and $archsin = "$dir$archsin";
      push @dirdatosin, $archsin;
  };
  @dirdatosin = union_conjunto(@dirdatosin); my (@archivos,@archivossin);
  foreach my $archsin (@dirdatosin) {    
      if (-e $archsin and not -d $archsin and not -e "$archsin$puntoext") {
          push @archivos,$archsin;
          push @archivossin,$archsin;
      };         
      if (-e "$archsin$puntoext" and not -d "$archsin$puntoext" and
            not -e $archsin) { 
          push @archivos,"$archsin$puntoext";
          push @archivossin,$archsin;
      };
      if (-e "$archsin$puntoext" and -e $archsin) {
          $coderr = 250; $mensaje = " Existen archivos
             $archsin$puntoext  y  $archsin
                Asi no puede trabajar Simusol"; 
      };
  };#foreach
  if (not $coderr) {
      impr_debug(__LINE__.' Ayud',\@archivos);
      if (@archivos == 0) {
          $coderr = 250; $mensaje = "No han quedado archivos para procesar";
      };
  };
  if (not $coderr) {      
      if ($puntoext eq '.dia') { 
          for (my $i = 0;  $i < @archivos; $i ++) {
              my $arch = $archivos[$i];
	      next if not system "grep dia:diagram $arch >/tmp/null";
	      system "zcat $arch > gnus/llll 2>/tmp/null";
              next if not system "grep dia:diagram  gnus/llll >/tmp/null";
	      $archivos[$i] = undef; $archivossin[$i] = undef;
          };
      };	    
      @{$ref->{absoluto}} = grep ($_,@archivos);
      @{$ref->{absolutosin}} = grep ($_,@archivossin);	  
      impr_debug(__LINE__.' Ayud $ref->{absoluto}',$ref->{absoluto});
  };    
  comifin('finy existencia,$coderr,$mensaje',$coderr,$mensaje);
  return $coderr,$mensaje;    
}#existencia;    
# ---------------------------------------------------------------------------
sub explic{
    # imprime mensaje para explicar va STDOUT
  return if $noverb;   
  if (@_ != 1) {
      die "explic no tiene 1 argumento
          @_"
      };
    # para que sirva de ayuda al usuario; no va al archivo lss1
    print        "........ $_[0]\n";
}#explic
#----------------------------------------------------------------------------
sub hashrenglon{
  #para un hash dado por si, forma un renglon ...
  my ($mensaje, %hash)=@_;
  my $texto = "$mensaje ";
  if (@_) {
     map(do{$texto .= "$_=>$hash{$_}; "},sort keys %hash);  
  } else {
      $texto .= '(vacio)';
  };   
  return "$texto\n";  
}#hashrenglon
# ---------------------------------------------------------------------------
sub impr_todo{
  comifin('comy impr_todo',@_);
  return unless $debug;  
  my ($mensaje,$ref)= @_;
  print STDERR " Empieza impr_todo $mensaje (ref$progr{$progname})\n";
  if ($ref->{dirarray}) {
      print STDERR " dirarray: ",scalar @{$ref->{dirarray}};
      if (@{$ref->{dirarray}} == 1) {
	  print STDERR " archivo: $ref->{dirarray}->[0]\n";
      } else {
          print STDERR " archivos\n";
      };
  };	  
  foreach my $palabra (qw(juntos curdirori outdir outdirfinal APARTIR 
    ARCHGUARDARCONGNUS ABSOLUTO ABSOLUTOSIN BASEARCHCORTO CLASEARCH CORTO CORTOSIN
    DATECORTO DIRG MUTUODIR NUMARCH PROPIO PROPIOSIN GUARDARCORTOSIN ls3 PUNTOEXT)) {
      print STDERR " $palabra $ref->{$palabra}\n"
        if defined $ref->{$palabra};
  };
  foreach my $palabra (qw(absoluto absolutosin basearch basearchcorto
    corto cortosin guardarcortosin propio propiosin clasearch datecorto puntoext
    codigo_1 codigo_s codigo_3)) {
#     print STDERR " $palabra ",paraimpr3puntos(60,@{$ref->{$palabra}}),"\n"
#	 if $ref->{$palabra};
     print STDERR " $palabra: @{$ref->{$palabra}}\n"
	 if $ref->{$palabra};
   };    
  print STDERR " Termina impr_todo $mensaje\n";
  comifin('finy impr_todo');
  return;
}#impr_todo
# ---------------------------------------------------------------------------
sub impr_hash{
  my ($identy, @hash)=@_; my ($impr, $largo);
  my $cuantos = scalar @hash; 
  if (($cuantos % 2) ) {#numero impar de valores
     $impr = pop(@hash);
     $largo = $impr;    
  } else {    
     $impr = 0;
     $largo = length($identy) + 1; # en impr_hash 
  }; 
  my %hash = @hash;    
  my $texto ='';     
  foreach my $uno (sort keys %hash){
     $texto .= sprintf "%1s",  (' ' x $largo) . "$uno => $hash{$uno}\n"; 
  };
  if ($impr) {
     return $texto;
  } else {
     print "$identy --- hash: ",scalar keys %hash," ---\n";
     print "$texto\n";   
  }; 
}#impr_hash
#---------------------------------------------------------------------------
sub impr_{
    # DEPRECADO
    
  #imprime elementos de una lista dada por si
  my ($identy,@lista) = @_;my $largo = length($identy) + 1; # en impr_
  if (@lista) {
   print "$identy --- array: ",scalar @lista," ---\n";
   foreach (@lista){
      print ' ' x $largo; 
      if (defined){ print $_,"\n"
      } else {print " undef\n"
      }
   }
  } else {print $identy,"\n";
  }
}#impr_
# ---------------------------------------------------------------------------
sub impr_debug{
  return unless $debug;
  if (@_ != 2) {
      die "impr_debug no tiene dos argumentos
          @_"
      };
  my ($mensaje,$cosa) = @_;
  my $texto = 'impr_debug ';
  $texto .= "$mensaje " if defined $mensaje;
  if (not defined $cosa) {
      $texto .=" no definido\n";    
  } elsif ($cosa =~ /^ARRAY\(/) {
      my $cosa1; @$cosa1 = @$cosa; 
      map(do{not defined $_ and $_ ='no definido' or
             $_ !~ /\S/ and $_ = 'blancos'},@$cosa1);
      $texto .= 'array ('.join (",", @$cosa1).")\n";	       
  } elsif ($cosa =~ /^HASH\(/) {
      my @lista; 
      foreach my $key (keys %$cosa){
          my $algo = $cosa->{$key}; defined $algo or $algo = 'undef';
          push @lista, "$key=>$algo";
      }; 
      $texto .= 'hash (' . join (',',@lista) .")\n";
  } elsif ($cosa =~ /^SCALAR\(/) { 
      $texto .=  "( escalar )$$cosa\n";
  } else { 
      $texto .= "$cosa\n";
  }; 
  print STDERR $texto;
}#impr_debug    
#---------------------------------------------------------------------------
sub impr_hashrenglon{
   #imprime un hash dado por si, todo en un renglon y sin identificacion
   my ($mensaje, %hash)=@_;
   print "$mensaje ";
   if (@_) {
      map((print "$_=>$hash{$_};   "),sort keys %hash)  
   } else {
      print '(vacio)'
   };   
   print "\n"  
}#impr_hashrenglon

# ---------------------------------------------------------------------------
sub interseccion_conjunto{
  # Dadas dos referencias a listas devuelve otra  con los elementos comunes
  # es mas eficiente si en la primera no hay elementos repetidos
  my ($lista1,$lista2) = @_;
  my %hash;
  foreach my $ele (@$lista1) {
      map(do{$_ eq $ele and $hash{$_}= 1},@$lista2);
  };  
  return keys %hash
}#interseccion_conjunto
# ---------------------------------------------------------------------------
sub juntar_por_paren{
    # buscar parentesis de cierre en listas de expresiones
  my ($pega,@listain) = @_; 
  my @listaout = ();
  my ($abre, $cierra, $ant, $coderr) = (0, 0, '', '');
  foreach(@listain) {
      $ant .=  "$_$pega" ;
      $abre = ($ant =~ tr/\(//); $cierra = ($ant =~ tr/\)//);
      if ($abre < $cierra) {
          avgrav ("Expresion con parentesis ')' no apareados:\n  $_");
          return 68;    
      } elsif ( $abre == $cierra) {
          $ant =~ s/$pega$//;push(@listaout,$ant); 
          $ant = ''; $abre = 0; $cierra = 0;;
      } 
  }; #@listain
  $ant =~ s/$pega$// if $ant ne '';
  if ($abre > $cierra) {
      avgrav ("Expresion con parentesis '(' no apareado:\n  $ant");
      return 69;
  };
  return $coderr,@listaout;    
}#juntar_por_paren
# ---------------------------------------------------------------------------
sub juntar_por_signos_y_paren{
    # para analizar cuadros, y ver cortes de renglones

  my ($pega,@listain) = @_; my @listaout = (); my $ant = '';
  my $juntado = join ("\n",@listain);
  #para juntar renglones : no 'pueden' comenzar con +-*/=\)
  #no  'pueden' terminar con \(ni con =; 
  #un renglon con = no inicial no se junta con el anterior, aunque quede
  #con parentesis u operaciones pendientes
  # los parentesis se tratan algebraicamente
  $juntado =~      s/([\,\+\-\*\/\=\(])\s*\n/$1 /g; # signos finales
  $juntado =~ s/\n\s*([\,\+\-\*\/\=\)])/ $1/g; # signos iniciales
  @listain = split ("\n",$juntado);
  my ($abre, $cierra) = (0,0);
  foreach(@listain){
      if ($ant eq '') {
          $ant = $_;
      } elsif (/^\s*\S.+=/) {
          do{push(@listaout,$ant); $ant = $_};#puede salir con parentesis mal
      } else {
          $ant .= $pega . $_;#le saque la ,
      };
      $abre = ($ant =~ tr/\(//); $cierra = ($ant =~ tr/\)//);
      #print 'Ayud ' . __LINE__ . " abre $abre cierra $cierra ant $ant \n";
      do {push(@listaout,$ant); $ant = ''} 
          if ($abre == $cierra );
  }; #@listain
  push(@listaout,$ant) if $ant ne  '';
  return (@listaout)    
}#juntar_por_signos_y_paren
# ---------------------------------------------------------------------------
sub juntar_por_signosf_y_paren{
    # para analizar cuadros, y ver cortes de renglones
    
  my (@listain) = @_; my @listaout = (); my $ant = '';
  my $juntado = join ("\n",@listain);
  # no  'pueden' terminar con ,;
  # y se intentan parentesis apareados 
  # con parentesis u operaciones pendientes
  # los parentesis se tratan algebraicamente
  $juntado =~      s/([\,\+\-\*\/\=])\s*\n/$1/g; # , finales
  @listain = split ("\n",$juntado);
  my ($abre, $cierra) = (0,0);
  foreach(@listain){
      next unless $_; 
      $ant .= $_; 
      $abre = ($ant =~ tr/\(//); $cierra = ($ant =~ tr/\)//);
      #print 'Ayud ' . __LINE__ . " abre $abre cierra $cierra ant $ant \n";
      do {push(@listaout,$ant); $ant = ''} 
          if ($abre <= $cierra );#puede haber errores que se detectaran despues
  }; #@listain
  push(@listaout,$ant) if $ant ne  '';
  return (@listaout)    
}#juntar_por_signosf_y_paren 
# ---------------------------------------------------------------------------

#----------------------------------------------------------------------------
sub paraimpr3puntos{
    # lista larga imprime el comienzo, y agrega ...
  my ($largo,@lista) = @_;my $dato = join(' ',@lista);
  length($dato) < $largo or  $largo < 5  # en paraimpr3puntos
    or $dato = substr($dato,0,$largo - 4) . '...';
  return $dato;
}#paraimpr3puntos
# ---------------------------------------------------------------------------
sub parser{
 # analiza paraplot   
  # se usa @resultados = parser(@separadores,$expresion);
  my ($sepi,$sepc,$sepd,$expresion) = @_;
  my (@lisi,@lisd);my ($lisi,$lisd);
  if ($expresion =~ /([^$sepc]+)\s*$sepc\s*(.*)/) {
      $lisi = $1; $lisd = $2; $lisd =~ s/\s*$//;
      @lisi = split(/$sepi/,$lisi);
      @lisd = split(/$sepd/,$lisd);
      (@lisi == 2   and @lisd) or return 'error';  
      $lisd[-1] =~ s/\s*$//;
      (my $coderr,@lisd)  = juntar_por_paren(',',@lisd);
  } else {return 'error'};
  return  (\@lisi,$sepc,\@lisd,$lisd);
}#parser 
# ---------------------------------------------------------------------------
sub particion{   # NO SE SABE 
  my ($refhash, $que) = @_;
  my @keys = keys %$refhash; 
  # se suponen ordenados con un mismo criterio los elementos en cada clase 
  # expresada con un string que es join con ' ' de los elementos
  # (si no interpreta clases distintas)
  my @clases = union_conjunto(values %$refhash);
  my $cuantos;
  for (my $i = 0; $i < @clases; $i ++) {
      my @lista = split /\s+/, $clases[$i];
      $cuantos += @lista;
  };
  #print '$refhash ', Dumper $refhash;
  $cuantos == @keys or
  do {explic("     ". join ('  ;  ', @clases) . "
      no es particion de \n          @keys;
      Numero total de elementos, ". scalar @keys . ",
      y numero de apariciones en las clases, $cuantos, 
      son distintos");
      return 1;
  };
  foreach my $key (@keys) {
      my $stringclase = " $refhash->{$key} ";
      $stringclase =~ /$key/ or
      do {explic("     ". join ('  ;  ', @clases) ."
          no es particion de \n          @keys;
          falla pertenencia");  
	  return 2;
      };
  };
  return ''; 
}#particion 
# ---------------------------------------------------------------------------
sub pausa{

    # PAUSA
    
    my ($msg) =(@_,'');
    explic("$msg    Pulse ENTER   ( o CTRL-C para terminar con todo):\n");
    my $dummy = <STDIN>;
    explic('');
    return
}#pausa
# ---------------------------------------------------------------------------
sub pausadebug{
    return if not $debug; 
    pausa(@_);
}#pausadebug
# ---------------------------------------------------------------------------
sub pausaver{
    # muestra y pausa
    
   my ($mensaje,$tarea)=@_;
   mensajear($mensaje);
   mensajear(
       "              Continue $tarea
                        con   ENTER-RETURN;
               Interrumpa con CTRL-C");
   my $resp = <STDIN>;
   mensajear('') if $debug; 
}#pausaver    
# ---------------------------------------------------------------------------
sub propio{
    #usada por avnograv error no grave  avgrav avnoseent  no se entiende
    #que: es avgrav no avnograv o no se entiende
  my ($que,$mensaje) = @_;
  print $SALIDAls3 "$que: $mensaje\n";
  if ($debug) {
      print STDERR "($progr{$progname}) $que: $mensaje\n";
  } else {    
      print  "($progr{$progname}) $que: $mensaje\n";
  };
}#propio

# ---------------------------------------------------------------------------
sub resolver_outdir{#
  my ($curdir,$outdir) = @_;  
  comifin('comy resolver_outdir de lib/simusol',@_);
  my $coderr = '';
  #lo usa desmenuza_comando
  #sobre la base que curdir NO CAMBIA, no se debe cambiar el curdir, salvo que la rutina
  # que lo haga inmediatamente lo reverse, y no es bueno para reentrancia
  
  # DEPRECADO: de linea de comandos o de directorio actual saca outdir y despues
  # le pone adelante lo que corresponda tomando el path original del archivo de entrada e insertando
  #el outdir
  # NO DEPRECADO, verifica que se pueda escribir ahi, resuelve caso path absoluto. creadir
   
  if (not defined $outdir){
      $outdir = $curdir;      
  }else{
      #####($coderr,$outdir) = simpl_directory($outdir);
      # verificar outdir que no tenga .. u otros problemas
     if( $outdir !~ /^\//){ 
        $outdir =join($curdir,$outdir);
        }
     }
  # caso contrario queda como viene, un directorio absoluto;
  

  impr_debug(__LINE__.' Ayud $outdir',$outdir);  
  if (not -d $outdir) {
         
         warn " $outdir no es un directorio; no sirve para recibir archivos, lo creo";
         # verificar que la parte que pre-existe es un directorio escribible y adecuado para no hacer lio
         make_path ($outdir);
  } else{
       # verificar que es un directorio escribible y adecuado para no hacer lio
  };
  
  if (-d $outdir) {
     #if (not $coderr) {
      my $owner =  `stat -c %U $outdir`; 
      chomp $owner;
      my $usted =  `whoami`;
      chomp $usted;
      impr_debug(__LINE__.' Auxi $owner,$usted',[$owner,$usted]);
      $owner eq $usted or die "    El directorio $outdir no sirve para outdir;
        pertenece a $owner y usted es $usted\n"; 
      my $attr = `stat -c %A $outdir`;
      $attr =~ /r.x$/ or die "    El directorio $outdir no sirve para outdir;
        no tiene los permisos necesarios. 
          Proponga uno adecuado con la opcion -outdir\n";
  }else{
      die "No se pudo crear outdir=$outdir\n";
  }
  
  $coderr and parary(250);
  #$ref->{outdir} = $outdir;
  comifin('finy resolver_outdir',$outdir);
  return $outdir;
}#resolver_outdir';
# ---------------------------------------------------------------------------
sub revisar_apareo{# revisa desde la izaquierda apareo de parentesis
    
  #devuelve $coderr -1 cuando no hay apareo; y
  # los conteos de apertura de los tres tipos de parentesis y
  # $uno la porcion de la izquierda quizas terminada 
  # en el parentesis culpable y $dos la porcion de la derecha no revisada
  my $expre = $_[0]; my ($coderr,$mensaje) = ('','');
  my ($car,$abrec,$abrer,$abrel,$uno,$dos) = ('',0,0,0,'',$expre); 
#  print STDERR __LINE__," $coderr,$abrec,$abrer,$abrel,$uno,$dos\n";
  while  ($dos =~ /[\(\)\[\]\{\}]/) {
      $dos =~ s/^(.)//; $car = $1; $uno .= $car;
 #     print STDERR __LINE__," $coderr,$abrec,$abrer,$abrel,$uno,$dos\n";
      next unless $car  =~ /[\(\)\[\]\{\}]/;
      $car eq '(' and $abrec++ or $car eq ')' and $abrec -- or
        $car eq '[' and $abrer ++ or $car eq ']' and $abrer -- or
        $car eq '{' and $abrel ++ or $car eq  '}' and $abrel --;
 #     print STDERR __LINE__," $coderr,$abrec,$abrer,$abrel,$uno,$dos\n";
      if ($abrec < 0 or $abrer < 0 or $abrel < 0) {
	  $coderr = -1; $mensaje = " No apareo detectado en \"$uno\"";
#          $mensaje .=  "\"$dos\"" if $dos;last;
      };
  };
  if ($abrec > 0 or $abrer > 0 or $abrel > 0) {
      $coderr = -1; $mensaje = " Hay parentesis sin cerrar en \"$expre\"";
  };     
#  print STDERR '(finy revisar_apareo $coderr,$mensaje,$uno,$dos,$abrec,$abrer,$abrel',
#	  " $coderr,$mensaje,$uno,$dos,$abrec,$abrer,$abrel\n";
  return $coderr,$mensaje,$uno,$dos,$abrec,$abrer,$abrel;
}#revisar_apareo
# ---------------------------------------------------------------------------
sub sacar_paren_ext{
  #recibe un string y devuelve un string  sin parentesis externos + resto (-1, por error)
  # o una terna  numero,string, string: el numero la cantidad de pares 
  # de parentesis exteriores sacados; lo de adentro; y el resto
  my ($dato,$resto,$error) = ($_[0],'',''); my $dat;
  if ($dato =~ /^\(/) { 
      ($dat,$resto,$error) = cerrar_paren($dato);
      defined $error and return -1; #no se cerro
      $dato = $dat;
  } else {
      return (0,$dato,'');
  };
  my $cuantos = 0;
  my $restin = ''; 
  while  ($restin eq '' and $dat ne '') {
      $dato = $dat;
      #impr_debug( __LINE__.' Ayud', "$_[0]     dato $dato ");
      $dato =~ s/^\((.*)\)$/$1/;
      ($dat,$restin,$error) = cerrar_paren($dato);
      defined $error and return -1; #no se cerro
      $cuantos ++;
  };
  return ($cuantos, $dato,$resto);
}#sacar_paren_ext
# ---------------------------------------------------------------------------
sub simpl_archivo{ #elimina '..' intercalados en nombre de archivo
    #se supone que no hay errores de sintaxis ni espacios 
    # al princ.ni al final
    # y que no termina en /, pues no es un directorio, pero si empieza con /

    # NO SE USA
    
    my $arch = $_[0]; $arch =~ s/^\///;
    my @lista = split /\//, $arch;
    @lista = grep (do{$_ ne '.'}, @lista);
    my $hay =1;
    while ($hay){
        $hay ='';
        for(my $i = 0; $i <@lista-1; $i ++) {
            if ($lista[$i+1] eq '..'  and $lista[$i] ne '..') {
 	        delete $lista[$i]; delete $lista[$i+1]; 
                if (defined $lista[$i+2] and $lista[$i+2] eq '..') {
                    $hay= 1;
                }
                $i ++;
	    } ;
        };
        @lista = grep(defined $_,@lista);    
    };  #ya no hay '..' intercalados
    my @listadospuntos = grep($_ eq '..',@lista);
    return '/'. join '/',@lista;
}#simpl_archivo
# ---------------------------------------------------------------------------
sub simpl_directory{ #elimina '..' o '.' intercalados en nombre del directorio

    # NO SE USA
    
  comifin('comy simpl_directory',@_); 
  my $direin = $_[0]; my ($coderr,$direout) = ('',$direin);
  my $curdir = `pwd`;chomp $curdir;
  if (-d $direin) {
      chdir $direin;
      $direout = `pwd`; chomp $direout;$direout =~ s/([^\/])$/$1\//;
  } else {
      $coderr = 1;X
  };
  chdir $curdir;# si $curdir no fue chompeado, resultaria inutil  
  comifin('finy simpl_directory',$coderr,$direout);
  return $coderr,$direout; 
}#simpl_directory 
# ---------------------------------------------------------------------------
sub textear_MENSAJES{
  my $texto = '   '. join("   \n",@MENSAJES);
  @MENSAJES = ();
  return $texto;
}#textear_MENSAJES
# ---------------------------------------------------------------------------
sub texto{
  # texto que debe ser traducido a otro idioma (ademas de los mensaje etc
  return $_[0];
}#texto
# ---------------------------------------------------------------------------
sub transmitir{
    # pone en nombres info de $ref NO SE DE ACUERDA 
    my ($ref,$numarch) = @_;
  my @palas = qw (BASEARCH PROPIO CORTO PROPIOSIN CORTOSIN BASEARCHCORTO ABSOLUTO
   ABSOLUTOSIN DATECORTO PUNTOEXT);
  my @nombres;
  map(do{push @nombres, $ref->{lc($_)}->[$numarch]},@palas);
  return @nombres;
}#transmitir  
# ---------------------------------------------------------------------------
sub union_conjunto{
    my @lista = @_;
  # Dada un lista devuelve la "misma" sin elementos repetidos (respeta orden)
  my %hash; 
   
  foreach (@lista) {
      next unless defined $_;
      if ($hash{$_}) {
          $_ = undef;
      } else {
          $hash{$_} = 1
     }; 
  };
  @lista = grep (defined $_,@lista);
  return @lista;
}#union_conjunto


# foreach my $na (@ARGV){
#   if (-e $na){ 
#       my ($n,$d,$e)=fileparse($na,@$ext);
#	push (@files ,[$n,$d,$e]);
#     }else{
#       foreach my $ex (@$ext){     
#            if (-e $na.$ex){
#		my ($n,$d,$e)=fileparse($na.$ex,$ex);
#   	        push (@files ,[$n,$d,$e]);
#                }		       
#             }
#       }
#     }


# ---------------------------------------------------------------------------


#             &error_progr
# ESTA EN GLOBALES
#sub error_progr{
#   my ($archivo,$linea,@array) = @_;
#   print STDERR " ===== ERROR de programación detectado en: 
#       archivo $archivo      linea  $linea\n";
#   print STDERR Dumper \@array;
#   exit 200;
#}#error_progr
# ---------------------------------------------------------------------------

#Subroutine hashrenglon redefined at /usr/local/share/perl/5.22.1/Simusol/AyudasPP.pm line 1415.
#Subroutine propio redefined at /usr/local/share/perl/5.22.1/Simusol/AyudasPP.pm line 1789.




#if ($files[0]->[0]){
#    $Simusol::PlotGNU::archivosinext=$files[0]->[0];
#    #    $arch=$files[0]->[0];
#    print "PRIMERO  $files[0]->[0]\n";
#    #print Dumper \@files;
#    return (1,[@files]);
#} else{
#    print "No encontro archivo que pueda usar\n";
#    print "usar paraplot.pl ARCHIVO (sin extension, busca .ds .caj o finalmente un .paraplot ya realizado )\n";
#    return (-1,[]);
#}

#}

#if ($arch){
#    $Simusol::PlotGNU::archivosinext=$arch;
#}elsif(@ARGV == 1 and -e "$ARGV[0].paraplot") {
#    $Simusol::PlotGNU::archivosinext = $ARGV[0];
#} else {
#    my $ok;
#   ($ok,$Simusol::PlotGNU::archivosinext) = elegir_archivos('paraplot');
#   $Simusol::PlotGNU::archivosinext =~ s/\.paraplot//;   # hey es una lista!!! pueden venir varios, procesar
#    # antes salia si no encontraba, pero tener en cuenta que puede no haber paraplot y venir la info por $paraplot
# 
#   #hacer bien!
#};

my $LSS1;
my %reffi;
my $CORTOA;
my $CAJAS;
my %clasearchivos;
# --------------------------------------------------------------------------
sub parar1{
    comfin('comfin parar1',@_);
    # $mensaje se usa para errores detectados por simusol1.pl,
    # que aun no se comunicaron;
    # otros se han comunicado por avgrav,... or porparar 
    # el codigo sera 0 (sin error para el principal) 
    # o el numero del exit
    # $archivo, si se da, es el nombre corto
    # $archivo o $mensaje $refcircuito deben estar presentes 
    #impr_debug(__LINE__.' Glob reffi ', \%reffi);
    my ($codigo,$refcircuito,$mensaje,$archivo)
           = (@_,'','');#a veces se usa sin el tercer y cuarto argumentos  
    if ($refcircuito eq '0' and not $archivo) {
        print "$mensaje\n";
        mensajear(" codigo s1: $_[0]"); 
        exit $codigo;
    } elsif ($archivo) { 
        $refcircuito = $reffi{$archivo}; 
    }; 
    my ($CORTO, ,$CORTOSIN, $PROPIO, $PROPIOSIN, $DATECORTO,$clase)
	= @$ref1{'CORTO', 'CORTOSIN', 'PROPIO', 'PROPIOSIN','DATECORTO'
                      , 'CLASEARCH'};
    $archivo = $CORTO; 
#    impr_datos(__LINE__.' Glob',['PARBORR'],$refcircuito);
    if ($codigo > 4 and $mensaje) {
        if ($avisosgrav) {explic($mensaje)} else {avgrav($mensaje)};
    };
    my $SI = 'SI';
    if ($codigo < 5) {$SI = 'NO';};
    explic("... $progname $SI detecto errores graves en: $archivo ($clase)\n");
    $reffi{$CORTO}->{errores} = 1 if $codigo > 2;
    if ($refcircuito ne '0' and $clase ne 'elementos') {
        my $BASE = $ref1->{BASEARCH};
        foreach my $arch (sort keys %clasearchivos) {
            impr_debug(__LINE__.' Glob $arch',$arch);
	    next if $arch eq $CORTO;
            my $clase = $clasearchivos{$arch}; 
            my $archm = $arch;
            if ($arch !~ /^\//) {
                $archm =$ref1->{curdirori} . $arch;
            };
            my ($basearch,$propio,$corto,$propiosindia,$cortosindia) 
                = relativizar($archm,$BASE);
            next if $corto eq $CORTOA;
            my $consin = " sin";
	    if ($reffi{$arch}->{errores}) {
                $consin = " con";   
            };       
            mensajear(" $corto: ($clase)$consin errores");
        };#foreach $arch
    };
    if ($codigo) {
          explic('       no hay circuito para simular');
    } else {    
          explic(" $archivo: se puede intentar simularlo");  
    }; 
    
    foreach my $keysindia (keys %{$LSS1}) {
        $keysindia =~ /\s/ and error_progr(__FILE__,__LINE__.' $keysindia con espacio');
        my $refc = $reffi{$keysindia};
        my $cod = $refc->{errorparar};
        next if defined $cod and $cod eq 0; 
        # significa que no corresponde archivo .lss1 
        #impr_debug(__LINE__.' Glob $CORTOA,$keysindia,$cod'
        #      ,[$CORTOA, $keysindia,$cod]); 
        my $texto = join("\n",@{$LSS1->{$keysindia}}) . "\n";
#        open LSS1, ">>$keysindia.lss1";
        print SALIDAls3 $texto;
    };
    mensajear(" codigo s1: $_[0]"); close SALIDAls3;
    exit $codigo; 
};#parar1 



# --------------------------------------------------------------------------
sub parar1V{
    comfin('comfin parar1',@_);
    # $mensaje se usa para errores detectados por simusol1.pl,
    # que aun no se comunicaron;
    # otros se han comunicado por avgrav,... or porparar 
    # el codigo sera 0 (sin error para el principal) 
    # o el numero del exit
    # $archivo, si se da, es el nombre corto
    # $archivo o $mensaje $refcircuito deben estar presentes 
    #impr_debug(__LINE__.' Glob reffi ', \%reffi);
    my ($codigo,$refcircuito,$mensaje,$archivo)
           = (@_,'','');#a veces se usa sin el tercer y cuarto argumentos  
    if ($refcircuito eq '0' and not $archivo) {
        print "$mensaje\n";
        print $SALIDAls3 "codigo s1: $_[0]\n"; 
        exit $codigo;
    } elsif ($archivo) { 
        $refcircuito = $reffi{$archivo}; 
    }; 
    my ($CORTO, ,$CORTOSINDIA, $PROPIO, $PROPIOSINDIA, $clase)
	= @$refcircuito{'CORTO', , 'CORTOSINDIA', 'PROPIO', 'PROPIOSINDIA'
                      , 'clasearch'};
    $archivo = $CORTO; 

    my @parborr = sort keys %{$refcircuito->{PARBORR}};
    if (@parborr) {
       impr_datos(__LINE__.' Glob',['PARBORR'],$refcircuito);
        open PARAM, ">$CORTOSINDIA.par";
        print PARAM  '#'.'-' x 10 
	    ." Parámetros o elementos sin influencia en los calculos\n";
        print PARAM  "#    de Sceptre, o ya sustituidos en $PROPIOSINDIA.d\n";
        foreach (sort @parborr) {
           print PARAM "$_ = $refcircuito->{PARBORR}->{$_}\n";
        };
        close PARAM;
        my $cuantos = scalar @parborr;
        mensaje( 
        "Hay $cuantos parámetros sin influencia en los cáculos de Sceptre o 
         ya sustituidos; verlos en $PROPIOSINDIA.par");
        explic " ($CORTOSINDIA.par) " if $PROPIO ne $CORTO;
    };
    if ($codigo > 4 and $mensaje) {
        if ($avisosgrav) {explic($mensaje)} else {avgrav($mensaje)};
    };
    my $SI = 'SI';
    if ($codigo <5) {$SI = 'NO';};
    explic("... $progname $SI detectó errores graves en: $archivo ($clase)\n");
    $reffi{$CORTO}->{errores} = 1 if $codigo > 2;
    if ($refcircuito ne '0' and $clase ne 'elementos') {
        my $BASE = $refcircuito->{BASEARCH};
        foreach my $arch (keys %clasearchivos) {
            my $clase = $clasearchivos{$arch}; 
            my $archm = $arch;
            if ($arch !~ /^\//) {
                $archm =$GlobalesSimusol::pwdori . $arch;
            };
            my ($basearch,$propio,$corto,$propiosindia,$cortosindia) 
                = relativizar($archm,$BASE);
            next if $corto eq $CORTOA;
            my $consin = " sin";
	    if ($reffi{$arch}->{errores}) {
                $consin = " con";   
            };       
            mensaje(" $corto: ($clase)$consin errores");
        };#foreach $arch
    };
    if ($codigo) {
          explic('       no hay circuito para simular');
    } else {    
          explic(" $archivo: se puede intentar simularlo");  
    }; 
    
    open CAJ, ">$CORTOSINDIA.caj";
    print CAJ 
        "#    Archivo $PROPIOSINDIA.caj   preparado por simusol1.pl\n";
    if (defined $CAJAS->{$CORTO}) {
         print CAJ "$CAJAS->{$CORTO}\n";   
    } else {
         print CAJ "Nada para poner aquí\n";   
    }
    close CAJ;
    foreach my $keysindia (keys %{$LSS1}) {
        $keysindia =~ /\s/ and error_progr(0,__LINE__.' Glob');
        my $refc = $reffi{$keysindia};
        my $cod = $refc->{errorparar};
        next if defined $cod and $cod eq 0; 
        # significa que no corresponde archivo .lss1 
        #impr_debug(__LINE__.' Glob $CORTOA,$keysindia,$cod'
        #      ,[$CORTOA, $keysindia,$cod]); 
        my $texto = join("\n",@{$LSS1->{$keysindia}}) . "\n";
  #     open LSS1, ">>$keysindia.lss1";
        print  $SALIDAls3 $texto;
    };
    mensaje ("codigo s1: $_[0]"); 

     close $SALIDAls3;

    exit $codigo; 
}; #parar1 




# -----------------------------------------------------------------------------
sub parar3{
  if ($_[1]) {
      avgrav($_[1]);
  };
  foreach my $keysindia (keys %{$LSS1}) {
      my $texto = join("\n",@{$LSS1->{$keysindia}}) . "\n";
      open LSS1, ">>$keysindia.lss1";
      print LSS1 $texto;
  };
  mensaje ("código s3: $_[0]") if $ENV{USER} eq 'loli'; close LSS1;
  exit $_[0];
}#parar3
#------------------------------------------------------------------------------

sub calcular_dirsal{#sin argumentos; no incluye el outdir
    comfin('comA calcular_dirsal',@_);
    my $mutuodir;
  my @dirext = sort keys %dirsalida;
  @dirext = grep (do{not /\./},@dirext);
  impr_debug(__LINE__.' Auxi @dirext', \@dirext);
  if (not $noclas) {
      $mutuodir = "..\/";
      map (do{#print STDERR "$_ $dirsalida{$_}\n";
           $dirsal{$_} = "$dirsalida{$_}/"}
           ,@dirext);
  } else {
      $mutuodir = '';
      map (do{#print STDERR "$_ $dirsalida{$_}\n";
           $dirsal{$_} = ""},@dirext);
  };
  comfin('finA calcular_dirsal');
  return (\%dirsal);
}#calcular_dirsal


# ---------------------------------------------------------------------------
sub concretar_ABSOLUTO{
  comfin('comA concretar_ABSOLUTO',@_);
  my ($ABSOLUTOSIN,$BASEARCHCORTO,$PROPIOSIN,$puntoext,$curdirori,$outdir) = @_;
  my ($coderr,$mensaje,$outdirfinal) = ('','',$outdir); my ($ABSOLUTO,$PROPIO);
  my $realpuntoext = $puntoext;my %existe;
  my $archdia;
  my @posibles =($ABSOLUTOSIN.'.dia',$ABSOLUTOSIN,$ABSOLUTOSIN.$puntoext);
  @posibles = union_conjunto(@posibles);
  impr_debug(__LINE__.' Auxi @posibles',\@posibles);
  @posibles = grep(do{-e $_ and not (-d $_)} ,@posibles);
  impr_debug(__LINE__.' Auxi @posibles',\@posibles);
  if (@posibles >1) {
      $coderr = 200; $mensaje = " Existen mas de uno posibles: @posibles
       Asi no trabaja Simusol";
  } elsif (@posibles == 0 ) {
      $coderr = 200; $mensaje = " No existe ninguno de estos archivos:
          $posibles[0]
          $posibles[1]";
  } else {
      $archdia = $posibles[0]; 
      $archdia =~ /(\.\w+)$/ and $realpuntoext = $1; 
  };
  if (not $coderr) {        
      if ($progr{$progname} =~ /[01]/) {
          $ABSOLUTO = "$ABSOLUTOSIN$realpuntoext";$PROPIO = "$PROPIOSIN$realpuntoext"
      } else {
          my $ext = 'd';
          $progr{$progname} eq '3' and $ext = 'paraplot';


          ($coderr,$mensaje,$ABSOLUTO,$PROPIO,$outdirfinal) = interpretar_outdir(
            $ABSOLUTOSIN,$BASEARCHCORTO,$PROPIOSIN,$ext,$curdirori,$outdir);



      };
  };
  comfin('finA concretar_ABSOLUTO $coderr,$mensaje,$ABSOLUTO,ABSOLUTOSIN,$PROPIO,
    $outdirfinal',
    $coderr,$mensaje,$ABSOLUTO,$ABSOLUTOSIN,$PROPIO,$outdirfinal,$realpuntoext);
  return $coderr,$mensaje,$ABSOLUTO,$ABSOLUTOSIN,$PROPIO,$outdirfinal,$realpuntoext;
}#concretar_ABSOLUTO
# ---------------------------------------------------------------------------
sub controlar_reserv_dirs{
  comfin('comA controlar_reserv_dirs',@_);
  my ($ref,$crear) = @_;# $estedir con / fin
  my ($coderr,$mensaje) = ('','');
#  impr_debug(__LINE__.' Auxi %dirsalida',Dumper \%dirsalida);
  my @reserv_dirs = (union_conjunto((values %dirsalida)),'cprojects','cauxes');
  impr_debug(__LINE__.' Auxi @reserv_dirs',[@reserv_dirs]);
  my $outdir = $ref->{outdir};
  foreach my $reservdir (@reserv_dirs) { 
      if ($outdir =~ /\/$reservdir\//) {
           $mensaje =  "   $outdir\n,       pasando por  $reservdir,
  no es buen lugar para recibir resultados; use adecuadamente la opcion outdir";
          $coderr = 254; last;
      };
  };
  $coderr and return ($coderr,$mensaje);    
  foreach my $estedir (@{$ref->{basearchcorto}}) {
#      impr_debug(__LINE__.' Auxi $estedir',$estedir);
      foreach my $reservdir (@reserv_dirs) { 
          if ($estedir =~ /\/$reservdir\//) {
              push @MENSAJES, "   $estedir\n,       pasando por  $reservdir,
  no es buen lugar para recibir resultados; use adecuadamente la opcion outdir";
          $coderr = 254; last;
          };
      };
  };    
  if (not $coderr and $crear) {
      ($coderr,$mensaje) = crear_subdirectorios($outdir,@reserv_dirs);
  };
  comfin('finA controlar_reserv_dirs',$coderr,$mensaje,$outdir);
  return $coderr,$mensaje;
}#controlar_reserv_dirs
# ---------------------------------------------------------------------------
sub crear_subdirectorios{
  comfin('comA crear_subdirectorios',@_);
  my ($desde, @subdirs) = @_;
  my $coderr = '';
  if (-e $desde and not -e $desde) {
      push @MENSAJES, 
        " Hay un archivo no directorio $desde que se ha pedido como directorio";
  } elsif (not -d $desde) {
      mkdir $desde;
      if (not -d $desde) {
	 push @MENSAJES," No existe y no se pudo crear el directorio $desde\n";
         $coderr = 253;
     };
  };
  if (not $coderr) {
      foreach my $subdir (@subdirs) {
          if (not -d "$desde/$subdir") {
              mkdir "$desde/$subdir";
              if (not -d "$desde/$subdir") {
                  push @MENSAJES
                    , " No existe y no se pudo crear el directorio $desde/$subdir\n";
              };
          };
      };
  };
  my $mensaje = textear_MENSAJES();    
  comfin('finA crear_subdirectorios',$coderr,$mensaje);
  return $coderr,$mensaje;
}#crear_subdirectorios;
# ---------------------------------------------------------------------------
sub interpretar_outdir{#ya debe estar definido outdir; $arch se  interpreta como
# referido a $curdirori y para indicar el archivo-diagrama
# se preocupa por existencia solo de lo que le interesa segun el $ext : d o paraplot
  comifin('comA interpretar_outdir',@_);
  my ($ABSOLUTOSIN,$BASEARCHCORTO,$PROPIOSIN,$ext,$curdirori,$outdir) = @_;
  my ($coderr,$mensaje) = ('',''); my $outdirfinal = $outdir;my($ABSOLUTO,$PROPIO);
  if ($BASEARCHCORTO !~ /^\//) {    
      $outdirfinal =  "$outdir$BASEARCHCORTO";
      impr_debug(__LINE__.' Auxi $outdirfinal',$outdirfinal);
  }; 
  my $archext = "$outdirfinal$dirsal{$ext}$PROPIOSIN.$ext";
  impr_debug(__LINE__.' Auxi $outdirfinal,$archext',[$outdirfinal,$archext]);
  if (not -e $archext) {

# ve que este el .d!!!!
#      $coderr = 252; $mensaje = " No existe un archivo $archext";



  } else {
      $ABSOLUTO = "$outdirfinal$PROPIOSIN.$ext";
      $PROPIO = "PROPIOSIN.$ext";
  };
  comifin('finA interpretar_outdir  $coderr,$mensaje,$ABSOLUTO,$PROPIO,$outdirfinal',
    $coderr,$mensaje,$ABSOLUTO,$PROPIO,$outdirfinal); 
  return $coderr,$mensaje,$ABSOLUTO,$PROPIO,$outdirfinal;
}#interpretar_outdir

# ---------------------------------------------------------------------------
sub aprontar{
  comfin('comA aprontar',@_);
  my ($ref,$propiosin) = @_;
  #print "$ref->{outdir}\n";
  my $outdirfinal =  "$ref->{outdir}$ref->{BASEARCHCORTO}";
  chdir $outdirfinal if $outdirfinal ne ''; 
  impr_debug(__LINE__.' Auxi $progr{$progname}',$progr{$progname});
  impr_debug(__LINE__.' Auxi',\%dirsal);
  impr_todo(__LINE__.' Auxi',$ref);  
  if ($progr{$progname} eq '1') {
      my $NUMARCH = $ref->{NUMARCH}; 
      not defined $NUMARCH and error_progr(__FILE__,__LINE__,' $NUMARCH no definido');
      my $cortosin = $ref->{cortosin}->[$NUMARCH];
      my $guardarcortosin = $ref->{guardarcortosin}->[$NUMARCH];
      not $guardarcortosin and $guardarcortosin = $ref->{cortosin}->[$NUMARCH];
      @extensiones = qw(ls3 log caj d par paraplot);
      foreach my $ext (@extensiones) {
          my $next = $ref->{$ext}; not defined $next and $next = $ext;
          my $arch = "$guardarcortosin$next";
	  # print "ARCHB >$arch< - >$ext< >$next< >$guardarcortosin<\n";
          system "rm $dirsal{$ext}$arch 2>/tmp/null";
      };
      chdir $ref->{curdirori};
  } elsif ($progr{$progname} =~/[3s]/) {
      if ($progr{$progname} eq 's') {
          @extensiones = qw (sim res f simul);
      } else {
          @extensiones = qw (gra);
      };
      my $arch = $propiosin;      
      my $guardarcortosin = $ref->{GUARDARCORTOSIN};
      not $guardarcortosin and $guardarcortosin = $propiosin;
      foreach my $ext (@extensiones) {
          my $next = $ref->{$ext}; not defined $next and $next = $ext;
          my $arch = "$guardarcortosin$next";
	  #print "ARCHA >$arch< >$ext< >$next< >$guardarcortosin<>$dirsal{$ext}<\n";
	  #print Dumper \%dirsal;
          system "rm $dirsal{$ext}$arch 2>/tmp/null";
      };              
  };
  comfin('finA aprontar');
}#aprontar;

# ---------------------------------------------------------------------------
sub controlar_reserv_dirsVIE{
  comfin('comA controlar_reserv_dirs',@_);
  my ($ref,$crear) = @_;# $estedir con / fin
  my ($coderr,$mensaje) = ('','');
  my @reserv_dirs = (union_conjunto(values %dirsalida),'cprojects','cauxes');
#  impr_debug(__LINE__.' Auxi %dirsalida',Dumper \%dirsalida);
  impr_debug(__LINE__.' Auxi',[@reserv_dirs]);
  my $outdir = $ref->{outdir};
  foreach my $reservdir (@reserv_dirs) { 
      if ($outdir =~ /\/$reservdir\//) {
           $mensaje =  "   $outdir\n,       pasando por  $reservdir,
  no es buen lugar para recibir resultados; use adecuadamente la opcion outdir";
          $coderr = 254; last;
      };
  };
  $coderr and return ($coderr,$mensaje);    
  foreach my $estedir (@{$ref->{basearchcorto}}) {
#      impr_debug(__LINE__.' Auxi $estedir',$estedir);
      foreach my $reservdir (@reserv_dirs) { 
          if ($estedir =~ /\/$reservdir\//) {
              push @MENSAJES, "   $estedir\n,       pasando por  $reservdir,
  no es buen lugar para recibir resultados; use adecuadamente la opcion outdir";
          $coderr = 254; last;
          };
      };
  };    
  if (not $coderr and $crear) {
      ($coderr,$mensaje) = crear_subdirectorios($outdir,@reserv_dirs);
  };
  comfin('finA controlar_reserv_dirs',$coderr,$mensaje,$outdir);
  return $coderr,$mensaje;
}#controlar_reserv_dirs
# ---------------------------------------------------------------------------
sub crear_subdirectoriosVIE{
  comfin('comA crear_subdirectorios',@_);
  my ($desde, @subdirs) = @_;
  my $coderr = '';
  if (-e $desde and not -e $desde) {
      push @MENSAJES, 
        " Hay un archivo no directorio $desde que se ha pedido como directorio";
  } elsif (not -d $desde) {
      mkdir $desde;
      if (not -d $desde) {
	 push @MENSAJES," No existe y no se pudo crear el directorio $desde\n";
         $coderr = 253;
     };
  };
  if (not $coderr) {
      foreach my $subdir (@subdirs) {
          if (not -d "$desde/$subdir") {
              mkdir "$desde/$subdir";
              if (not -d "$desde/$subdir") {
                  push @MENSAJES
                    , " No existe y no se pudo crear el directorio $desde/$subdir\n";
              };
          };
      };
  };
  my $mensaje = textear_MENSAJES();    
  comfin('finA crear_subdirectorios',$coderr,$mensaje);
  return $coderr,$mensaje;
}#crear_subdirectorios;


my %extension;

sub interpretar_outdirVIE{#ya debe estar definido $outdir; y  con @ARGV == 1
# si el $ARGV[0] no es absoluto se interpreta como referido a $curdirori
#para indicar al archvo dia (aunque puede no haber .dia y lo que interesa 
# es el .d para simusol_sceptre.pl o el .paraplot o .simul para simusol3.pl)
# lo usan todos
  comfin('comA interpretar_outdir',@_);
  my $ref = $_[0]; my ($coderr,$mensaje) = ('','');
  impr_todo(__LINE__.' Auxi',$ref);  
  my $outdir = $ref->{outdir}; my $curdirori = $ref->{curdirori};
  my ($diadir,$cortodiadir,$cortoarch,$cortoarchsin,$propioarch,$propioarchsin,$resto); 
  my $archivo = my $arch = $ref->{dirarray}->[0];
  $archivo !~ /^\// and $archivo = "$curdirori$arch";
  $archivo =~ s/\.\w*$//;
  impr_debug(__LINE__.' Auxi $archivo, absoluto, sin su extension si la tenia'
	     , $archivo);
  $archivo =~ /^(.*)\/([^\/]*)$/ and  do{$diadir = $1;$propioarch = $2};

  impr_debug(__LINE__.' Auxi $diadir,$propioarch',[$diadir,$propioarch]);
  ($propioarchsin = $propioarch) =~ s/\.\w+//;
  ($coderr,$diadir) = simpl_directory($diadir);
  impr_debug(__LINE__.' Auxi $outdir,$diadir',[$outdir,$diadir]);
  my $largo_curdirori = length $curdirori;
  my $largo_diadir = length $diadir;
  impr_debug(__LINE__.' Auxi $largo_curdirori $largo_diadir',[$largo_curdirori,$largo_diadir]);
  my $outdirfinal;
  if ($largo_diadir >= $largo_curdirori) {
      my $parte = substr($diadir,0,$largo_curdirori);
      impr_debug(__LINE__.' Auxi $parte',$parte);
      if ($parte eq $curdirori) {
          $resto = substr($diadir,$largo_curdirori);
         impr_debug(__LINE__.' Auxi $resto',$resto);
      } else {
          $resto = $parte;
      };
      $outdirfinal = "$outdir$resto";
      impr_debug(__LINE__.' Auxi $outdir,$diadir,$resto,$outdirfinal'
		 ,[$outdir,$diadir,$resto,$outdirfinal]);
  };
  impr_todo(__LINE__.' Auxi',$ref);
    push @{$ref->{basearchcorto}},$resto;
  my $extbuscada = $extension{$progr{$progname}};
  impr_debug(__LINE__.' Auxi $extbuscada $outdirfinal $propioarch' ,
	     ["M".$extbuscada."M",$outdirfinal,$propioarch]);
  my $ddd = $dirsal{$extbuscada}; $ddd or $ddd = '';
  my $archbuscadosin = "$ref->{basearchcorto}->[0]$ddd$propioarch";
  impr_debug(__LINE__.' Auxi $arcbuscadosin',$archbuscadosin);
  if (-e "$archbuscadosin.$extbuscada") {
      push @{$ref->{cortosin}},$archbuscadosin;
      push @{$ref->{corto}},"$archbuscadosin.$extbuscada";
      $ref->{PROPIOSIN} = $propioarch;
      $ref->{outdirfinal} = $resto;
  } elsif ($progr{$progname} =~ /[01]/) {
      push @{$ref->{cortosin}},$archbuscadosin;
      push @{$ref->{corto}},"$archbuscadosin";
      $ref->{PROPIOSIN} = $propioarch;
      $ref->{outdirfinal} = $resto;
  } else {  
      $mensaje = " No existe el archivo $archbuscadosin.$extbuscada
         ni el archivo $archbuscadosin ";$coderr = 60;
  }; 
  impr_todo(__LINE__.' Auxi',$ref);
  comfin('finA interpretar_outdir',$coderr,$mensaje);
  return $coderr,$mensaje; 
}#interpretar_outdir


# ---------------------------------------------------------------------------
sub presentar_simusol{
  comfin('comA presentar_simusol',@_);
  my ($ref,$NUMARCH,$dirsal,$SALIDAls3, $SALIDAlog) = @_;
#  impr_todo(__LINE__.' Auxi comienzo de presentar_simusol',$ref);
  my $prog = $progr{$progname}; my $pre = '';
  $prog eq 's' and $pre = $dirsal{d} or $prog eq '3' and $pre = $dirsal{paraplot}; 
  my $PROPIOSIN = $ref->{PROPIOSIN};   
  my $PROPIO = $ref->{PROPIO};
  my $BASEARCHCORTO = $ref->{BASEARCHCORTO};
  my $CORTOSIN = $ref->{CORTOSIN};
  my $CORTO = $ref->{CORTO};
  my $DATECORTO = $ref->{DATECORTO};
  if ($progr{$progname} eq '1') {
  my $CLASEARCH = $ref->{CLASEARCH};
  my $dirg = $dirguardar{$CLASEARCH};
  $ref->{DIRG} = $ref->{dirg}->{$NUMARCH} = $dirg;
  $ref->{GUARDARCORTOSIN} = $ref->{guardarcortosin}->[$NUMARCH];
  $ref->{GUARDARPROPIOSIN} = $ref->{guardarpropiosin}->[$NUMARCH];
  my $apartir = " a partir de archivo de fecha $DATECORTO";
  my $copiado = " copiado en $dirg/$PROPIO";
  $ref->{APARTIR} = $apartir; $ref->{COPIADO} = $copiado;
  my $archguardarcongnus = $ref->{CORTOSIN};
  if ($todas) {
      my $archguardar = $ref->{GUADARCORTOSIN}."_$todas";
      $archguardar=~ s/\s+/_/g;
      $archguardarcongnus =~ s/([^\/]+)$/gnus\/$1/;
  };
  $ref->{ARCHGUARDARCONGNUS} = $archguardarcongnus;
};
#  impr_todo(__LINE__.' Auxi',$ref);
  my (%nombre,%presen);
  my (%extreal);

  
  $extreal{log} = 'log'; 
  $extreal{ls3} = $ref->{ls3};
#  impr_todo(__LINE__.' Auxi',$ref);
  my ($modo,$arch);
  my %cosas = ('ls3'=>'Mensajes de',
	       'log'=>'Archivos producidos por');
  for my $ext ('ls3','log') {
      if ($progr{$progname} eq '1') {
          $modo = '0';
      } else {
	  $modo = '1';
      };
      impr_debug(__LINE__.' Auxi $CORTO',$CORTO);
      $nombre{$ext} = "$PROPIOSIN.$extreal{$ext}";
      $presen{$ext} = "=-=-$cosas{$ext} $progname, $PROPIO, $DATECORTO";
      $presen{$ext} .= "       con opcion -todas $todas\n"
          if $todas;
  };
#  print STDERR "                                  Voy a abrir ls3_log\n";
  
#my   ( $SALIDAls3, $SALIDAlog)=abrir_ls3_log($ref,\%dirsal);
 


 print STDERR "                                   Ya abri ls3_log\n";
  if ($progr{$progname} ne '1') {
      my $date = localtime();
      if ($progr{$progname} eq '1') {
          print $SALIDAls3
            "Archivo $dirsal{ls3}$PROPIOSIN.$ref->{ls3}  $marca_Simusol  $date\n";
          print $SALIDAlog 
            "Archivo $dirsal{log}$PROPIOSIN.log  $marca_Simusol  $date\n";
      };
      print $SALIDAls3 "$presen{ls3}\n";
      print $SALIDAlog "$presen{log}\n";
  };
  comfin('finA presentar_simusol');
  return  ;
}#presentar_simusol;

1;
