#ayudas.pm
# son ayudas para el programador; algunas para dar informacion al programador;
# otras para que sea mas facil programar ayudas para los usuarios
package Simusol::AyudasXML;
#use warnings;
use strict;
use warnings;
use Data::Dumper;
$Data::Dumper::Sortkeys = 1;


BEGIN {
  use Exporter ();
  our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
  @ISA=qw(Exporter);
  @EXPORT=qw(
             &aceptar_archivo_XML
	     &impr_lisarb 
	     &imprlisarb 
             &impr_lisarbresu 
             &imprlisarbresu 
	     &imprlislisarb
	     &impr_lislisarb
	     &impr_nodarb 
	     &imprnodarb 
             &impr_nodarbresu
             &imprnodarbresu
  	    );
};
END();


#----------------------------------------------------------------------------
sub imprlisarb{
    #XML
   # imprime una lisarb, desrrollando el primer nivel; dada por su referencia
   # $reflisarb
   my ($nombre,$reflisarb)=@_;
   my ($hash,@lista) = @$reflisarb;
   print "+++++++++++++++\n";
   print "$nombre ---lisarb: ",(scalar @lista)/2 ,
          " nodarbs.  --hasharb:  ";
   imprhashrenglon('', %$hash);
   for(my $i=0;$i<@lista;$i += 2){
      my @listita= @lista[$i,$i+1];
      imprnodarb('(' . $i/2 . ')' . '   ',@listita) 
   };
   print "+++++++\n";
 } 
#----------------------------------------------------------------------------
sub imprlisarbresu{
    #XML
   # imprime una lisarb, desrrollando el primer nivel; dada por su referencia
   # $reflisarb
   my ($nombre,$reflisarb)=@_;
   my ($hash,@lista) = @$reflisarb;
   print "+++++++++++++++\n";
   print "$nombre ---lisarb refinada: ",(scalar @lista)/2 ,
          " nodarbs.  --hasharb:  \n hash ";
   imprhashrenglon('', %$hash);
   for(my $i=0;$i<@lista;$i += 2){
      my @listita= @lista[$i,$i+1];
      imprnodarbresu('(' . $i/2 . ')' . '   ',@listita) 
   };
   print "+++++++\n";
 } 
#----------------------------------------------------------------------------
sub imprlislisarb{
    #XML
   #imprime una lista de listas arboladas dada por sí.  
   my ($nombre,@lista)=@_;
   print "$nombre --- lista de " ,scalar @lista," lisarbs ---\n";
   for (my $i=0;$i<@lista; $i++){
      my $lisarb= $lista[$i]; 
      imprlisarbresu ("$nombre($i) ",$lisarb);
   }
}
#----------------------------------------------------------------------------
sub imprnodarb{
    # XML
  #imprime un basico de lista arbolada dado por ($tagarb,$contarg)
  my ($nombre,$tagarb,$contarb)=@_;
  $nombre.=" --nodarb--  ";
  print "$nombre;  tagarb:  $tagarb;   contarg: "; 
  if ($tagarb ne '0') {
     imprhashrenglon('', %{$contarb->[0]}); 
     print '     lista de ', (scalar@{$contarb}-1)/2 ," nodarbs\n"; 
  } else {
     print $contarb
  };
  print "\n"
}
#----------------------------------------------------------------------------
sub imprnodarbresu{
   # XML 
  #imprime un basico de lista arbolada dado por ($tagarb,$contarg)
  my ($nombre,$tagarb,$contarb)=@_;
  $nombre.=" --nodarb--  ";
  if ($tagarb ne '0') {
     print "$nombre;  tagarb:  $tagarb;   contarg: "; 
     imprhashrenglon('',%{$contarb->[0]}); 
     print '     lista de ', (scalar@{$contarb}-1)/2 ," nodarbs\n"; 
  };
}#imprnodarbresu
# ---------------------------------------------------------------------------
sub aceptar_archivo_XML{#

    # es XML  o no?
    
  comifin('comA aceptar_archivo_XML',@_);
  my ($archivo,$gnusdir) = @_;my ($coderr,$mensaje,$doc) = ('','','');
  if ($archivo =~ /~$/) {$mensaje = " Es un respaldo: $archivo"; $coderr = 251;
  } elsif (-d $archivo) {$mensaje = " Es un directorio o carpeta:$archivo";
      $coderr = 252;
  } elsif (not -e $archivo) { $mensaje = " No existe el archivo: $archivo"; $coderr = 250}; 
  if (not $coderr) {			      
      my $p = XML::Parser->new(Style=>'Tree');
      impr_debug(__LINE__.' Ayud por hacer parsefile $archivo,$gnusdir ', [$archivo,$gnusdir]);
      eval{$doc = $p->parsefile($archivo)};
      if ($@ ne '') { # quizas esta comprimido,que es el modo natural de Dia
          #impr_debug(__LINE__.' Ayud $@',$@);
          system "zcat $archivo >$gnusdir/llll 2>/dev/null";  
          eval{$doc=$p->parsefile("$gnusdir/llll")};
          if ($@ ne  '') {
              $mensaje = " No es un buen archivo XML: $archivo";
              $coderr = 253;
          };
      }
  };
  if (not $coderr) {
      impr_debug(__LINE__.' Ayud'," Todo bien");
  };    
  comifin('finA aceptar_archivo_XML $coderr,$mensaje,$doc',$coderr,$mensaje,$doc);
  return $coderr,$mensaje,$doc;
}#aceptar_archivo_XML
#----------------------------------------------------------------------------
sub impr_lisarb{
    ### los lisarb tienen que ver xon XML
   # imprime una lisarb, desrrollando el primer nivel; dada por su referencia
   # $reflisarb
   my ($nombre,$reflisarb)=@_;
   my ($hash,@lista) = @$reflisarb;
   print "+++++++++++++++\n";
   print "$nombre ---lisarb: ",(scalar @lista)/2 ,
          " nodarbs.  --hasharb:  ";
   impr_hashrenglon('', %$hash);
   for(my $i=0;$i<@lista;$i += 2){
      my @listita= @lista[$i,$i+1];
      impr_nodarb('(' . $i/2 . ')' . '   ',@listita) 
   };
   print "+++++++\n";
}#impr_lisarb 
#----------------------------------------------------------------------------
sub impr_lisarbresu{
   # imprime una lisarb, desrrollando el primer nivel; dada por su referencia
   # $reflisarb
   my ($nombre,$reflisarb)=@_;
   my ($hash,@lista) = @$reflisarb;
   print "+++++++++++++++\n";
   print "$nombre ---lisarb refinada: ",(scalar @lista)/2 ,
          " nodarbs.  --hasharb:  \n hash ";
   impr_hashrenglon('', %$hash);
   for(my $i=0;$i<@lista;$i += 2){
      my @listita= @lista[$i,$i+1];
      impr_nodarbresu('(' . $i/2 . ')' . '   ',@listita) 
   };
   print "+++++++\n";
}#impr_lisarbresu 
#----------------------------------------------------------------------------
sub impr_lislisarb{
   #imprime una lista de listas arboladas dada por si.  
   my ($nombre,@lista)=@_;
   print "$nombre --- lista de " ,scalar @lista," lisarbs ---\n";
   for (my $i=0;$i<@lista; $i++){
      my $lisarb= $lista[$i]; 
      impr_lisarbresu ("$nombre($i) ",$lisarb);
   }
}#impr_lislisarb
#----------------------------------------------------------------------------
sub impr_nodarb{
  #imprime un basico de lista arbolada dado por ($tagarb,$contarg)
  my ($nombre,$tagarb,$contarb)=@_;
  $nombre.=" --nodarb--  ";
  print "$nombre;  tagarb:  $tagarb;   contarg: "; 
  if ($tagarb ne '0') {
     impr_hashrenglon('', %{$contarb->[0]}); 
     print '     lista de ', (scalar@{$contarb}-1)/2 ," nodarbs\n"; 
  } else {
     print $contarb
  };
  print "\n"
}#impr_nodarb
#----------------------------------------------------------------------------
sub impr_nodarbresu{
  #imprime un basico de lista arbolada dado por ($tagarb,$contarg)
  my ($nombre,$tagarb,$contarb)=@_;
  $nombre.=" --nodarb--  ";
  if ($tagarb ne '0') {
     print "$nombre;  tagarb:  $tagarb;   contarg: "; 
     impr_hashrenglon('',%{$contarb->[0]}); 
     print '     lista de ', (scalar@{$contarb}-1)/2 ," nodarbs\n"; 
  };
}#impr_nodarbresu
# ---------------------------------------------------------------------------

1;
