package Simusol::Globales;
#variables y constantes globales
use warnings;
use strict;

use Data::Dumper;
use Text::Abbrev;

use Simusol::AyudasPP;


our $ref1={};  # OJO DEBE ESTAR EXPORTADO EN ALGUN MODULO

$Data::Dumper::Indent = 1; 
our $INSTALLDIR = '/usr/local'; 
#our $INSTALLDIR = '/home/loli/maq_luis';
#our $HOMEDIR = $ENV{HOME}; 
#our $INSTALLDIR = "$HOMEDIR/binlib";
our $SIMUSOLBINDIR =  "$INSTALLDIR/bin";
our $SIMUSOLLIBDIR =  "$INSTALLDIR/lib";
our $INSTDIR; #directorio que tendrá los ejecutables de sceptre
#if (-e "$INSTALLDIR/bin/sceptre") {
#    $INSTDIR = $INSTALLDIR
#} else { 
    $INSTDIR = `which sceptre`;
    $? and die " sceptre no está disponible\n";
    chomp $INSTDIR;
    $INSTDIR =~ s/\/bin\/sceptre//;
#}; 
our $LIBDIR = "$INSTDIR/lib";
our $BINDIR = "$INSTDIR/bin";

our (@Dia2Simusol,@Simusol2Dia); #ASUS???
#our $version= 0.87;

our %extension = (
      'simusol' => 'dia'
    , 'simusol_sceptre' => 'd'
    , 'simusol1.pl' => 'dia'
    , 'simusol2.pl' => 'dirac'
    , 'simusol3.pl' => 'paraplot'
    , 'sim_renback' => 'dia'
		     );

#our $PRINCIPAL; #nombre del archivo principal para el procesamiento
#    # si no se conoce de entrada, porque se dan varios,  se usa 'simusol'
#    # los mensajes se mandan a $PRINCIPAL.lss1
our $algo = chr(31) . chr (139) . chr(8) ;$algo ='^' . $algo; 
  #lo anterior identifica archivos comprimidos
our %progr = ('simusol' => 0,'simusol1.pl' => 1, 'simusol_sceptre' => 's'
          , 'simusol2.pl' => 2, 'simusol3.pl' => 3);
our $d; #%opt_hash; #cada script comparte variables our con las subrutinas 

our $noverb;

# llamadas por el ( siempre que ...
# pero dos scripts (uno llama al otro pero a traves de system) 
# no comparten esas variables; simusol y simusol1.pl no comparten $opt_hash
our %nombresusados; #key nombre de elemento no rama; general; values 1;
    #se usa para cuando hay que crear elementos JN...
our %expr_usadas; #key identificacion de expres. usadas


#our %modelo; #key nombre del modelo; value referencia a los datos del
    # circuito que lo definio; $defimod sustituye       
#our %circ_model; #hash con key nombre (CORTO) de archivo y 
    #value referencia al  hash con datos del circuito
our %reffi;# hash de referencias a datos de archivos; key nombres de
     #archivo; value referencia a un hash 
our %reffipri;# hash de referencias a datos de archivos complementarios;
    # key nombres de archivo; value referencia a un hash 
our %refficompl;# hash de referencias a datos de archivos complementarios
    # de uno dado;
    # key nombres de archivo principal; value referencia a un hash  
    #que tiene como keys nombres de archivos secundarios
our %clasearchivos; #hash con key nombre de archivo y value: 
    # modelo, elementos  o circuito 
#our (%falta_pcs,%falta_uni,%falta_modelo); 
our @dirplantiquedan;
our $cuantosiconos = {}; #apunta a hash con keys de plantilla;

our ($nombrelay, $nombreplantilla, $nombreshape ,$nombreelemento)
    = ([],[],[],[]);

our $nombrefile=[]; #ASUS


  #$nombrelay'}       #capas
  #$nombreplantilla'} #primeras partes de nombres de shapes
  #$nombreshape'}     #segundas partes de nombres de shapes
  #$nombreelemento'}  #nombres de elementos en cuadro USO_DEF
#referencia a listas de codigos de los objetos de los diagramas leidos
our ($laylista, $plantillalista, $shapelista, $codlista
   , $codvalorlista, $textolista, $lugarlista) 
    = ([], [], [], [], [], [], []);

our $filelista=[];  #ASUS

  #$laylista        #de la capa (por orden de lectura luego de ..)
  #$plantillalista  #de la primera parte del nombre de la forma
  #$shapelista      #de la segunda parte del nombre de la forma 
  #$codlista        #como elemento (fundam. para sceptre)
  #$codvalorlista   #junto con codlista identifican icono
  #$textolista      #identif. del elemento en el diagrama
  #$lugarlista      #lugar en diagrama
# referencia a hashes                        
our ($cualplantilla, $cuallay, $cualshape, $cualelemento) = ({}, {}, {}, {}); 
  #$cualplantilla)  #nombredeplantilla => lugar en la lista de plantillas
  #$cuallay         #nombre de capa => lugar en la lista global de capas
  #$cualshape       #nombre de shape = > lugar en la lista de shapes
  #$cualelemento    #nombre de elemento => lugar en la lista

our $cualfile={}; #ASUS

# referencia a hashes   con key $pcs
                               #dado en diagrama de definicion de elementos
our ($comonombre,$comocod, $comocodvalor, $comootrosnodos) = ({}, {}, {}, {});
  #$comonombre      #plantillacshape => nombre del elemento 
  #$comocod         #plantillacshape => codigo (de letra, sceptre)
  #$comocodvalor    #plantillacshape => codigo (de letra, fórmula)

our $nombre_menu_Dia={};


########################################################################################################
# MOVIDO en ASUS, lo mantengo si no no anda
our @reflayer; #array de referencias a hash con características de las
# layers;
#mas abajo se agrega uno con s: reflayers!!!!!
########################################################################################################
# movido en ASUS
our @nomcirc; #index el numero de layer
our $CAJAS = {}; #referencia a hash 
                #con key nombre de archivo de tipo circuito,  o modelo
		#y value el texto de las cajas y alguna otra cosa
#referencia a listas con palabras codificadas
######################################################################################################



#hashes con definiciones resultantes de archivos .ele .mod y similares
#con key $plantilla (primera parte de  nombre de forma
our ($DEFIELE, $defimod, $DEFIUNI,,  $defiabrev
    ,$defiuni, $deficomp, $defiequiv, $defimagn
    ,$palabrasequivV, $palabrasequi)
      = ({}, {}, {}, {}, {}, {}, {}, {}, {}, {});
  #$deficomp      #$plantilla = > # ref a hash de compuestos para C,E,J,L,R
  #$defiabrev     #$plantilla => # ref a hash de abreviaturas para V e I
 
  #$DEFIELE}           # key nombre de elemento, value ref a hash
                               # de datos sobre el elemento 
  #$defimod        # identif. del modelo => ref a hash
  #$DEFIUNI        # codigo de primera parte de nombre de formas=>
                                 # ref a hash de
                               #    unidades y nombres para los 
			       # distintos elementos reales
                         # ejemplo de rama: 5=>{'E' => 'gradoC, temperatura',
  #$defiabrev     # codigo de primera parte de 
                               # nombre de formas=>
                               # ref a hash de abreviaturas para V e I
  #$defiuni
  #$defiequiv     # codigo de primera parte de 
                               # nombre de formas=>
                               # refer a hash de equiv. de abrev
  #$defimagn      # codigo de primera parte de 
                               # nombre de formas=>
                               # refer a hash de magnitudes
  #$palabrasequivV      
  #$palabrasequivI

     # ref. a arrays o hashes para contener atributos de los objetos;
     # el índice es el número de  objeto absoluto para simusol
   
our (@opciones,$opciones); #relativo a llamada a simusol
our @orden_nodos_mod = (4, 2, 0, 6, 7, 8, 1, 3,5); 
    # es el orden correspondiente a
    # sentido horario para el modelo general, la shape de 9 conexiones;
    # el punto de conexion 0 corresponde al 4, el 1 al 2 el ultimo al 5
    # y se trabaja como si siempre se ocuparan las primeras conexiones.
    #los demás modelos deben tener justo el número exacto de conexiones
    # que usen#por lo que no tendra importancia ese orden
#LOLIour %fortranfun = ('DSQRT',1,'DSIN',1,'DCOS',1,'DEXP',1,'DATAN',1
#LOLI                    ,'DABS',1,'DLOG',1,'DLOG10',1,'DMOD',1);
our (%hash_FUNCIONES_definidas, %hash_TABLAS_definidas);
#tablas usadas por un circuito se guardan en $refcirc-{USATAB}

our %codigoStandard=(
    'Image'=>['A','A'],
    'Text'=>['A','A'],
    'Ellipse'=>['A','A'],
    'Box'=>['A','A'],
    'Polygon'=>['A','A'],
    'Arc'=>['x','x'],
    'BezierLine'=>['x','X'],
    'Beziergon'=>['A','A'],
    'Line'=>['l','l'],
    'PolyLine'=>['x','X'],
    'ZigZagLine'=>['X','x']);
    #las ZigZagLine nombran diferente a sus handlers
our %codigovalor=(
    'nodo'=>'N', 
    'nodod'=>'n',
    'Image'=>'A', 
    'Text'=>'A',
    'Ellipse'=>'A',
    'Box'=>'A',
    'Polygon'=>'A',
    'Arc'=>'x',
    'BezierLine'=>'X',
    'Beziergon'=>'A',
    'Line'=>'l',
    'PolyLine'=>'X',
    'ZigZagLine'=>'x',
    'Objet'=>'O',
    'Object'=>'O',
    'modelo'=>'T',
    ''=>'Z'
);
    # en la explicación siguiente handle significa 
    # "enganchable activo": hay
    # que pescarlo precisamente y acercarlo a un punto de conexión para
    # conseguir un enganche. (mientras se trabaja con Dia)
our %quenombre=(
    'J'=>'fuente de corriente',
    'R'=>'resistencia',
    'E'=>'fuente de tensión',
    'C'=>'condensador',
    'N'=>'nodo',
    'n'=>'nodo rep.',
    'A'=>'texto descriptivo o fig. auxiliar',
    'l'=>'rama de conexión con posibles contactos',
    'X'=>'rama de conexión',
    'X'=>'rama tipo ZigZag',
    'V'=>'texto con valores',
    'T'=>'modelo',
    'O'=>'Cuadro',
);
our %nombrepuntos=(
    'PolyLine'=>'poly_points',
    'ZigZagLine'=>'orth_points',
    'Line'=>'conn_endpoints',
    'Arc'=> 'conn_endpoints',
    'BezierLine'=>'bez_points');     



#####puesto por ASUS
our ($codcontexto,$codconattrib,$codramas ,$codnodos,$codigno
     ,$codelems,$codelemTs,$codconects,$codconectsnonodos)
          =('[ECJLRTZNecjrlnO]','[O]','[uxX]','[Nnt]','[A]'
  ,'[ECJLRecjlr]','[ECJLRTecjrl]','[ECJLRTZecjlrNnt]','[ECJLRTZecjlrtz]'); 
##########################3





our %unist;
abbrev \%unist, qw(minutos horas segundos dias);
#lo anterior define un hash con key: abreviatura y value los dados;
# ejemplo: $unis{se} vale segundos; $unis{'aab'} está indefinido
our %factort = ('segundos' => 1, 'minutos' => 60, 'horas' => 3600, 
                'dias' => 86400, 'hour'=>3600);
our ($unidadtiempo ,$comitiempo, $fintiempo,$origcomitiempo,$origfintiempo) 
        =  ('minuto', 0, 10800, '0', '180 minuto'); 

our %acep_fun;
my @aceptables = qw(sqrt sin cos exp abs log log10 sign mod sinh cosh);
map (do{$acep_fun{$_} = 1; $acep_fun{"d$_"} = 1},@aceptables);
#$acep_fun{qproducto} = 1; $acep_fun{qsuma} = 1;
    #impr_debug(__LINE__.' Glob,%acep_fun',\%acep_fun);
my @extensiones = 
   ('ls1', 'ls2','GNU', 'GPI'
    , 'dirac', 'gra', 'gnu', 'gnu1'  
    , 'res', 'res1', 'simul', 'simul1', 'caj', 'caj1'
    , 'd', 'd1', 'paraplot', 'paraplot1', 'lss1', 'lss11','ls3','ls31',
    , 'eps','png','ps','for'
    , 'shape', 'sheet', 'autosave','log', 'dump'
    , 'html', 'svg'
);
# son extensiones usadas por simusol con distintos propositos para archivos
# que no serán diagramas
our (%no_ext);
map($no_ext{$_} = 1,@extensiones);


######################################
# sacado por ASUS
#our ($BASEARCHA, $CORTOA, $PROPIOA, $CORTOASINDIA, $PROPIOASINDIA , $pwdori);
#$CORTOA = '';
####################################### mantenido 
our ($CORTOASINDIA, $PROPIOASINDIA , $pwdori);

################# agregado en asus
our ($ARCHIVOA, $BASEARCHA,  $PROPIOA, $CORTOASIN, $PROPIOASIN);
our ($PUNTOEXTA, $PRINCIPAL, $NUMPRINCIPAL, $CLASEPRINCIPAL, $datedia);
    # $PRINCIPAL; #nombre del archivo principal para el procesamiento
    # si no se conoce de entrada, porque se dan varios,  se usa 'simusol'?
    # los mensajes se mandan a $PRINCIPAL.lss1
our $refglobal = {};
our $refall = {'nombre'=>'todas las capas'
               ,'capas'=>[],'capasele'=>[],'capasmod'=>[],'capasgra'=>[]
               ,'capascir'=>[],'capasresto'=>[],'capasnosirven'=>[]
               ,'capasDIAGR'=>[]
               ,'archivos'=>[]
               ,'lisobjO'=>[],'ARCHIVO2extras'=>{},'cualnumclasenum'=>{} };
our @refdias; #array de referencias a array con lo de las capas del
              # archivo diagrama dia
our @refarchers;  #array de referencias a hash con caracteristicas de archivo 
our @refgrafers; #array de referencias a hash con caracteristicas 
                 #de la parte grafica del archivo
our @reflayers; #array de referencias a hash con caracteristicas de layers;
                #fundamentalmente los cuadros
our @refnombres; #array de referencias a hash con distintos nombres para archivos
our %refboxes; #hash de referencias con keys #numobj de cuadro
###############################


# sacado por mi , movido a programas
#	        %opt_hash 
# sacado en ASUS
#$HOMEDIR 
#$PRINCIPAL
#                &impr_opciones
BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA=qw(Exporter);
     @EXPORT=qw(
                $filelista
                $laylista $plantillalista $shapelista
                $codlista $codvalorlista $textolista $lugarlista
                @reflayer $cuantosobj @dirplantiquedan
		%acep_fun %codigoStandard
                %codigo %codigovalor %quenombre 
                $cualfile $nombrefile
                $cuallay $nombrelay
		$cualplantilla $nombreplantilla
                $cuantosiconos
		$cualshape $nombreshape 
                $cualelemento $comonombre $nombreelemento
		$comocod $comocodvalor $comootrosnodos
                %nombrepuntos %clasearchivos
                %lay_mod_arch %lay_circ_arch
	        %nombresusados %expr_usadas
                $refall $refglobal $reftrabajo  
                @refdias @refarchers @refgrafers @reflayers @refnombres
                @Dia2Simusol @Simusol2Dia  
                %refboxes
	        @nomcirc @nomfile
	        %reffi %refficompl %reffipri $DEFIELE $defimod 
                $DEFIUNI $defiabrev $defiuni $deficomp $defiequiv $defimagn
                $palabrasequivV       
                $palabrasequivI
	        @opciones $opciones
		@orden_nodos_mod
                %hash_FUNCIONES_definidas 
 		%hash_TABLAS_definidas
                %fortranfun
                %opt_comun 
                %unist %factort
                $unidadtiempo $comitiempo $fintiempo
                $origcomitiempo $origfintiempo		
                $version
                $CAJAS		
                $INSTALLDIR $SIMUSOLBINDIR $SIMUSOLLIBDIR
		$INSTDIR $LIBDIR $BINDIR
 $codcontexto $codconattrib $codramas $codnodos $codigno
                $codelems $codelemTs $codconects $codconectsnonodos 
 		&controlar_our
                %no_ext %numarch
                $ARCHIVOA $BASEARCHA $datedia
                $CLASEPRINCIPAL
               $CORTOASIN $PROPIOA $PROPIOASIN
                $PROPIOAGUARDAR $PROPIOASINGUARDAR
                $PRINCIPAL $PUNTOEXTA $NUMPRINCIPAL
                $pwdori
                $CORTOASIN $PROPIOA $PROPIOASIN $PRINCIPAL
                $todosque
		%extension %progr
                &atender_opt_hash_todas
                &borrar_datos
                &cargar_datos &cargar_datos_tipotok &cargar_tiparg_refarg
                &cajear_capa
   	        &comfin
                &comparar_icono 
                &copiar_datos 
        	&crear_gnus 
                &descartar_archivos
                &descripcion_capa &descripcion_cuadro &descripcion_icono
                &descripcion_nombre &descripcion_objeto
                &error_progr
                &impr_capa
                &impr_file
                &impr_FUNCIONES &impr_TABLAS
                &impr_conects
                &impr_cualobjref
                &impr_dat &impr_dat_que
                &impr_datos
                &impr_enganches
                &impr_identi
                &impr_obj &impr_objs 

                &impr_par  
                &impr_ramas
                &impr_RESULTADOS
                &impr_unionesobj
                &iniciar_refglobal
                &mover_datos
                &para_sceptre_num
         
                &porparar1               
 		&repite_nombre 
                &tiparg_2_tipo
                tiparg_refarg_2_valor
                &tomar_datos &tomar_tiparg_refarg
                &valor
      );  
};


END();
#  ASUS              %numarch %no_ext
#                $BASEARCHA $pwdori
#                $CORTOA $CORTOASINDIA $PROPIOA $PROPIOASINDIA #
#		%extension %progr
#               &cargar_datos &copiar_datos &borrar_datos 
#                &mover_datos &tomar_datos
#                &comparar_icono 
#                &descripcion_capa
#                &descripcion_nombre &descripcion_objeto &descripcion_cuadro
#                &descripcion_icono
#		&repite_nombre 
#                &impr_dat &impr_dat_que
#                &impr_datos &impr_obj &impr_ramas &impr_identi
#                &impr_cualobjref
#                &impr_resultados &impr_TABLAS
#                &impr_enganches
#                &impr_unionesobj
#		&controlar_our
#		&crear_gnus 
#		&comfin &parar1 &porparar1
#                &error_progr
#                &cajear_capa

 
our $todas; #$opt_hash{todas}

############# OJO DE DONDE VIENE $debug!!!!!
# ---------------------------------------------------------------------------
sub inicio{
    my ($commlineinfo)=@_;


   my  $progname=$commlineinfo->{progname};    
    my $ohd= $commlineinfo->{opciones}->{d};
    my $nv= $commlineinfo->{opciones}->{noverb};
    my $tod= $commlineinfo->{opciones}->{todas};

    
    $d=$ohd;
    $todas=$tod;
    $noverb=$nv;
#    $CORTOA=$arch; 
 
    
#$GlobalesSimusol::CORTOA = $CORTO;
####$GlobalesSimusol::PRINCIPAL = $CORTO;
#$GlobalesSimusol::PROPIOA = $PROPIO;  



#$PRINCIPAL=$arch;
 
# para paraplot
#  my $archguardar = $ref1->{PROPIOSIN}; 
#  my $archguardarcongnus = $ref1->{ARCHGUARDARCONGNUS};
#  my $PROPIO = $ref1->{PROPIO};
#  my $CORTO = $ref1->{CORTO};
#  my $date = $ref1->{DATECORTO};
#  my $paraplotSIMULADO = '';
#  if () {


    
# ($BASEARCHA, $CORTOA, $PROPIOA, $CORTOASINDIA, $PROPIOASINDIA , $pwdori);
}
# ---------------------------------------------------------------------------


sub atender_opt_hash_todas{
  comfin('comG atender_opt_hash_todas',@_);
  my $ref = $_[0];  
  for (my $numarch = 0; $numarch < @{$ref->{cortosin}}; $numarch ++) {
      my $cortosin = $ref->{cortosin}->[$numarch];
      if ($todas) {
          (my $agre = $todas) =~ s/\s+/_/g;
          $cortosin .=  $agre;
      };	  
      $ref->{guardarcortosin}->[$numarch] = $cortosin;
  };
  comfin('finG atender_opt_hash_todas',@_);
}#atender_opc_hash_todas    
# ---------------------------------------------------------------------------
sub comfin{ #uso comfin('com xxxxxx', @_)   o comfin('fin xxxxxx', @_)
  # o comfin('fin xxxxxx', @_,$lisque,$ref,'impr')
  # o comfin('fin xxxxxx',,$lisque,$ref,'impr')
  # 'impr' para que llame a impr_datos con $lisque y $ref
  return ''  unless $debug; 
  #  my $rrrr = $refarchers[0];
  my @viene = @_;
  my $primera = shift @viene; my $cosa = ''; 
  if (@viene >15) {
      print STDERR ".....  $primera con muchos argumentos\n";
      return;
  };    
  my @simplif;
  while (@viene) {
      my $nuevo;
      if (not defined $viene[0]) {
          $nuevo = 'no definido';
      } elsif ($viene[0] =~   /^ARRAY\(\w*/) {
	  my $texto = []; @$texto = @{$viene[0]};
          if (grep (/^(ARRAY|HASH)/,$texto)) {
              $nuevo = $texto;
	  } else {
              if (@$texto > 8) {
                   $nuevo = 'ARRAY (' . scalar (@$texto);   
                   my @lisundef = grep(do{not defined $_},@$texto);
                   @lisundef and $nuevo .= ' con undef)' or $nuevo .=')';
              } else {
                       $nuevo = "[@$texto]";
              }
          };
      } elsif ($viene[0] =~ /^HASH\(\w*\)$/) {
          my $texto = {};%$texto = %{$viene[0]};	  
          my $soy = $texto->{soy}; $soy and $soy = "soy $soy" or $soy = '';
          $nuevo = 'HASH ('. $soy . ' (' . scalar (keys (%$texto)) . '))'; 
          if (defined $texto->{CORTOSIN}) {
              $nuevo .= " - (($texto->{CORTOSIN})): ";
          };
          if (grep (/^(ARRAY|HASH)/),%$texto or scalar keys%$texto > 4) {
              $nuevo .= $texto;
          } else {
              $nuevo .= hashrenglon($texto);
          };
      } elsif ($viene[0] =~ /^SCALAR\(\w*\)$/) {
          $nuevo = 'SCALAR (' . length(${$viene[0]}) . ')';
      } else {
	  my $texto = $viene[0];
	  if ($texto eq '') {
	      $nuevo = 'nada';
	  } elsif ($texto !~ /\S/) {
	      $nuevo = 'blancos';
	  } else {    
              ($nuevo = $texto) =~ s/^\s+/ /;
              if ($nuevo eq '') {
                  $nuevo = 'nada';
              } elsif (length $nuevo < 16) {
              } elsif($nuevo =~ /^\//) {
                  my $largo = length $nuevo; my $comi = $largo - 15;
                  $nuevo = '...'. substr($nuevo,$comi); 
              } elsif (length $nuevo > 80) {
                  $nuevo = substr($nuevo,0,80) .'...';
              };
	      
	  };    
          if ($texto =~ /,/) {
 #             $nuevo .= ' con comas';
          };
      };
      push @simplif, $nuevo;
      shift @viene;
  };
  my ($donde,$comfin);
  if ($_[0] =~ /^\s*(\w+)\s+(\S\w*)/){
      ($donde,$comfin) = ($1,$2);
      if (@_ >3 and defined $_[-1] and defined $_[-2] and defined $_[-3] 
         and $_[-1] eq 'impr' and  $_[-2] =~ /HASH\(/ and $_[-3] =~ /ARRAY/) {
            impr_datos("para $comfin pide comfin",$_[-3],$_[-2]);
     };
  };
  eco(" $_[0](" . join(',',@simplif). ')'); #para comfin
  return '';
}#comfin
# ---------------------------------------------------------------------------

# ---------------------------------------------------------------------------
sub comfinVIEJO{ #uso comfin('com xxxxxx', @_)   o comfin('fin xxxxxx', @_)
  # o comfin('fin xxxxxx', @_,$lisque,$ref,'impr')
  # o comfin('fin xxxxxx',,$lisque,$ref,'impr')
  # 'impr' para que llame a impr_datos con $lisque y $ref
  return ''  unless $debug;
  my @viene = @_; shift @viene;
  my @simplif;

  foreach(@viene) {
      next if not defined $_;
      my $texto = substr($_,0,80);
      my $nuevo = $_;
      if ($texto =~ /^ARRAY\(/) { 
         my @lisundef = @$_; @lisundef = grep(do{not defined $_},@lisundef);
          if(@$_>8) {
             $nuevo = 'ARRAY (' . scalar (@$_) . ')'    
          } elsif (@lisundef) {
             $nuevo = 'ARRAY (' . scalar (@$_) . 'con undef)'
	  } else {
             $nuevo = "[@$_]";
          }
      } elsif ($texto =~ /^HASH\(/) {
       $nuevo = 'HASH (' . scalar (keys (%$_ )) . ')'; 
          if (defined $_->{archivo}) {
              $nuevo .= " - $_->{archivo}: ";   
          } elsif (defined $_->{refcirc} and defined $_->{refcirc}->{archivo}) { 
              $nuevo .= " - $_->{refcirc}->{archivo}: ";
          };
      } elsif ($texto =~ /^SCALAR\(/) {
	  $nuevo = 'SCALAR (' . length($$_) . ')';
      } elsif (@_>2) {
          $nuevo = "/$texto/";
      } else {
          $nuevo = "/$_/";
      };
      push @simplif, $nuevo;
  };
  my ($donde,$comfin);
  if ($_[0] =~ /^\s*(\w+)\s+(\S\w*)/){
     ($donde,$comfin) = ($1,$2);
    if (@_ >3 and defined $_[-1] and defined $_[-2] 
         and $_[-1] eq 'impr' and  $_[-2] =~ /HASH\(/ ) {
      impr_datos("para $comfin pide comfin $donde",$_[-3],$_[-2]);
     };
  };
  eco(" $_[0](" . join(',',@simplif). ')'); #para comfin
  return '';
} #comfin
# ---------------------------------------------------------------------------
# ---------------------------------------------------------------------------
sub descartar_archivos{
  comfin('comG descartar_archivos',@_);
  my @dirarray = @_; my @nuevo_dirarray;
  foreach my $arch (@dirarray) {
      impr_debug(__LINE__.' Glob $arch',$arch);
      next if -d $arch;
      (my $ext = $arch) =~ s/^(.*)\.(\w+)$/$2/;
      next if $no_ext{$ext};
      next if $arch =~ /_run$/;
      next if $arch eq 'modellib.dat' or $arch eq 'funciones.for';
      push @nuevo_dirarray,$arch;
  };
  impr_debug(__LINE__.' Glob @nuevo_dirarray',(join "\n",@nuevo_dirarray));
  comfin('finG descartar_archivos',@nuevo_dirarray);
  return @nuevo_dirarray;    
}#descartar_archivos    
# ---------------------------------------------------------------------------
sub cargar_datos{
   comfin('comG cargar_datos',@_); 
   my ($ref,$que,$nombre,$valor,$tipo,$tiparg,$refarg,$mensaje) = @_;
   #impr_dat_que($mensaje,$nombre, $que, $ref, 'cg0'); 
   $tipo eq 'n' and defined $ref->{"TIPO$que"} and
     defined $ref->{"TIPO$que"}->{$nombre} and 
       $ref->{"TIPO$que"}->{$nombre} =~ /[afpqx]/  and do{
           $ref->{"VIEJO$que"}->{$nombre} = $ref->{$que}->{$nombre};
           $ref->{"TIPOVIEJO$que"}->{$nombre} = $ref->{"TIPO$que"}->{$nombre};
       };
   impr_par(__LINE__.' Glob '."$que $nombre $mensaje",$tiparg,$refarg);
   $ref->{$que}->{$nombre} = $valor;
   $ref->{"TIPO$que"}->{$nombre} = $tipo;
   $ref->{"TIPARG$que"}->{$nombre} = $tiparg;
   $ref->{"REFARG$que"}->{$nombre}= $refarg;  
   #impr_dat_que($mensaje,$nombre, $que, $ref, 'cg1'); 
   push @{$ref->{"lista$que"}},$nombre;
   @{$ref->{"lista$que"}} = union_conjunto(@{$ref->{"lista$que"}});
   impr_debug(__LINE__.' DOLORES $ref->{"lista$que"} $que '.$que,
     Dumper $ref->{"lista$que"});
   if ($que eq 'PARAMETROS') {
       $ref->{valor2cual}->{$valor} = $nombre;
   };    
   comfin('finG cargar_datos'); 
   return;
}#cargar_datos   
# ---------------------------------------------------------------------------
sub cargar_datos_tipotok{
  comfin('comG cargar_datos_tipotok',@_);
  my ($refcirc,$que,$nombre,$tipotok,$valor,$tipo,$tiparg,$refarg,$mens,
     $unid,$ori,$lugar,$coment)= @_;#dejo algunos
  $refcirc->{TIPOTOK}->{$nombre} = $tipotok;
  impr_debug(__LINE__.' Glob $nombre,$mens',[$nombre,$mens]);
  foreach my $pal (qw(uni ori lugar coment)) {$refcirc->{$pal}->{$nombre} = ''};
  $unid and $refcirc->{unid}->{$nombre} = $unid;
  defined $ori and $refcirc->{ori}->{$nombre} = $ori;
  $lugar and $refcirc->{lugar}->{$nombre} = $lugar;
  $coment and $refcirc->{coment}->{$nombre} = $coment;
#  impr_debug(__LINE__.' Glob TIPOTOK',Dumper $refcirc->{TIPOTOK});
  cargar_datos($refcirc,$que,$nombre,$valor,$tipo,$tiparg,$refarg,$mens);
 # impr_datos(__LINE__.' Glob',[$que],$refcirc);
  comfin('finG cargar_datos_tipotok');    
}#cargar_datos_tipotok;    
# ---------------------------------------------------------------------------
sub cargar_tiparg_refarg{
  my ($refcirc,$que,$nombre,$tiparg,$refarg) = @_;
  $refcirc->{"TIPARG$que"}->{$nombre} = $tiparg;
  @{$refcirc->{"REFARG$que"}->{$nombre}} = @{$refarg};
}#cargar_tiparg_refarg  
# ---------------------------------------------------------------------------
sub copiar_datos{
  comfin('comG copiar_datos',@_);    
  my ($refo, $queo, $nombreo, $refd, $qued, $nombred, $mensaje) = @_;
  impr_dat_que($mensaje,$nombreo, $queo, $refo, 'cp0');  
  my $tipoo = $refo->{"TIPO$queo"}->{$nombreo};
  my $tipod = $refd->{"TIPO$qued"}->{$nombred};
  defined $tipoo and $tipoo eq 'n' and defined $tipod and $tipod =~ /[afpqx]/
      and $refd->{"VIEJO$qued"}->{$nombred} = $refd->{$qued}->{$nombred};
  $refd->{$qued}->{$nombred} = $refo->{$queo}->{$nombreo};
  $refd->{"TIPO$qued"}->{$nombred} = $refo->{"TIPO$queo"}->{$nombreo};
  $refd->{"TIPARG$qued"}->{$nombred} = $refo->{"TIPARG$queo"}->{$nombreo};
  $refd->{"REFARG$qued"}->{$nombred} = $refo->{"REFARG$queo"}->{$nombreo};
  $refd->{TIPOTOK}->{$nombred} = $refo->{TIPOTOK}->{$nombreo};
  my $agre = substr($queo,0,3). "-$nombreo";
  impr_dat_que($mensaje."_$agre",$nombred, $qued, $refd, 'cp1');  
  push @{$refd->{"lista$qued"}},$nombred;
  comfin('finG copiar_datos');    
}#copiar_datos
# ---------------------------------------------------------------------------
sub borrar_datos{
  comfin('comG borrar_datos',@_);    
  #con $modo verdadero no se registra como borrado el parametro
  my ($ref,$que,$nombre,$modo,$mensaje) = @_;
  if ($que eq 'PARAMETROS') {
      if (not $modo  and not $ref->{parametroscreados}->{$nombre}
              and defined $ref->{PARAMETROS}->{$nombre}) {
          copiar_datos($ref,'PARAMETROS',$nombre,$ref,'PARBORR',$nombre
		,__LINE__,' Glob ');
      };
  };
  #impr_dat_que($mensaje,$nombre, $que, $ref, 'br'); 
  delete $ref->{$que}->{$nombre};
  delete $ref->{"TIPO$que"}->{$nombre};
  delete $ref->{"TIPARG$que"}->{$nombre};
  delete $ref->{"REFARG$que"}->{$nombre}; 
  @{$ref->{"lista$que"}} = grep (do {$_ ne $nombre}, @{$ref->{"lista$que"}});
  comfin('finG borrar_datos');    
}#borrar_datos   
# ---------------------------------------------------------------------------
sub mover_datos{
  comfin('comG mover_datos',@_);    
  #se confia que nunca el nombre descartado haya entrado de nuevo
  my ($refo, $queo, $nombreo,$refd, $qued, $nombred,$mensaje) = @_;
  return if $refo eq $refd and $queo eq $qued and $nombreo eq $nombred;
  $refd->{$qued}->{$nombred} = $refo->{$queo}->{$nombreo};
  $refd->{"TIPO$qued"}->{$nombred} = $refo->{"TIPO$queo"}->{$nombreo};
  $refd->{"TIPARG$qued"}->{$nombred} = $refo->{"TIPARG$queo"}->{$nombreo};
  $refd->{"REFARG$qued"}->{$nombred} = $refo->{"REFARG$queo"}->{$nombreo};
  #impr_dat_que($mensaje,$nombreo, $queo, $refo, 'bmv'); 
  delete $refo->{$queo}->{$nombreo};
  delete $refo->{"TIPO$queo"}->{$nombreo};
  delete $refo->{"TIPARG$queo"}->{$nombreo}; 
  delete $refo->{"REFARG$queo"}->{$nombreo}; 
  my $agre = substr($queo,0,3). "-$nombreo";
  push @{$refd->{"lista$qued"}},$nombred;
  @{$refo->{"lista$queo"}}=grep (do{$_ ne $nombreo},@{$refd->{"lista$queo"}}); 
  #impr_dat_que("$mensaje$agre",$nombred, $qued, $refd, 'mv'); 
  comfin('finG mover_datos');    
}#mover_datos
















# ---------------------------------------------------------------------------
sub cargar_datosV{
   comfin('com cargar_datos',@_); 
   my ($ref,$que,$nombre,$valor,$tipo,$tiparg,$refarg,$mensaje) = @_;
   #impr_dat_que($nombre, $que, $mensaje, $ref, 'cg0'); 
   $tipo eq 'n' and defined $ref->{"TIP$que"}->{$nombre} and 
       $ref->{"TIP$que"}->{$nombre} =~ /[afpqx]/  and do{
           $ref->{"VIEJO$que"}->{$nombre} = $ref->{$que}->{$nombre};
           $ref->{"TIPVIEJO$que"}->{$nombre} = $ref->{"TIP$que"}->{$nombre};
       };
   $ref->{$que}->{$nombre} = $valor;
   $ref->{"TIP$que"}->{$nombre} = $tipo;
   $ref->{"TIPARG$que"}->{$nombre} = $tiparg;
   $ref->{"REFARG$que"}->{$nombre}= $refarg;  
   #impr_dat_que($nombre, $que, $mensaje, $ref, 'cg1');
}   
# ---------------------------------------------------------------------------
sub copiar_datosV{
   my ($refo, $queo, $nombreo, $refd, $qued, $nombred, $mensaje) = @_;
   #impr_dat_que($nombreo, $queo, "$mensaje", $refo, 'cp0'); 
  impr_datos(__LINE__.' Glob', ['DATOS','PARAMETROS'], $refo);

   my $tipoo = $refo->{"TIP$queo"}->{$nombreo};
   my $tipod = $refd->{"TIP$qued"}->{$nombred};
   defined $tipoo and $tipoo eq 'n' and defined $tipod and $tipod =~ /[afpqx]/
       and $refd->{"VIEJO$qued"}->{$nombred} = $refd->{$qued}->{$nombred};
   $refd->{$qued}->{$nombred} = $refo->{$queo}->{$nombreo};

   $refd->{"TIP$qued"}->{$nombred} = $refo->{"TIP$queo"}->{$nombreo};
   $refd->{"TIPARG$qued"}->{$nombred} = $refo->{"TIPARG$queo"}->{$nombreo};
   $refd->{"REFARG$qued"}->{$nombred} = $refo->{"REFARG$queo"}->{$nombreo};
   my $agre = substr($queo,0,3). "-$nombreo";
   #impr_dat_que($nombred, $qued, "$mensaje($agre)", $refd, 'cp1'); 
}   
# ---------------------------------------------------------------------------
sub borrar_datosV{
   #con $modo verdadero no se registra como borrado el parametro
   my ($ref,$que,$nombre,$modo,$mensaje) = @_;
   if ($que eq 'PARAMETROS') {
       if (not $modo  and not $ref->{parametroscreados}->{$nombre}
               and defined $ref->{PARAMETROS}->{$nombre}) {
           copiar_datos($ref,'PARAMETROS',$nombre,$ref,'PARBORR',$nombre
			,__LINE__,' Glob ');
       };
   };
   #impr_dat_que($nombre, $que, $mensaje, $ref, 'br'); 
   delete $ref->{$que}->{$nombre};
   delete $ref->{"TIP$que"}->{$nombre};
   delete $ref->{"TIPARG$que"}->{$nombre};
   delete $ref->{"REFARG$que"}->{$nombre}; 
}   
# ---------------------------------------------------------------------------
sub mover_datosV{
   #se confia que nunca el nombre descartado haya entrado de nuevo
   my ($refo, $queo, $nombreo,$refd, $qued, $nombred,$mensaje) = @_;
   return if $refo eq $refd and $queo eq $qued and $nombreo eq $nombred;
   $refd->{$qued}->{$nombred} = $refo->{$queo}->{$nombreo};
   $refd->{"TIP$qued"}->{$nombred} = $refo->{"TIP$queo"}->{$nombreo};
   $refd->{"TIPARG$qued"}->{$nombred} = $refo->{"TIPARG$queo"}->{$nombreo};
   $refd->{"REFARG$qued"}->{$nombred} = $refo->{"REFARG$queo"}->{$nombreo};
   #impr_dat_que($nombreo, $queo, $mensaje , $refo, 'bmv'); 
   delete $refo->{$queo}->{$nombreo};
   delete $refo->{"TIP$queo"}->{$nombreo};
   delete $refo->{"TIPARG$queo"}->{$nombreo}; 
   delete $refo->{"REFARG$queo"}->{$nombreo}; 
   my $agre = substr($queo,0,3). "-$nombreo";
   #impr_dat_que($nombred, $qued, "$mensaje$agre", $refd, 'mv'); 
}   
#----------------------------------------------------------------------------
sub comparar_icono{
  my ($ref,$descrig,$rh) = @_;
  my $rhv = $ref->{$descrig};my $coderror = 0; 
  if (defined $rhv->{nombre}) {
      foreach my $tema ('nombre','cod','codvalor') {
          $rhv->{$tema} eq $rh->{$tema} or
             return ($tema, $rhv->{$tema}, $rh->{$tema});
      };
  };
  foreach my $tema ('nombre','cod','codvalor') {
      $rhv->{$tema} =  $rh->{$tema};
  };
  return '';
}#comparar_icono

#----------------------------------------------------------------------------
sub crear_gnus{
   my $BASEARCH = $_[0];
   my $dire = $BASEARCH . 'gnus';
   -e $dire and not -d $dire and do{
       print '=' x 70,"
   ======  Estoy por borrar un archivo de nombre $dire; de otro modo termino;
   ======  Borro $dire (s/n)? ";
       my $resp = <STDIN>;
       $resp =~ /n/i 
         and die "Con un archivo \"gnus\" en $BASEARCH no puedo trabajar\n";
       system "rm $dire";
    };
    system "mkdir $dire"  and porparar1(254,0,
         " Simusol no puede trabajar sin permisos para escribir archivos");
} # crear_gnus

# ---------------------------------------------------------------------------
sub descripcion_enganches_rama{
  #comfin('comG descripcion_enganches_rama', @_);
  # muestra los enganches de la rama dada por su numero de objeto
  # y los identificadores de los objetos enganchados
  my $rama = $_[0]; my $numcapa = $laylista->[$rama]; my $numfile = $filelista->[$rama];
  my $refgraf = $refgrafers[$numcapa];
  $refgraf->{resumen}->{$rama} = [];  
  my @listaenganches = @{$refgraf->{enganches}->{$rama}};
  my @texto ;
      foreach my $enganche (@listaenganches) {
          my ($handle,$to,$connection) = @$enganche{'handle','to','connection'};
          my $ij = $Dia2Simusol[$numfile]->{$to};
          my $cod = $codlista->[$ij]; my $iden = $cod . $textolista->[$ij];
          push @texto, sprintf "%34s|%1s: %6s(%1s) %4s",'',$handle,$iden,$connection,$to;
          if ($cod =~ /$codelemTs/) {unshift @{$refgraf->{resumen}->{$rama}},'elem';
          } elsif ($cod =~/$codnodos/) {push @{$refgraf->{resumen}->{$rama}},'nodo';
          } elsif ($cod =~/$codramas/) {push @{$refgraf->{resumen}->{$rama}},'rama';
          }; 				 
      };
  if (@{$refgraf->{resumen}->{$rama}} == 0) {
      push @{$refgraf->{resumen}->{$rama}},'nada';
  };    
 push @texto,sprintf "%34s|%1s",'','resumen '.join (' ',@{$refgraf->{resumen}->{$rama}});
  #comfin('finG descr_enganches_rama', @texto);
  return @texto;
}#descripcion_enganches_rama


# ---------------------------------------------------------------------------
sub descripcion_nombre{
# describe a un objeto dado por su identificacion $iden "para sceptre",
# en el hash referido por $cualobj
  #comfin ('com descripcion_nombre', @_");
  my ($iden,$cualobj) = @_; 
# REVISAR
  my ($cod,$texto) =  ($iden =~ /^(.)(.*)/);  
  my $idenn = $iden;
  if ($cod eq 'O') {$idenn  = $texto};
  my $listadescrip=''; 
  if  (not defined $cualobj->{$iden}) {
      $listadescrip .= "\n        No hay datos para describir a $iden\n";
  } else {
      my @lista = @{$cualobj->{$iden}};
      
      for (my $i = 0; $i < @lista; $i ++) {
        my $obj = $lista [$i]; 
        $listadescrip .= "  $idenn:   " . descripcion_objeto($obj) ."\n" ;
     };
  }; 
  #comfin ('fin descripcion_nombre');
  return $listadescrip;
} #descripcion_nombre
# ---------------------------------------------------------------------------
sub descripcion_objeto{
  #describe a un objeto dado por su numero de objeto que le toco
  #comfin ('com descripcion_objeto', @_);
  my $obj=$_[0];
  my ($cod,$codvalor,$texto) 
      = ($codlista->[$obj],$codvalorlista->[$obj], $textolista->[$obj]);
  #impr_debug(__LINE__.' Glob desc._objeto ',[$cod,$codvalor,$texto]);
  if ($codlista->[$obj] ne 'O') { #para 'O' se usa descrip_cuadro
     $texto  = $cod . $texto};
     my ($capa,$lug);
     my ($pl,$sh) =($plantillalista->[$obj], $shapelista->[$obj]);
     my $nombre= '"'.$nombreshape->[$sh].'"';
     if (defined $comonombre->{$pl .'c'. $sh}) {
          $nombre .= ' '. $comonombre->{$pl .'c' . $sh}. " $texto";
     } elsif (defined $quenombre{$cod}) {
          $nombre .= " $quenombre{$cod} $texto";
     };
     if ($lugarlista->[$obj]) {
        $lug = $lugarlista->[$obj]; 
        $lug =~ s/\s*$//; $lug =~ s/^\s*//; 
     } else {
       $lug = '??'
     }; 
     if (defined $laylista->[$obj]  and $nombrelay->[$laylista->[$obj]]) {
        $capa = $nombrelay->[$laylista->[$obj]];
        $capa =~ s/.*\(0 \- (.+)\)/$1/; 
        $capa =~ s/^\s*(.+)/$1/;$capa =~ s/\s*$//;
     }  else {$capa = '??';
  };  
  #comfin ('fin descripcion_objeto');
  return "$nombre (en $lug, $capa)";
}
# ---------------------------------------------------------------------------
sub descripcion_cuadro {
    my $numcuadro = $_[0];
    (my $numobj = $numcuadro) =~ s/\#numobj(.+)/$1/;
    impr_debug(__LINE__.' Glob $numcuadro,$numobj',[$numcuadro,$numobj]);
#    impr_debug(__LINE__.' Glob $lugarlista',Dumper $lugarlista);
    my $lug = $lugarlista->[$numobj]; $lug =~ s/\s*$//;
    my $il = $laylista->[$numobj];
    my $capa = descripcion_capa($laylista->[$numobj]);
    return "cuadro $textolista->[$numobj] en $lug-($nombrelay->[$il])";
}#descripcion_cuadro

# ---------------------------------------------------------------------------
sub descripcion_cuadroV {
    my $numobj = $_[0];
    $numobj =~ s/\#numobj(.+)/$1/;
    my $lug = $lugarlista->[$numobj]; $lug =~ s/\s*$//;
    my $il = $laylista->[$numobj];
    my $capa = descripcion_capa($laylista->[$numobj]);
    return "cuadro $textolista->[$numobj] en $lug-($nombrelay->[$il])";
}
# ---------------------------------------------------------------------------
sub descripcion_icono{
  # descripcion (el nombre de la shape) de la forma dada por el $plcshape
  # que le toco 
   my $plcshape = $_[0];
   my ($pl,$shape) = $plcshape =~ /(\d+)c(\d+)/;
   return $nombreplantilla->[$pl] .' - ' . $nombreshape->[$shape];
}
# ---------------------------------------------------------------------------
sub descripcion_capa{
   my $il = $_[0];
   if (defined $nombrelay->[$il]) {
      return "capa $il: $nombrelay->[$il]";
   } else {
      return "capa $il";
   };    
}
# ---------------------------------------------------------------------------
sub repite_nombre{ 
   my ($iden,@listita)=@_;
   print 
    "El identificador $iden está repetido para los elementos  en: \n     ";
   map (do {print "$lugarlista->[$_]  "},@listita);print "\n";
   $avisosgrav++
}
# ---------------------------------------------------------------------------
sub tomar_datos{
  my ($ref,$que,$nombre,$mensaje) = @_;
  return ($ref->{$que}->{$nombre}, $ref->{"TIPO$que"}->{$nombre},
           $ref->{"TIPARG$que"}->{$nombre}, $ref->{"REFARG$que"}->{$nombre}); 
}#tomar_datos
# ---------------------------------------------------------------------------
sub tomar_tiparg_refarg{
  my ($ref,$que,$nombre) = @_;   
  return ($ref->{"TIPARG$que"}->{$nombre},$ref->{"REFARG$que"}->{$nombre});
}#tomar_tiparg_refarg   
# ---------------------------------------------------------------------------
sub impr_capa{
  return unless $debug;
  my ($mensaje,$numcapa) = @_;
  print STDERR " impr_capa $mensaje: empieza para numcapa = $numcapa\n";
  my $reflay = $reflayers[$numcapa]; my $refgraf = $refgrafers[$numcapa];
  my $numfile = $reflay->{NUMARCHIVOCAPA};
  print STDERR 
    "numfile = $numfile  $nombrefile->[$numfile] $reflay->{clasecapa}\n";
  foreach my $palabra ('pcs ele','pcst','pcs rama','plantilla') {
      print STDERR "refgraf tienes $palabra: ";
      my $reflista = $refgraf->{tienes}->{$palabra};
      $reflista and print STDERR "@$reflista \n" or print STDERR "\n";  
  };
  #print STDERR 'refgraf resumen: ',Dumper $refgraf->{resumen}; 
  print STDERR "reflay tienes textocla: ";
  my $reflista = $reflay->{tienes}->{textocla};
  $reflista and print STDERR "@$reflista \n" or print STDERR "\n";  
  if ($reflay->{tienes}->{clase_formula}) {
      my @refpares = @{$reflay->{tienes}->{clase_formula}};
      foreach my $refpar (@refpares) {
          impr_debug(__LINE__.' Glob',Dumper $refpar);
	  my ($clasepcs,$formula) = @$refpar;
	  print STDERR '[',$clasepcs,',',$formula,']',' ';
      };
      print STDERR "\n";
  };	  
  
  print STDERR "impr_capa $mensaje: termina para numcapa = $numcapa\n";
  return;
}#impr_capa 
# ---------------------------------------------------------------------------
sub impr_conects{
  return unless $debug;  
  comfin('comG impr_conects',@_);
  my ($mensaje,$numcapa) = @_; my $refgraf = $refgrafers[$numcapa]; my $numfile = $refgraf->{numfile}; 
  my @lisobjs = (0 .. scalar @$codlista -1 );
  @lisobjs = grep (do{$codlista->[$_] =~ /$codconects/},@lisobjs);
  impr_debug($mensaje,\@lisobjs);
  my $formato = "%2s %3s %6s %4s %16s|%9s|%12s|%1s\n";
  printf STDERR $formato,'#','','iden',' pcs','lugar(conect)   ','sheet','shape','lista uniones'; 
  foreach my $ij (@lisobjs) {
      my $fileobj = $Simusol2Dia[$ij]->[1];
      my $iden = $codlista->[$ij].$textolista->[$ij];
      my $sheet = $refglobal->{nombreplantilla}->[$plantillalista->[$ij]];
      my $shape = $refglobal->{nombreshape}->[$shapelista->[$ij]];    
      my $pcs = $plantillalista->[$ij]. 'c' .$shapelista->[$ij];
      my $lugar = $lugarlista->[$ij];
      my $reflistaiden = $refgraf->{listaconect}->{$ij};
      $reflistaiden or next;
      my $texto = (join(',',@$reflistaiden) or '');
      printf STDERR $formato,$ij,$fileobj,$iden,$pcs,$lugar,$sheet,$shape,$texto;
 };
  comfin('comG impr_conects');
}#impr_conects;
# ---------------------------------------------------------------------------



sub impr_cualobjref{
   return unless $d;
   my ($mensaje,@lisref) = @_; 
   #my $refcirc; 
   my %cosa; 
   imprhashrenglon(__LINE__." Glob $mensaje ", $lisref[0]);
   if (defined $lisref[0]->{refcirc}) {
      $cosa{$lisref[0]} = 'capa ';
      $cosa{$lisref[0]->{refcirc}} = 'circuito';
      push (@lisref,$lisref[0]->{refcirc});
   } else {
      $cosa{$lisref[0]} = 'no es capa ';
   };
   foreach my $ref (@lisref) {    
     my @liscuales = keys %{$ref};
     @liscuales = grep (/^cualobj/,@liscuales);
     foreach my $cualque (@liscuales) {
       print STDERR "...... $mensaje $cosa{$ref}$cualque\n";
       my @lisobjetos = keys %{$ref->{$cualque}};
       foreach (@lisobjetos) {
           print STDERR "$_=> [ " .  
                  join (' ', @{$ref->{$cualque}->{$_}}) . " ]\n";
       };
     };
   };
   print "fin impr_cualobjref $mensaje\n";   
}
# ---------------------------------------------------------------------------
#sub impr_identi{
#   # sólo se usa para depurar
#   my ($mensaje,$refcirc) = @_; 
#   return unless $d;
#   print STDERR "----------------------- com Glob impr_identi: $mensaje
#                   a pedido de archivo $refcirc->{CORTO}\n";
#   impr_debug(__LINE__.' Glob cuallay',Dumper $cuallay);
#   impr_debug(__LINE__.' Glob cualplantilla', Dumper $cualplantilla);
#   impr_debug(__LINE__.' Glob cualshape', Dumper $cualshape);
#   impr_debug(__LINE__.' Glob comonombre', Dumper $comonombre);
#   impr_debug(__LINE__.' Glob comocod', Dumper $comocod);
#   impr_debug(__LINE__.' Glob comocodvalor', Dumper $comocodvalor);
#   impr_obj($mensaje,'[RJCEZT]',$refcirc->{capas});
#   print "                   a pedido de archivo $refcirc->{CORTO}
#----------------------- fin Glob impr_identi: $mensaje\n";
#}
# --------------------------------------------------------------------------
#sub impr_dat_que{
#  return unless $d;
#  my ($nombre,$que,$mensaje,$ref,$clave) = @_; 
#  defined $mensaje or $mensaje = '';
#  my $form = "i.d:%3s%6s=>%1s|%6s|%24s|%2s %13s\n";    
#  if (defined $ref->{$que}->{$nombre}) {
#      my ($dato,$tipdato,$tipargdato,$refargdato) 
#            = ($ref->{$que}->{$nombre}
#               ,$ref->{"TIP$que"}->{$nombre}
#               ,$ref->{"TIPARG$que"}->{$nombre}
#               ,$ref->{"REFARG$que"}->{$nombre});
#      not defined $tipdato and $tipdato = '';      
#      not defined $tipargdato and $tipargdato ='';
#      my $largo = length($dato); $largo < 55 and $largo = 24;
#      $dato = substr($dato . ' ' x 50,0,$largo);
#      printf STDERR $form, $clave, $nombre,
#         $tipdato, $tipargdato, $dato ,$que, $mensaje;
#      print STDERR  "i.d:$clave $nombre REFARG            ", __LINE__. 'Glob '
#                   ,"@$refargdato","\n"
#                 if defined $refargdato and $refargdato =~ /^ARRAY/; 
#  } else {
#      printf STDERR $form,$clave,"$nombre",'','','No está'
#         ,'','',$mensaje; 
#  };
#  return;
#   
#} #impr_dat_que
# --------------------------------------------------------------------------
sub impr_dat{
  # imprime datos para una sola posible variable del sceptre
  # sólo se usa para depurar
  return unless $d;
  my ($nombre,$mensaje,$ref,$clave) = @_; my $que;
  my @ternas;
  for my $posque ('DATOS','PARAMETROS') {
      if (defined $ref->{$posque} and defined $ref->{$posque}->{$nombre}) {
           push @ternas,[$posque,$ref->{$posque}->{$nombre},$nombre];  
           last
      }
  };
  my $form = "i.d:%3s%6s=>%1s|%6s|%24s|%2s %13s\n";    
  $mensaje or $mensaje = '??';
  if (@ternas == 0) { 
      if (defined $ref->{cualobjtextonodo}->{$nombre}) {
          printf STDERR $form,$clave,$nombre,'','','Nodo','',$mensaje;
      };
      my $pre = '';
      if ($nombre =~ s/^([VJ])//) {
          $pre = $1; my $dato = $ref->{DATOS}->{$nombre};
          if (defined $dato){
              push @ternas, ['DATOS',$dato,$nombre];
          } else {
	      printf STDERR $form,$clave,"$pre$nombre",'','','No está'
                          ,'','',$mensaje; 
              return;
          };
      } elsif ($nombre =~ s/^(TEMP)\s*//i) {
	  $pre = $1;
          my $datoT = $ref->{TEMP}->{$nombre};
          my $datot=  $ref->{temp}->{$nombre}; 
          if (defined $datoT){
              push @ternas, ['TEMP',$datoT,$nombre]
          } elsif (defined $datot) {
              push @ternas, ['temp',$datot,$nombre]
          } else {
	      printf STDERR $form,$clave,"$pre$nombre",'','','No está'
                  ,'',$mensaje; 
              return;     
          };              
     } elsif (defined $ref->{cualobjnoigno}->{$nombre}) {
          my $lugar = $lugarlista->[$ref->{cualobjnoigno}->{$nombre}->[0]];
	  printf STDERR $form,$clave, $nombre,'','Es el objeto en $lugar?',''
                  ,'', $mensaje;
          return;                   
     } else {
	  printf STDERR $form,$clave, $nombre,'','','No se encuentra',''
                          , $mensaje;
          return;
     }     
  };
  foreach my $terna (@ternas) {
      my ($que, $dato, $nombre) = @$terna;
      my $largo = length($dato); $largo < 55 and $largo = 24;
      $dato = substr($dato . ' ' x 50,0,$largo);
      my $tipdato = ($ref->{"TIPOS$que"}->{$nombre} or '');
      my $tipargdato = ($ref->{"TIPARG$que"}->{$nombre} or '');
      my $usapar  = ($ref->{'USAPAR'}->{$nombre} or '');
      $usapar and $usapar = 'par '. $usapar or 
            $usapar = $que; 
      # solo util en PARAMETROS
      printf STDERR $form, $clave, $nombre, 
                $tipdato, $tipargdato, $dato ,$usapar,$mensaje;
  };
  return;	  
}# impr_dat
# ---------------------------------------------------------------------------
# ---------------------------------------------------------------------------
sub impr_datos{
  # solo se usa para depurar
  return unless $d;
  my ($ident, $lisque, $ref, $nombre) = (@_,'');
  print STDERR '                           $ident',$ident,"\n";
  return unless $ref ne '';
    
  $nombre or $nombre = $ref->{nombrecirc};
  defined $nombre or $nombre = $ref->{CORTOELE};
  defined $nombre or $nombre = $ref->{CORTO};
  defined $nombre or $nombre = "$ref->{formula} para $ref->{clasepcs}";# para un $rdennff
  defined $nombre or $nombre = 'sin nombre';
  impr_debug(__LINE__.' Glob $ref ',Dumper $ref);
  
  print STDERR "    empieza impr_datos @$lisque\n    ($ident) 
                     para $nombre ",'=' x 15,"\n";
  my ($para,$resu,$funci);
  $lisque->[0] eq 'todosque' and @$lisque =
 ('PARAMETROS','DATOS','INICIALES','CONTROLES','RESULTADOS','TABLAS','FUNCIONES');
  impr_debug(__LINE__.' Glob $lisque',$lisque);my @lista;
  foreach my $que (@$lisque) {
      $ref->{"lista$que"} or next;
      @lista = @{$ref->{"lista$que"}};
      impr_debug(__LINE__.' Glob',\@lista);
      my $otro;
      $que eq 'DATOS' and $otro = 'union'
	  or $que eq 'PARAMETROS' and $otro = 'unid';
      @lista and print STDERR
        "  =>(TIPO$que|TIPARG$que|     $que             |............)\n";
      foreach (sort @lista) {
#	  impr_debug(__LINE__.' Glob $_',$_);
          my $dato = $ref->{$que}->{$_};
	  $dato = 'no definido' unless defined $dato;
          my $largo = length($dato); 
          my $sobra = $largo - 36;my $dato2='';
	  if ($sobra >0) {
            if (defined $ref->{"TIPO$que"}->{$_} and
                $ref->{"TIPO$que"}->{$_} eq ',' and
                defined $ref->{REFLISTAVALOR}->{$_}) {
                 $dato = paraimpr3puntos(36,@{$ref->{REFLISTAVALOR}->{$_}});
              } else { 
                 $dato2 = substr($dato,36,$largo);
                 $largo < 55 and $largo = 36;
                 $dato = substr($dato . ' ' x 50,0,$largo);
              };
          };  
          my $tipodato = ($ref->{"TIPO$que"}->{$_} or '');
          my $tipargdato = ($ref->{"TIPARG$que"}->{$_} or '');
          my $tipotok = ($ref->{TIPOTOK}->{$_} or ''); 
          my $elotro  = ''; 
	  if (defined $ref->{"REFARG$que"} and
              defined $ref->{"REFARG$que"}->{$_}) {
              if ($ref->{"REFARG$que"}->{$_} =~ /ARRAY/) {
                  $elotro = "@{$ref->{'REFARG'.$que}->{$_}}"
              } else {
	          impr_debug(__LINE__.' Glob REFARG$que',
                    Dumper $ref->{"REFARG$que"});
                  error_progr(__FILE__,__LINE__,
                   '$ref->{"REFARG".$que}->{$_} no es un ARRAY'); 
	      };
          };
          if ($que =~ /^(DATOS|PARAMETROS)/  and defined $ref->{$otro} and 
	      $ref->{$otro}->{$_}) {
               $elotro = $elotro . "|$otro: $ref->{$otro}->{$_}";
          };		   
          printf STDERR 
            "%10s=>%1s|%1s|%6s|%36s|%1s\n",$_, $tipotok,$tipodato, $tipargdato, 
              $dato ,$elotro;
          $dato2 and printf STDERR 
            "%10s=>%1s|%1s|%6s|%1s\n", $_,$tipotok,'','',$dato2;
      };
      my $texto ='';
      if ($que eq 'PARAMETROS' and @lista) {
          $texto .= '   Glob parametroscreados: '.
                   join (' ', keys %{$ref->{parametroscreados}})."\n"
            if defined $ref->{parametroscreados};
          $texto .= '   Glob parametrossustituidos; '.
                   join (' ', keys %{$ref->{parametrossustituidos}})."\n"
            if defined $ref->{parametrossustituidos};
          $texto .= hashrenglon('   Glob valuespar: ', %{$ref->{valuespar}})
            if defined $ref->{valuespar};
          $texto .= '   Glob parametros usados: '.
        	    join (' ', keys %{$ref->{USAPAR}})."\n"
           if defined $ref->{USAPAR} and scalar  %{$ref->{USAPAR}}; 
      } elsif ($que eq 'RESULTADOS') {
	  $texto .= ($ref->{PEDIDOS}->{listapedidos} or '');
      } elsif ($que eq 'temp') {
          $texto .= hashrenglon('   Glob TEMP ', %{$ref->{TEMP}});
          $texto .= hashrenglon('   Glob temp ', %{$ref->{temp}});
       } elsif ($que eq 'FUNCIONES' and @lista) {
	  $texto .= hashrenglon('   Glob USAFUN',%{$ref->{USAFUN}});
	  $texto .= hashrenglon('   Glob FUNUSAFUN',%{$ref->{FUNUSAFUN}});
      }
      print STDERR $texto;
  }#que
  print STDERR  "impr_datos @$lisque, ($ident termina)
                     para $nombre ",'=' x 15,"\n  ",'=' x 60,"\n";  
}#impr_datos
# --------------------------------------------------------------------------
sub impr_dat_que{
  return unless $d;
  my ($mensaje,$nombre,$que,$ref,$clave) = @_;
  my $form = "i.d:%3s%6s=>%1s|%1s|%6s|%24s|%2s %13s\n";
  if (defined $ref->{$que}->{$nombre}) {
      my $tipotok = ($ref->{TIPOTOK}->{$nombre} or '');
      my ($dato,$tipdato,$tipargdato,$refargdato) 
            = ($ref->{$que}->{$nombre}
               ,$ref->{"TIPO$que"}->{$nombre}
               ,$ref->{"TIPARG$que"}->{$nombre}
               ,$ref->{"REFARG$que"}->{$nombre});
      not defined $tipdato and $tipdato = '';      
      not defined $tipargdato and $tipargdato ='';
      my $largo = length($dato); $largo < 55 and $largo = 24;
      $dato = substr($dato . ' ' x 50,0,$largo);
      printf STDERR $form, $clave, $nombre,$tipotok,
         $tipdato, $tipargdato, $dato ,"@$refargdato", $mensaje;
  } else {
      printf STDERR $form,$clave,"$nombre",'','','No esta'
         ,'','',$mensaje; 
  };
  return;
}#impr_dat_que
# ---------------------------------------------------------------------------
sub impr_file{
  return unless $debug;
  my ($mensaje,$numfile) = @_;
  print STDERR " $mensaje: empieza impr_file para numfile = $numfile\n";
  my $refarch = $refarchers[$numfile];
  my @keys = qw(clasearch BASEARCHCORTO CORTO DATECORTO cuantas_capas);
  foreach my $key (@keys) {
      print STDERR "$key: ",($refarch->{$key} or ''),"\n";
  };	  
  my @listas = qw(DATOS PARAMETROS INICIALES TABLAS FUNCIONES CONTROLES RESULTADOS);
  foreach my $key (@listas) {
      print STDERR "lista$key: ", join(' ',@{$refarch->{'lista'.$key}}),"\n"
        if defined  $refarch->{'lista'.$key} and  @{$refarch->{'lista'.$key}};
  };	  
  print STDERR 'tienes: ',Dumper $refarch->{tienes};
  print STDERR 'refvalores: ',Dumper $refarch->{refvalores};
  print STDERR " $mensaje: termina impresion files\n";     
}#impr_file
# ---------------------------------------------------------------------------
sub impr_FUNCIONES{
  my ($mensaje,$ref) = @_;
  impr_datos($mensaje,['FUNCIONES'],$ref);
  foreach my $nombrefun (sort keys %{$ref->{definicionFUNCIONES}}) {
      my $archivo = $ref->{archivoFUNCIONES}->{$nombrefun};
      print STDERR " funcion $nombrefun    definida en $archivo \n";
      my $reff = $reffi{$archivo};
      print STDERR "$reff->{definicionFUNCIONES}->{$nombrefun}\n";
      print STDERR "                           argumentosformales: ",
                    "@{$reff->{listaargFUNCIONES}->{$nombrefun}}\n";
      print STDERR "                                     nousados: ",
                    "@{$reff->{nousados}->{$nombrefun}}\n";
      print STDERR "     variables que no son argumentos formales: ",
                    "@{$reff->{dudosos}->{$nombrefun}}\n";
  };
  return; 
}#impr_FUNCIONES  
# ---------------------------------------------------------------------------
# ---------------------------------------------------------------------------
sub impr_identi{
   # solo se usa para depurar
   my ($mensaje,$refcirc) = @_; 
   return unless $d;
   print STDERR "----------------------- com Glob impr_identi: $mensaje
                   a pedido de archivo $refcirc->{CORTO}\n";
   impr_debug(__LINE__.' Glob cuallay',Dumper $cuallay);
   impr_debug(__LINE__.' Glob cualplantilla', Dumper $cualplantilla);
   impr_debug(__LINE__.' Glob cualshape', Dumper $cualshape);
   impr_debug(__LINE__.' Glob comonombre', Dumper $comonombre);
   impr_debug(__LINE__.' Glob comocod', Dumper $comocod);
   impr_debug(__LINE__.' Glob comocodvalor', Dumper $comocodvalor);
   impr_obj($mensaje,'[RJCEZT]',$refcirc->{capas});
   print "                   a pedido de archivo $refcirc->{CORTO}
----------------------- fin Glob impr_identi: $mensaje\n";
}#impr_identi
# ---------------------------------------------------------------------------
sub impr_obj{ 
  # datos de objetos cuyo numero esta en la lista y cumplen r.e.   
  # solo se usa para depurar
  return unless $d;
  my ($mens,$reg,$lislay,$lisobj) = @_;
  # $mens mensaje; $reg expresion regular de cod. de objetos
  # $lislay ref. a lista de num. de layers
  # $lisobj ref. a lista de num. deobjetos; sera seleccionada bajo $reg  
  # $refcirc referencia a circuito con la informacion
  defined $reg or $reg = '[RLCEJTt]';
  defined $lislay or $lislay = [0 .. scalar @reflayers -1];
  defined $lisobj or $lisobj = [0 .. (scalar @$codlista -1)];
  print STDERR "   Glob com. impr_obj: $mens" ,'=' x 15,"\n";
  my ($uni,$DATOS,$INICIALES) = ('','','');
  foreach my $il (@$lislay) {
      if ($il > @$laylista -1) {
          print STDERR "capa $il inexistente\n";
	  next
      } else {
          my $reflay = $reflayers[$il];
          my $numfile = $reflay->{NUMARCHIVOCAPA};
	  my $refcirc = $refarchers[$numfile];
          print STDERR "...........", descripcion_capa($il)
                  ," expr_reg  $reg \n";
          defined $reflay and
          do {$uni = $refcirc->{uni}; 
              $DATOS = $refcirc->{DATOS}; 
              $INICIALES = $refcirc->{INICIALES};
          };	
          my @lisobjsel = grep(
	          do{ ($codlista->[$_] =~ /$reg/) and $laylista->[$_] == $il}
	                     , @$lisobj);
         if (@lisobjsel) { 
                printf STDERR "%3s %13s %4s %7s %3s %15s %8s %20s\n" 
       ,'#', 'nombre   ' , 'iden','placsha','c.v','lugar       ','uni','datos';
	 } else {
             print STDERR "   No hay objetos de esa clase $reg\n";
             my @lisobjcod = grep ($codlista->[$_] =~ /$reg/,@$lisobj);
             my @lisobjlay = grep ($laylista->[$_] == $il,@$lisobj);
         };
          foreach my $ij (@lisobjsel) {
              my $iden = $codlista->[$ij] . $textolista->[$ij]; 
              my $plantillacshape = 
        	    $plantillalista->[$ij]. 'c' .$shapelista->[$ij];
              my $identif = $comonombre->{$plantillacshape};
	      defined $identif or $identif
                  = $nombreshape->[$shapelista->[$ij]];
              printf STDERR "%3s %13s %5s %6s %3s %15s"
                ,$ij, substr($identif . '.' x 9,0,10) . '...'
	        , substr($iden,0,6), $plantillacshape
	                , $codvalorlista->[$ij], $lugarlista->[$ij]; 
              my ($unisiden,$datosiden,$inicialesiden);
              $uni  and do{$unisiden = $uni->{$iden}}; 
	      $DATOS and do{$datosiden = $DATOS->{$iden}};
              $INICIALES and do{$inicialesiden = $INICIALES->{'V' . $iden}};
              defined $unisiden or $unisiden = 'nodef';
              defined $datosiden or
	      do {$datosiden = 'nodef';
	      };
              defined $inicialesiden or $inicialesiden = '---';
              printf STDERR"%6s %20s %6s\n"
                      , $unisiden,$datosiden,$inicialesiden; 
          };#foreach $ij
      }; #else; si hay capa
  };#for $il
  print STDERR "\n",'=' x 15, "\n";
  #imprhash('temp ',%{$refcirc->{temp}});		   
};#impr_obj
# ---------------------------------------------------------------------------
#sub impr_opciones{
#    my ($mensaje) = (@_,'');
#    print STDERR  "$mensaje opciones ", Dumper \%opt_hash;
#}#impr_opciones
# ---------------------------------------------------------------------------
sub impr_objs{
  return unless $debug;
  comfin('comG impr_objs',@_); 
# datos de objetos cuyo numero esta en la lista,cumplen reg. y "estan" en $ref  
  # solo se usa para depurar
  my ($mens,$ref,$reg,$lislay,$lisobj) = (@_,[],[]);my $coderr = '';
  print STDERR "$mens empieza impr_objs\n";
  # $mens $ref y $reg obligatorios
  # $mens mensaje
  # $reg expresion regular
  # $lislay ref. a lista de num. de layers
  # $lisobj ref. a lista de num. de objetos; si no se da, los objetos de  capas 
  # $ref con toda la informacion de iconos y barras que interese
  # puede ser un $refarch, $reflay, $refgraf
  my $numfile = $ref->{numfile};
  my ($formato,$formatoramas,$largo);
  #impr_debug(__LINE__.' Glob $ref',Dumper $ref);
  #impr_debug(__LINE__.' Glob $lislay',Dumper $lislay);
  my (@lisobjs,@lisconects,@liseleTs,@lisnodos,@lisramas,@liscuadros);
  not $reg and       error_progr(__FILE__,__LINE__,'Falta indicar $reg'); 
  if ($lisobj =~ /ARRAY/ and @$lisobj) {
      @lisobjs = @$lisobj;
      impr_debug(__LINE__.' Glob',\@lisobjs);die;
  } else {
     @lisobjs =  (0..scalar @$codlista - 1);
     if ($lislay =~ /ARRAY/ and @$lislay) {
         my %silay;
         map ($silay{$_} = 1,@$lislay);
	 impr_debug(__LINE__.' Glob %silay',\%silay);
         @lisobjs = grep (do{$silay{$laylista->[$_]}},@lisobjs);
     };
  };   
  @lisobjs = sort {$a<=>$b} @lisobjs;
  impr_debug(__LINE__.' Glob @lisobjs',\@lisobjs);
#  map (do {print STDERR __LINE__.' Desd',"$filelista->[$_] "},@lisobjs);
  foreach my $obj (@lisobjs) {
      my $cod = $codlista->[$obj];
      next unless $cod =~ /$reg/;
      if ($cod =~ /$codelemTs/) {push @liseleTs,$obj;
      } elsif ($cod =~/$codnodos/) {push @lisnodos,$obj;
      } elsif ($cod =~/$codramas/) {push @lisramas,$obj;
      } elsif ($cod eq 'O') {push @liscuadros,$obj;
      };				
  };
  @lisconects = (@liseleTs,@lisnodos);
  print STDERR "\n";
  impr_debug(__LINE__.' Glob @lisconects,@lisramas,@liscuadros',
	     [@lisconects,'||',@lisramas,'||',@liscuadros]);
  $formato = "%2s %3s %6s %4s %16s|%9s|%12s|%1s\n";
  $formatoramas = "%2s %4s %4s %4s %12s|";
  if (@lisconects) {
      print STDERR '='x80,' @lisconects',"\n";
      printf STDERR $formato,'#','','iden',' pcs','lugar(conect)   ','sheet','shape',
       'en menu_Dia';
      my $numfileant;;
      foreach my $ij (@lisconects) {
	  my ($numfilenuevo,$fileobj)  = @{$Simusol2Dia[$ij]};
	  if ($numfileant and $numfileant != $numfilenuevo) {
              print STDERR ' 'x38,"archivo $numfilenuevo $nombrefile->[$numfilenuevo]\n";
	      $numfileant = $numfilenuevo;
          };    
          my $cod = $codlista->[$ij];
          my $iden = $cod . $textolista->[$ij];
          my $sheet = $refglobal->{nombreplantilla}->[$plantillalista->[$ij]];
          my $shape = $refglobal->{nombreshape}->[$shapelista->[$ij]];    
          my $pcs = $plantillalista->[$ij]. 'c' .$shapelista->[$ij];
          my $lugar = $lugarlista->[$ij];
          my $identif = $refglobal->{nombre_menu_Dia}->{$pcs};
          defined $identif or $identif = '';
	  printf STDERR $formato,$ij,"$fileobj",$iden,$pcs,$lugar,$sheet,$shape,$identif;
      }
  };
  if (@lisramas) {
      print STDERR '='x80,' @lisramas',"\n";
      printf STDERR $formatoramas,'#' ,'','iden','pcs','lugar(ramas)';
      print STDERR "      puntos especiales o enganches\n";
      my $numfileant = -1;
      my $ij; 
     foreach $ij (@lisramas) { 
	  my ($numfilenuevo,$fileobj)  = @{$Simusol2Dia[$ij]};
	  if ($numfileant != $numfilenuevo) {
   print STDERR ' 'x38,  "archivo numfile viejo $numfileant nuevo $numfilenuevo \n";
	      $numfileant = $numfilenuevo;
          };    
          my $iden = $codlista->[$ij].$ij;
          my $pcs = $plantillalista->[$ij].'c'.$textolista->[$ij]; 
          my $lugar = $lugarlista->[$ij];
          printf STDERR $formatoramas, $ij,"$fileobj",$iden, $pcs, $lugar;
          if ($ref->{puntos_especiales}->{$ij}) {  
              print STDERR "  @{$ref->{puntos_especiales}->{$ij}}\n";
#	      if (@{$ref->{enganches}->{$ij}}) {
		  my @descr = descripcion_enganches_rama($ij);
#		  print STDERR Dumper \@descr;die;
                  map(do {print STDERR "$_\n"},@descr);
 #             };# else {
	      #    printf STDERR "%34s|%1s\n", '','no hay enganches';
	      #};	  
	  };    
      };	  
  };
  if (@liscuadros) {
      print STDERR '='x80,' liscuadros',"\n";
      printf STDERR "%3s %28s|%1s\n",'#','        (cuadros)','    lugar';  
      my $numfileant = -1;
      foreach my $ij (@liscuadros) {
	  my ($numfilenuevo,$fileobj)  = @{$Simusol2Dia[$ij]};
	  if ($numfileant != $numfilenuevo) {
              print STDERR ' 'x38,"archivo $numfilenuevo $nombrefile->[$numfilenuevo]\n";
	      $numfileant = $numfilenuevo;
          };    
	  my $lugar = $lugarlista->[$ij];
	  my $parte1 = $textolista->[$ij];my $parte2;
          if ($textolista->[$ij] =~ /^([^\n]+)\n(.+)$/) {
              ($parte1,$parte2) = ($1,$2);
	  };    
          printf STDERR "%3s %3s %-28s| %1s\n", $ij,"O$fileobj","Cuadro $parte1",$lugar;
	  $parte2 and printf STDERR "         %1s\n",$parte2;
      };
  };      
  if (not @lisobjs) {
      print STDERR '='x80,"\n";
      print STDERR "   No hay objetos en las condiciones pedidas\n";
  };
  print STDERR "$mens termina impr_objs\n";
  print STDERR '='x80,"\n";
  comfin('finG impr_objs,linea,$coderr');
  return '';
}#impr_objs  
# ---------------------------------------------------------------------------
sub impr_par{
  my ($mensaje,$tiparg,$refarg,$mostrar) = @_;
  (my $letras = $tiparg) =~ s/\W+//g;
  if ($refarg !~ /ARRAY/ or length ($letras) != @$refarg or $tiparg =~ /\w\w/) {
      print STDERR "impr_par $mensaje ERROR en el par tiparg refarg:\n"; 
      print STDERR '    Dumper $tiparg ',Dumper $tiparg;
      print STDERR '    Dumper $refarg ',Dumper $refarg;
      error_progr(__FILE__,__LINE__,$mensaje);
  };
  return unless $mostrar and $debug;
  my $tipargm = $tiparg;
  not $tiparg and $tipargm = 'vacio';
  printf STDERR "impr_par %26s||%20s","$mensaje   ", $tipargm;
#  printf "impr_par %26s||%20s","$mensaje   ", $tipargm;
  my $refargm = '';
  if (@$refarg) { 
      $refargm = join ' ',@$refarg;
  } else {
      $refargm = 'vacio';
  };
  print STDERR "   $refargm\n";print "   $refargm\n";
  # comfin('finG impr_par');
  return;
}#impr_par
# ---------------------------------------------------------------------------
sub impr_ramas{
  # solo se usa para depurar
  return unless $d;
  my ($mensaje,$numcapa) = @_; my $sinnada = '';
  my $refgraf = $refgrafers[$numcapa];
  print STDERR  " $mensaje empieza impr_ramas  capa $numcapa\n";
  foreach my $palabra ('resumen_eng','listaconect0','listaconect1','listaconect2',
     'listaconectmas','enganches') {
    impr_debug(' $refgraf{'.$palabra.'}',Dumper $refgraf->{$palabra});
  };    
  my @listakeys = sort grep(/^lisramas/ , keys %$refgraf);
  foreach my $key (@listakeys) {
      my @lista; my $marca ;
      next if $key eq 'lisramascrudas' and @listakeys > 1; 
      if ($key ne 'lisramaspar') {
          @lista = @{$refgraf->{$key}}; $marca = ' ';
      } else {
          my @listapares = @{$refgraf->{$key}};
          map (push(@lista, @$_), @listapares); 
          $marca ='p';
      };
      $refgraf->{$key} !~ /^ARRAY/ and next;
      if (@lista) {
          print STDERR scalar @lista, " ramas en $key\n";           
          foreach my $rama (@lista) {
	      my $codrama = $codlista->[$rama];
              foreach my $enganche (@{$refgraf->{enganches}->{$rama}}) {
                  my ($ramai, $handle, $lugar, $to,$connection) =
                  @$enganche{'rama','handle','lugar', 'to','connection'};
                  $to or next;
                  my $cod = $codlista->[$to]; my $texto = $textolista->[$to];
                  printf STDERR 
                  "Para rama  $marca%4i cod%2s: rama%4i, h%2i,%16s," . 
                                " objeto%4i, c%2i, %1s%1s\n",
                  $rama, $codrama, $ramai, $handle,
                  $lugar,$to,$connection,$cod,$texto; 
	     };
         };
      } else {
	  $sinnada .= " $key";
      };
  };
  print STDERR " Conjuntos sin ramas:
          $sinnada\n";
  print STDERR " $mensaje termina impr_ramas\n";
  return;
}#impr_ramas
# ---------------------------------------------------------------------------
sub impr_RESULTADOS{
   # impr( '   Glob impr_obj ',@$lislay,'sepa',@$lisobj);
   return unless $d;
   my ($mensaje, $ref) = @_;
   print STDERR " $mensaje empieza impr_RESULTADOS\n";
   impr_datos('', ['PEDIDOS','RESULTADOS'], $ref);
   impr_debug(' indicebueno', $ref->{indicebueno});
   impr_debug(' lisnum ',  Dumper $ref->{lisnum});
   impr_debug(' listalisnum ',  $ref->{listalisnum});
   impr_debug(' listasceptres ',$ref->{RESULTADOS}->{listasceptres});
   impr_debug(' lispropiasvars', @{$ref->{listaPEDIDOS}});
   impr_debug(' lismagnitudes', $ref->{lismagnitudes});
   impr_debug(' lisunidades', $ref->{lisunidades});
   print STDERR " $mensaje termina impr_RESULTADOS\n";
}#impr_resultados
# ---------------------------------------------------------------------------
sub impr_TABLAS{
  return unless $d;
  my ($mensaje,$ref) = @_;
  print STDERR " $mensaje  empieza impresion interna de TABLAS\n";
  my @posibles = sort keys %{$ref->{REFLISTAVALOR}};
  @posibles = grep(do {$_ =~ /^(\w+)_/  and $ref->{TIPOTABLAS}->{$1}},@posibles);
  foreach my $nombre (@posibles) {
      impr_debug(" ,$nombre: ",$ref->{REFLISTAVALOR}->{$nombre});
  };
  print STDERR " $mensaje termina impresion interna de TABLAS\n";
  return;  	 
	


    
    my @listablas = keys %hash_TABLAS_definidas;
    print STDERR "com impr_TABLAS     $mensaje\n";
    foreach my $idtabla (@listablas) {
	my $archivo = $ref->{archivoTABLAS}->{$idtabla};
	my ($BASEARCH,$PROPIO,$CORTO);
        if (defined $archivo) {
	    ($BASEARCH,$PROPIO,$CORTO) = relativizar($archivo,$ref->{BASEARCH});
        };
        print STDERR "---------------    tabla $idtabla", 
        "    definida en $ref->{defiTABLAS}->{$idtabla}->{archivo}\n";
        print STDERR "     del archivo $CORTO\n"
            if defined $ref->{archivoTABLAS}->{$idtabla};
        my @lista; my $reflista = $ref->{textodefiTABLAS}->{$idtabla};
        if (defined $reflista) {
              print STDERR '        modificadores: '
                  , join ("\n            ",@$reflista)
                  ,"\n        ----------\n";
        }; 
        print STDERR 'cuantas abscisas: ',
                     scalar @{$ref->{absTABLAS}->{$idtabla}},
                     '    ordenadas: ',
                     scalar @{$ref->{ordTABLAS}->{$idtabla}},"\n";
        print STDERR 'primera ',"@{$ref->{priTABLAS}->{$idtabla}}; " .
                       $ref->{absTABLAS}->{$idtabla}->
                          [$ref->{priTABLAS}->{$idtabla}->[0]],"\n";
        print STDERR 'ultima ', "@{$ref->{ultTABLAS}->{$idtabla}}; " .
                       $ref->{absTABLAS}->{$idtabla}->
                         [$ref->{ultTABLAS}->{$idtabla}->[-1]],"\n";
    };
    print STDERR "---------- fin impr_TABLAS $mensaje\n";
}# impr_TABLAS
# ---------------------------------------------------------------------------
sub impr_unionesobj{
   comfin('comfin impr_unionesobj',@_);
   my ($mensaje,$reflay) = @_;
   return unless $d;
   my $refun = $reflay->{unionesobj};
   not defined $refun and do{print STDERR "$mensaje : no hay nada"; return};
   foreach my $obj(sort keys %$refun) {
       my $tira;
       $tira =  "@{$refun->{$obj}}"; 
       printf STDERR "%4i %20s %7s  %1s\n", $obj, $lugarlista->[$obj], 
              "$codlista->[$obj]$textolista->[$obj]", $tira;
   };
}#impr_unionesobj    
# ---------------------------------------------------------------------------
sub iniciar_refglobal{
  comfin('comG iniciar_refglobal',@_);
  $refglobal->{TIPOTOK}->{TIEMPO} = 'S'; $refglobal->{TIPOTOK}->{TIME} = 'S';
  foreach my $func (@aceptables) {
      $refglobal->{TIPOTOK}->{uc($func)} = 'f';
  };
  $refglobal->{TIPOTOK}->{QPRODUCTO}=$refglobal->{TIPOTOK}->{QPRODUCTO} = 'g';
  #en globales.dat queda definido valor inicial de $refglobal->{equivalente}
  foreach my $fu (keys %{$refglobal->{equivalente}}) {
      $refglobal->{TIPOTOK}->{$fu} = 'h';
  };    
  impr_debug(__LINE__.' Glob $refglobal->{TIPOTOK}',Dumper $refglobal->{TIPOTOK});
  comfin('finG iniciar_refglobal');
  return;
}#iniciar_refglobal;
# ---------------------------------------------------------------------------


sub impr_datosV{
  # sólo se usa para depurar
  return unless $d;
  my ($ident, $lisque, $ref, $nombre) = (@_,'');
  return unless $ref ne ''; 
  $nombre or $nombre = $ref->{nombrecirc};
  defined $nombre or $nombre = $ref->{CORTOELE};
  defined $nombre or $nombre = $ref->{CORTO};
  defined $nombre or $nombre = 'sin nombre';
  print STDERR "    empieza impr_datos. @$lisque\n    ($ident) 
                     para $nombre ",'=' x 15,"\n"; 
  my ($para,$resu,$funci);
  foreach my $que (@$lisque) { 
      my @lista = ();
      @lista = keys %{$ref->{"TIP$que"}} if defined $ref->{"TIP$que"};
      @lista = keys %{$ref->{$que}} if defined $ref->{$que} and not @lista;
      @lista or next;
      my $otro;
      $que eq 'DATOS' and $otro = 'uni'
	  or $que eq 'PARAMETROS' and $otro = 'USAPAR';

      print STDERR
        "  =>(TIP$que|TIPARG$que|     $que             |............)\n";
      foreach (sort @lista) {
          my $dato = $ref->{$que}->{$_};
	  $dato = 'no definido' unless defined $dato;
          my $largo = length($dato); 
          my $sobra = $largo -24;my $dato2='';
          $sobra >0 and $dato2 = substr($dato,24,$largo);
          $largo < 55 and $largo = 24;
          $dato = substr($dato . ' ' x 50,0,$largo);
          my $tipdato = ($ref->{"TIP$que"}->{$_} or '');
          my $tipargdato = ($ref->{"TIPARG$que"}->{$_} or '');
          my $elotro  = '';
          defined $otro and defined $ref->{$otro} 
              and defined $ref->{$otro}->{$_}
              and $elotro = $ref->{$otro}->{$_};
	  defined $ref->{"REFARG$que"}->{$_} 
             and $elotro = "REFARG $ref->{'REFARG'.$que}->{$_}"
          or  $elotro = "REFARG no hay" ; 
          printf STDERR "%10s=>%1s|%6s|%24s|%2s\n" 
                 ,$_, $tipdato, $tipargdato, 
              $dato ,$elotro;
          $sobra >0 and printf STDERR "%10s=>%1s|%6s|%24s|%2s\n"
	      ,'','','',$dato2,'';
      };
      my $texto ='';
      if ($que eq 'PARAMETROS' and @lista) {
          $texto .= '   Glob parametroscreados: '.
                   join (' ', keys %{$ref->{parametroscreados}})."\n"
            if defined $ref->{parametroscreados};
          $texto .= '   Glob parametrossustituidos; '.
                   join (' ', keys %{$ref->{parametrossustituidos}})."\n"
            if defined $ref->{parametrossustituidos};
          $texto .= hashrenglon('   Glob valuespar: ', %{$ref->{valuespar}})
            if defined $ref->{valuespar};
          $texto .= '   Glob parámetros usados: '.
        	    join (' ', keys %{$ref->{USAPAR}})."\n"
           if defined $ref->{USAPAR} and scalar  %{$ref->{USAPAR}}; 
      } elsif ($que eq 'RESULTADOS' or $que eq 'temp') {
          $texto .= hashrenglon('   Glob TEMP ', %{$ref->{TEMP}});
          $texto .= hashrenglon('   Glob temp ', %{$ref->{temp}});
          $texto .= 'listapedidos ' . "@{$ref->{listapedidos}}\n" 
	      if $ref->{listapedidos};
      } elsif ($que eq 'FUNCIONES' and @lista) {
	  $texto .= hashrenglon('   Glob USAFUN',%{$ref->{USAFUN}});
	  $texto .= hashrenglon('   Glob FUNUSAFUN',%{$ref->{FUNUSAFUN}});
      }
      print STDERR $texto;
  }; # #que
  print STDERR  "impr_datos @$lisque, ($ident termina)
                     para $nombre ",'=' x 15,"\n  ",'=' x 60,"\n";  
}#impr_datos
# ---------------------------------------------------------------------------
sub impr_ramasV{
  # sólo se usa para depurar
  return unless $d;
  my ($mensaje,$reflay) = @_; my $sinnada = ''; 
  print STDERR 
 "   Glob impr_ramas $mensaje; 
                 $reflay->{refcirc}->{archivo};capa $reflay->{capa}\n";
  my @listakeys = sort grep(/^lisramas/ , keys %$reflay);
  foreach my $key (@listakeys) {
      my @lista; my $marca ;
      next if $key eq 'lisramascrudas' and @listakeys > 1; 
      if ($key ne 'lisramaspar') {
          @lista = @{$reflay->{$key}}; $marca = ' ';
      } else {
          my @listapares = @{$reflay->{$key}};
          map (push(@lista, @$_), @listapares); 
          $marca ='p';
      };
      $reflay->{$key} !~ /^ARRAY/ and next;
      if (@lista) {
          print STDERR scalar @lista, " ramas en $key\n";           
          foreach my $rama (@lista) {
	      my $codrama = $codlista->[$rama];
              foreach my $enganche (@{$reflay->{conexiones}->{$rama}}) {
                  my ($ramai, $handle, $lugar, $to,$connection) =
                  @$enganche{'rama','handle','lugar', 'to','connection',};
                  defined $to or next;
                  my $cod = $codlista->[$to]; my $texto = $textolista->[$to];
                  printf STDERR 
                  "Para rama  $marca%4i cod%2s: rama%4i, h%2i,%16s," . 
                                " objeto%4i, c%2i, %1s%1s\n",
                  $rama, $codrama, $ramai, $handle,
                  $lugar,$to,$connection,$cod,$texto; 
	     };
         };
      } else {
	  $sinnada .= " $key";
      };
  };
  print STDERR " Conjuntos sin ramas:
          $sinnada\n";
  return;
}
# ---------------------------------------------------------------------------
sub impr_unionesobjV{
   comfin('comfin impr_unionesobj',@_);
   my ($mensaje,$reflay) = @_;
   return unless $d;
   my $refun = $reflay->{unionesobj};
   not defined $refun and do{print STDERR "$mensaje : no hay nada"; return};
   foreach my $obj(sort keys %$refun) {
       my $tira;
       $tira =  "@{$refun->{$obj}}"; 
       printf STDERR "%4i %20s %7s  %1s\n", $obj, $lugarlista->[$obj], 
              "$codlista->[$obj]$textolista->[$obj]", $tira;
   };
}    
# ---------------------------------------------------------------------------
sub impr_objV{ 
  # datos de objetos cuyo numero esta en la lista y cumplen r.e.   
  # sólo se usa para depurar
  return unless $d;
  my ($mens,$reg,$lislay,$lisobj) = @_;
  # $mens mensaje; $reg expresión regular de cod. de objetos
  # $lislay ref. a lista de num. de layers
  # $lisobj ref. a lista de num. deobjetos; sera seleccionada bajo $reg  
  # $refcirc referencia a circuito con la informacion
  defined $reg or $reg = '[RLCEJTt]';
  defined $lislay or $lislay = [0 .. scalar @reflayer -1];
  defined $lisobj or $lisobj = [0 .. (scalar @$codlista -1)];
  print STDERR "   Glob com. impr_obj: $mens" ,'=' x 15,"\n";
  my ($uni,$DATOS,$INICIALES) = ('','','');
  foreach my $il (@$lislay) {
      if ($il > @$laylista -1) {
          print STDERR "capa $il inexistente\n";
	  next
      } else {
          my $reflay = $reflayer[$il];
	  my $refcirc = $reflayer[$il]->{refcirc};
          print STDERR "...........", descripcion_capa($il)
                  ," expr_reg  $reg \n";
          defined $reflay and
          do {$uni = $refcirc->{uni}; 
              $DATOS = $refcirc->{DATOS}; 
              $INICIALES = $refcirc->{INICIALES};
          };	
          my @lisobjsel = grep(
	          do{ ($codlista->[$_] =~ /$reg/) and $laylista->[$_] == $il}
	                     , @$lisobj);
         if (@lisobjsel) { 
                printf STDERR "%3s %13s %4s %7s %3s %15s %8s %20s\n" 
       ,'#', 'nombre   ' , 'iden','placsha','c.v','lugar       ','uni','datos';
	 } else {
             print STDERR "   No hay objetos de esa clase $reg\n";
             my @lisobjcod = grep ($codlista->[$_] =~ /$reg/,@$lisobj);
             my @lisobjlay = grep ($laylista->[$_] == $il,@$lisobj);
         };
          foreach my $ij (@lisobjsel) {
              my $iden = $codlista->[$ij] . $textolista->[$ij]; 
              my $plantillacshape = 
        	    $plantillalista->[$ij]. 'c' .$shapelista->[$ij];
              my $identif = $comonombre->{$plantillacshape};
	      defined $identif or $identif
                  = $nombreshape->[$shapelista->[$ij]];
              printf STDERR "%3s %13s %5s %6s %3s %15s"
                ,$ij, substr($identif . '.' x 9,0,10) . '...'
	        , substr($iden,0,6), $plantillacshape
	                , $codvalorlista->[$ij], $lugarlista->[$ij]; 
              my ($unisiden,$datosiden,$inicialesiden);
              $uni  and do{$unisiden = $uni->{$iden}}; 
	      $DATOS and do{$datosiden = $DATOS->{$iden}};
              $INICIALES and do{$inicialesiden = $INICIALES->{'V' . $iden}};
              defined $unisiden or $unisiden = 'nodef';
              defined $datosiden or
	      do {$datosiden = 'nodef';
	      };
              defined $inicialesiden or $inicialesiden = '---';
              printf STDERR"%6s %20s %6s\n"
                      , $unisiden,$datosiden,$inicialesiden; 
          };#foreach $ij
      }; #else; sí hay capa
  };#for $il
  print STDERR "\n",'=' x 15, "\n";
  #imprhash('temp ',%{$refcirc->{temp}});		   
}; #impr_obj
# ---------------------------------------------------------------------------
sub impr_resultadosV{
   # impr( '   Glob impr_obj ',@$lislay,'sepa',@$lisobj);
   return unless $d;
   my ($mensaje, $ref) = @_;
   print STDERR '   Glob impr_resultados',"\n";
   impr_datos($mensaje, ['RESULTADOS','TALCUALRESULTADOS','temp'], $ref);
   impr_debug ("$mensaje indicebueno", $ref->{indicebueno});
   impr_debug($mensaje. ' lisnum ',  Dumper $ref->{lisnum});
   impr_debug($mensaje. ' listalisnum ',  $ref->{listalisnum});
   impr_debug($mensaje. ' lisoutputussceptre ',$ref->{lisoutputssceptre});
   impr_debug($mensaje. ' lispropiasvars', $ref->{lispropiasvars});
   impr_debug($mensaje. ' lismagnitudes', $ref->{lismagnitudes});
   impr_debug($mensaje. ' lisunidades', $ref->{lisunidades});
   impr_debug($mensaje. ' lisresultadosmalos', $ref->{lisresultadosmalos});
   impr_debug($mensaje. ' lisrepetidos', $ref->{lisrepetidos});
}
# ---------------------------------------------------------------------------
# ---------------------------------------------------------------------------
sub impr_TABLASV{ # PUESTO POR ASUS, no usado en paraplot
  return unless $d;
  my ($mensaje,$ref) = @_;
  print STDERR " $mensaje  empieza impresion interna de TABLAS\n";
  my @posibles = sort keys %{$ref->{REFLISTAVALOR}};
  @posibles = grep(do {$_ =~ /^(\w+)_/  and $ref->{TIPOTABLAS}->{$1}},@posibles);
  foreach my $nombre (@posibles) {
      impr_debug(" ,$nombre: ",$ref->{REFLISTAVALOR}->{$nombre});
  };
  print STDERR " $mensaje termina impresion interna de TABLAS\n";
  return;  	 
	


    
    my @listablas = keys %hash_TABLAS_definidas;
    print STDERR "com impr_TABLAS     $mensaje\n";
    foreach my $idtabla (@listablas) {
	my $archivo = $ref->{archivoTABLAS}->{$idtabla};
	my ($BASEARCH,$PROPIO,$CORTO);
        if (defined $archivo) {
	    ($BASEARCH,$PROPIO,$CORTO) = relativizar($archivo,$ref->{BASEARCH});
        };
        print STDERR "---------------    tabla $idtabla", 
        "    definida en $ref->{defiTABLAS}->{$idtabla}->{archivo}\n";
        print STDERR "     del archivo $CORTO\n"
            if defined $ref->{archivoTABLAS}->{$idtabla};
        my @lista; my $reflista = $ref->{textodefiTABLAS}->{$idtabla};
        if (defined $reflista) {
              print STDERR '        modificadores: '
                  , join ("\n            ",@$reflista)
                  ,"\n        ----------\n";
        }; 
        print STDERR 'cuantas abscisas: ',
                     scalar @{$ref->{absTABLAS}->{$idtabla}},
                     '    ordenadas: ',
                     scalar @{$ref->{ordTABLAS}->{$idtabla}},"\n";
        print STDERR 'primera ',"@{$ref->{priTABLAS}->{$idtabla}}; " .
                       $ref->{absTABLAS}->{$idtabla}->
                          [$ref->{priTABLAS}->{$idtabla}->[0]],"\n";
        print STDERR 'ultima ', "@{$ref->{ultTABLAS}->{$idtabla}}; " .
                       $ref->{absTABLAS}->{$idtabla}->
                         [$ref->{ultTABLAS}->{$idtabla}->[-1]],"\n";
    };
    print STDERR "---------- fin impr_TABLAS $mensaje\n";
}# impr_TABLAS



sub impr_tablas_VIEJOANTESDEASUS{
    return unless $d;
    my ($mensaje,$ref) = @_;
    my @listablas = sort keys %hash_TABLAS_definidas;
    impr_debug(__LINE__.' Glob LOLITA @listablas',\@listablas);
    print STDERR "com impr_tablas     $mensaje @listablas\n";
    foreach my $idtabla (@listablas) {
        print STDERR "---------------    tabla $idtabla", 
        "    definida en $ref->{defiTABLAS}->{$idtabla}->{archivo}\n";
        print STDERR "     del archivo $ref->{archivoTABLAS}->{$idtabla}\n"
            if defined $ref->{archivoTABLAS}->{$idtabla};
        my @lista; my $reflista = $ref->{textodefiTABLAS}->{$idtabla};
        if (defined $reflista) {
              print STDERR '        modificadores: '
                  , join ("\n            ",@$reflista)
                  ,"\n        ----------\n";
        }; 
        print STDERR 'cuantas abscisas: ',
                     scalar @{$ref->{absTABLAS}->{$idtabla}},
                     '    ordenadas: ',
                     scalar @{$ref->{ordTABLAS}->{$idtabla}},"\n";
        print STDERR 'primera ',"@{$ref->{priTABLAS}->{$idtabla}}; " .
                       $ref->{absTABLAS}->{$idtabla}->
                          [$ref->{priTABLAS}->{$idtabla}->[0]],"\n";
        print STDERR 'ultima ', "@{$ref->{ultTABLAS}->{$idtabla}}; " .
                       $ref->{absTABLAS}->{$idtabla}->
                         [$ref->{ultTABLAS}->{$idtabla}->[-1]],"\n";
    };
    print STDERR "---------- fin impr_tablas $mensaje\n";
}# impr_tablas
# ---------------------------------------------------------------------------
sub impr_enganchesV{
  comfin('com impr_enganches', @_);
  return unless $d;
  # imprime los enganches de la rama dada por su numero de objeto
  # y los identificadores de los objetos enganchados
  return unless $d;
  my ($mensaje,$rama) = @_;
  my $reflay = $reflayer[$laylista->[$rama]];
  my @lista = @{$reflay->{conexiones}->{$rama}};
  #@lista = grep($_->{rama} == $rama, @lista); 
  #impr_debug($mensaje," Enganches rama $rama"); 
  foreach my $enganche (@lista) {
      my ($rama, $handle,$lugar, $to,$connection) =
          @$enganche{'rama','handle','lugar', 'to','connection'};
      if ($lugar =~ /HASH/) {$lugar = $lugar->{val}};
      my $cod = $codlista->[$to]; my $texto = $textolista->[$to];
      printf STDERR "rama%4i, h%2i,  %20s, objeto%4i, c%2i, %1s%1s\n",
      $rama, $handle,$lugar,$to,$connection,$cod,$texto; 
  };
  comfin('fin impr_enganches', @_);
} # impr_enganches
# ---------------------------------------------------------------------------
# ---------------------------------------------------------------------------
sub controlar_our{# se usa sin argumentos
  #solo se esta usando desde este modulo; pero esta disponible para todos
  #modificada para .....
  #solo para depurar
  my @listaori;
  map (do{push @listaori, scalar@$_},
         ($laylista, $plantillalista , $shapelista, $codlista,
          $codvalorlista, $textolista, $lugarlista,$filelista));
  my @lista = union_conjunto (@listaori);
  if (@lista > 1) {
      print STDERR "Los 8 largos deben ser todos iguales\n";
      map (do{print STDERR ( '' . scalar @$_ ,"\n")},
         ($laylista, $plantillalista , $shapelista, $codlista,
          $codvalorlista, $textolista, $lugarlista,$filelista));
      error_progr(__FILE__,__LINE__,' Hay diferencias');
  };    
}
# ---------------------------------------------------------------------------
sub cajear_capa{
  comfin('comG cajear_capa',@_); 
  my ($reflay) = @_;
  my $nombre = $nombrelay->[$reflay->{ilayer}];
  my $PROPIOSIN = $reflay->{PROPIOSIN};
  my $CORTOSIN = $reflay->{CORTOSIN};
  open CAJ, ">>$CORTOSIN.caj";
  print CAJ "# capa ", $nombre,"\n";
  foreach my $key (keys %{$reflay->{refvalores}}) {
     foreach my $num (keys %{$reflay->{refvalores}->{$key}}) {
          print CAJ ' 'x10, "Cuadro $key\n";
          print CAJ join ("\n",@{$reflay->{refvalores}->{$key}->{$num}}),"\n";
      };
  };
  close CAJ;
  comfin('finG cajear_capa'); 
}
# ---------------------------------------------------------------------------
sub para_sceptre_num{
#  comfin('comG para_sceptre_num', @_);
  my $valor = $_[0];
  $valor = sprintf("%6G", $valor);$valor =~ s/^\s*//;
  if ($valor =~ /E/ and $valor !~ /\./) { 
      $valor =~ s/E/.E/;
  };
  comfin('finG para_sceptre_num', $valor);
  return $valor;
}#para_sceptre_num     
# ---------------------------------------------------------------------------

my $CORTOA;
sub porparar1MAL{
  # lo usan subrutinas llamadas por simusol1.pl, relativas a 
  # definicion de formulas o modelos para asignar errores a archivos
  # luego se debe abandonar el tratamiento del archivo correspondiente
  # y pone en 0 el cont. de err. graves 
  comfin('comG porparar1',@_);
  my ($coderr, $ref, $mensaje) = @_;
  if ($mensaje) {
      if ($coderr >2) {avgrav($mensaje)} else { explic($mensaje)};
  }
  $reffi{$CORTOA}->{errorparar} = $coderr;
  if ($coderr eq 0) {
     system "rm $CORTOASIN.lss1 2>/dev/null";
  };    
  #$avisosgrav = 1 if  ($avisosgrav == 0 and $coderr >2);
  # al final lo lleva a 0
  #impr_debug(__LINE__.' Glob $ref,  argumento de porparar ', $ref); 
  if ($ref eq '0') {
      $ref = $reffi{$CORTOA};
      defined $ref or error_progr(__FILE__,__LINE__.' no definido $reffi{$CORTOA}');   
  };
  if ($ref ne '0') {
      my $refcirc = $ref->{refcirc};
      defined $refcirc and # era una capa asignada a un circuito
         $ref = $refcirc; 
  }; 
  #defined $CORTO or 
  #do {$CORTO = $ref->{CORTO};
  #    $CORTOSIN = $ref->{CORTOSIN}
  #};
  #impr_debug(__LINE__.' Glob $ref', $ref);
  $ref->{errores} += $avisosgrav;
  $avisosgrav = 0;
  comfin('finG  porparar1');
  #return $coderr;
} #porparar1

# ---------------------------------------------------------------------------
sub tiparg_2_tipo{
  comfin('comG tiparg_2_tipo',@_);
  my $tiparg = $_[0];my $tipo = '';
  my @listatiparg = split '',$tiparg;
  impr_debug(__LINE__.' Glob',\@listatiparg);
  if (@listatiparg == 1) {
      $tipo = $listatiparg[0];
  } elsif (@listatiparg == 2) {
      $listatiparg[1] eq 'n' and $tipo = 'n' or $tipo = 'x';
  } elsif ($tiparg =~ /^(\w)\(.+\)$/) {
      $tipo = $1;
  } elsif ($tiparg !~ /,/) {
      $tipo = 'x';
  } else {
      my ($coderr,@listaagrup) = juntar_por_paren('',split(',',$tiparg));
      @listaagrup > 1 and $tipo = ',' or $tipo = 'x';
  };
  comfin('finG tiparg_2_tipo',$tipo);
  return $tipo;
}#tiparg_2_tipo;
# ---------------------------------------------------------------------------
sub tiparg_refarg_2_valor{#devuelve $valor
  comfin('comG tiparg_refarg_2_valor',@_);
  my ($tiparg,$refarg) = @_;
  $tiparg =~ s/^(\W*)//; my @refarg = @$refarg; my $valor = $1;
  while ($tiparg =~ s/^(\w)(\W*)//) {
      my $token = shift @refarg; $valor .= $token . $2;
   };
  comfin('finG tiparg_refarg_2_valor',$valor);
  return $valor;
}#tiparg_refarg_2_valor  
# ---------------------------------------------------------------------------
sub error_progr{
   my ($file,$line,$mensaje) = @_; #los tres necesarios
   $d and $d = '';
   my $refarch = $reffi{$ref1->{corto}->[$ref1->{NUMARCH}]};
   mensajear(" Error de programacion en $line de $file: $mensaje");
   impr_datos( '', ['todosque'], $refarch) if  $ref1 and $refarch and not $noverb;
   parar1(200,0);
}#error_progr
# ---------------------------------------------------------------------------
sub valor{
 # comfin('comG valor',@_);
  my ($ref,$aspecto,$cosa) = @_;
  if (@_ != 3) {
      die "valor no tiene tres argumentos
          @_"
  };
  $cosa or return '';
  my $posivalor;
#  impr_debug(__LINE__.' Glob'." $aspecto",$ref->{$aspecto}); 
#  impr_debug(__LINE__.' Glob'." $aspecto $cosa",$ref->{$aspecto}->{$cosa}) 
#    if defined $ref->{$aspecto}; 
#  impr_debug(__LINE__.' Glob'." $aspecto",$refglobal->{$aspecto}); 
#  impr_debug(__LINE__.' Glob'." $aspecto $cosa"
#    ,$refglobal->{$aspecto}->{$cosa}) if defined $refglobal->{$aspecto}; 
  if ($ref and $ref->{$aspecto} and defined $ref->{$aspecto}->{$cosa}) {
      $posivalor = $ref->{$aspecto}->{$cosa};    
  } elsif ($refglobal->{$aspecto} and
            defined $refglobal->{$aspecto}->{$cosa}) {
      $posivalor = $refglobal->{$aspecto}->{$cosa};
  };
  if (not defined $posivalor) { 
      if ($aspecto =~ /^(REFARG|USA|listaargFUNCION|listacom)$/) {
          $posivalor = [];
      } else {
          $posivalor = '';
      };
  };
 # comfin('finG valor',$posivalor);
  return $posivalor; 
}#valor
# ---------------------------------------------------------------------------

# ---------------------------------------------------------------------------
sub controlar_ourV{# se usa sin argumentos
   #solo se esta usando desde este modulo; pero esta disponible para todos
   #modificada para .....
   #sólo para depurar
   print STDERR "Los 7 largos deben ser todos iguales  ";
   map (do{print STDERR ( ' ' . scalar @$_ ,' ')},
          ($laylista, $plantillalista , $shapelista, $codlista,
	   $codvalorlista, $textolista, $lugarlista));
   print STDERR "\n";
   foreach my $cosa ($laylista, $plantillalista , $shapelista, $codlista,
		     $codvalorlista, $textolista, $lugarlista) {
       foreach (@$cosa) {
           print " $_";
           $cosa eq $textolista and print "\n"; 
       };
       print "\n";
   };
}
# ---------------------------------------------------------------------------
sub cajear_capaV{
  comfin('com cajear_capa',@_); 
  my ($reflay) = @_;
  my $nombre = $nombrelay->[$reflay->{ilayer}];
  my $PROPIOSINDIA = $reflay->{PROPIOSINDIA};
  my $CORTOSINDIA = $reflay->{CORTOSINDIA};
  open CAJ, ">>$CORTOSINDIA.caj";
  print CAJ "# capa ", $nombre,"\n";
  foreach my $key (keys %{$reflay->{refvalores}}) {
     foreach my $num (keys %{$reflay->{refvalores}->{$key}}) {
          print CAJ ' 'x10, "Cuadro $key\n";
          print CAJ join ("\n",@{$reflay->{refvalores}->{$key}->{$num}}),"\n";
      };
  };
  close CAJ;
  comfin('fin cajear_capa'); 
}
# ---------------------------------------------------------------------------
sub porparar1V{
  # lo usan subrutinas llamadas por simusol1.pl, relativas a 
  # definicion de formulas o modelos para asignar errores a archivos
  # luego se debe abandonar el tratamiento del archivo correspondiente
    # y pone en 0 el cont. de err. graves


    
  comfin('com porparar1',@_);
  my ($coderr, $ref, $mensaje) = @_;
  if ($mensaje) {
      if ($coderr >2) {avgrav($mensaje)} else { explic($mensaje)};
  }
  $reffi{$CORTOA}->{errorparar} = $coderr;
  if ($coderr eq 0) {
     system "rm $CORTOASINDIA.lss1 2>/dev/null";
  };    
  #$avisosgrav = 1 if  ($avisosgrav == 0 and $coderr >2);
  # al final lo lleva a 0
  #impr_debug(__LINE__.' Glob $ref,  argumento de porparar ', $ref); 
  if ($ref eq '0') {
      $ref = $reffi{$CORTOA};
      defined $ref or error_progr(0,__LINE__.' Glob');   
  };
  if ($ref ne '0') {
      my $refcirc = $ref->{refcirc};
      defined $refcirc and # era una capa asignada a un circuito
         $ref = $refcirc; 
  }; 
  #defined $CORTO or 
  #do {$CORTO = $ref->{CORTO};
  #    $CORTOSINDIA = $ref->{CORTOSINDIA}
  #};
  #impr_debug(__LINE__.' Glob $ref', $ref);
  $ref->{errores} += $avisosgrav;
  $avisosgrav = 0;
  comfin('fin  porparar1');
  #return $coderr;
} #porparar1


# ---------------------------------------------------------------------------
1
